#! /bin/sh

# %Z%$RCSfile: cman.sh,v $    GIPS $Revision: 2.14 $ (MIT/CSR) $Date: 1993/10/13 23:51:12 $
#
#           General Image Processing program
#               Peter G. Ford
#              Center for Space Research
#    Copyright 1984 Massachusetts Institute of Technology
#
#    Module:        cman.sh        Creation Date:    12/29/83
#    Version:    $Revision: 2.14 $        Update:        $Date: 1993/10/13 23:51:12 $
#    Function:    Provide information on GIPS commands
#

file1="##FILE1##"
file3="##FILE3##"

cd ${GIPSDIR-/usr/gips}/man
doc=${GIPSDIR-/usr/gips}/doc
docs="gips gipstut gipstool.wc"
f= k= l= o= v=
grind="${GRIND-##GRIND##} -lc -f"
tpr="${CAT-##CAT##} -rC1 -rD1"
npr="/usr/bin/nroff -e -rC1 -rD1"
nfi="|/usr/bin/col|/usr/ucb/more"

if [ $# -eq 0 -o "x$*" = "x-f" ]
    then sort whatis | more ; exit
fi

for i
do
    if [ $k ]
        then key="${key+$key|}$i"
    else case $i in
        =)    exec echo "Usage: cman [-fkltv] [name ...]" >&2 ;;
        -f)   f=f ;;
        -k)   k=k ;;
        -l)   l=l ;;
        -t)   v=v ;;
        -v)   v=v ;;
        1)    if [ $f ]
                  then key="${key+$key|}(1.*)"
                  else file="${file-}${file1} "
              fi ;;
        3)    if [ $f ]
                  then key="${key+$key|}(3.*)"
                  else file="${file-}${file3} "
              fi ;;
        gips|tutor*|GIPS|TUTOR*)
            case $i in
                gips|GIPS)      i=gips ;;
                tutor*|TUTOR*)  i=gipstut ;;
            esac
            case x$f$k$l$v in
                xf) echo "cman: no -f entry for $i" >&2
                    exit 1 ;;
                xl) file="${file-}$doc/$i " ;;
                xv) tbl $doc/$i | eqn | $tpr -ms -J GipsDoc
                    exit ;;
                x)  eval "tbl $doc/$i | eqn | $npr -ms $nfi"
                    exit ;;
                *)  break ;;
            esac ;;
        intro|INTRO)
            case x$f$k$l$v in
                xf) echo "cman: no -f entry for $i" >&2
                    exit 1 ;;
                xl) file="${file-}$doc/$docs " ;;
                xv) o=o ;;
                x)  eval "tbl $doc/gips | neqn | $grind | $npr -ms $nfi"
                    eval "tbl $doc/gipstut | neqn | $npr -ms $nfi"
                    eval "$npr -me $doc/gipstool.wc $nfi" ;;
                *)  break ;;
            esac ;;
        *)  if [ $f ]
                then key="${key+$key|}^$i |\\[$i\("
            elif [ -r man1/$i -o -r man3/$i ]
                then eval i="man?/$i"
            elif [ -r man1/$i.1 -o -r man3/$i.3 ]
                then eval i="man?/$i.?"
                else exec echo "cman: $i not found" >&2
            fi
            file="${file-}$i " ;;
    esac
    fi
done

case x$f$k$l$v$o in
    xl)    eval ls ${file-"$file1 $file3"} ; exit ;;
    xf|xk) cat whatis | egrep "${key?missing keyword(s)}" | sort | more
           exit ;;
    xvo)   if [ ! "${file-}" ] ; then
               tbl $doc/gips | eqn | $grind | $tpr -ms -J GipsDoc
               tbl $doc/gipstut | eqn | $tpr -ms -J GipsTut
               $tpr -me -J GipstoolWC $doc/gipstool.wc
               exit
           fi ;;
    xv)    if [ "${file-}" ] ; then
               eval "$tpr -man -J GipsMan $file" ; exit
           fi ;;
    x)     x=${file-"$file1 $file3"} ; eval "$npr -man $x $nfi" ; exit ;;
    *)     echo "cman: conflicting options: -$f$k$l$v" >&2
           exit 1 ;;
esac

tbl $doc/gips | eqn | $grind | $tpr -ms -J GipsDoc
tbl $doc/gipstut | eqn | $tpr -ms -J GipsTut
$tpr -me -J GipstoolWC $doc/gipstool.wc
$tpr -J GipsPtx $doc/gips.ptx
eval $tpr -J GipsMan -man ${file-"$file1 $file3"}
