#ifndef lint
static char *sccsid = "%Z%$RCSfile: gin.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1998/05/13 01:01:40 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		gin.c		Creation Date:	12/29/83
**	Version:	$Revision: 2.2 $		Update:		$Date: 1998/05/13 01:01:40 $
**	Function:	Generate test General Image
**	Components:	main()		GIPS/UNIX command
*/

#include	<stdio.h>
#include	"gips.h"
#include	<signal.h>

static	 int	xnum	= 8;
static	 int	ynum	= 8;
static	 char	dscale	= 's';
static	 char	dtype	= 'b';
static	 char	*mfile	= "-";

static flagentry flagtable[] = {
	"x",	"%d num",	(flag *) &xnum,
	"y",	"%d num",	(flag *) &ynum,
	"s",	"%c dscale",	(flag *) &dscale,
	"t",	"%c dtype",	(flag *) &dtype,
	"m",	"-> file",	(flag *) &mfile,
	NULL
};

main(argc,argv)

	int	argc;
	char	**argv;
{
	register FILE	*fp;
	FILE		*fm;
	register int	y, n;
	double		dmin	= 0;
	double		dmax	= 256;
	double		xmax;
	double		ymax;
	int		dlen;
	int		outcvt;
	int		*ibuf;
	char		*dbuf;

	saveargs(argv);
	argc = gipsflags(argc,argv,flagtable);
	if (argc > 1)
		error("bad argument: %s",*++argv);

	if ((fp = ihread(GINPROFILE,GIPSPROFILE)) == NULL)
		gipserr();
	else
		(void)(ihbcl(fp));
	(void)(ihput("xnum",(char *)&xnum));
	(void)(ihput("xmin",(char *)&dmin));
	xmax = xnum;
	(void)(ihput("xmax",(char *)&xmax));
	(void)(ihput("ynum",(char *)&ynum));
	(void)(ihput("ymin",(char *)&dmin));
	ymax = ynum;
	(void)(ihput("ymax",(char *)&ymax));
	(void)(ihput("dmin",(char *)&dmin));
	(void)(ihput("dmax",(char *)&dmax));
	(void)(ihput("dscale",&dscale));
	(void)(ihput("dtype",&dtype));
	if (*mfile != '-')
		if ((fm = ihmerg(mfile)) == NULL)
			gipserr();
		else
			(void)(ihbcl(fm));
	if ((dlen = ihdtype(dtype)) == 0)
		gipserr1(GIPSUNSCALE);
	outcvt = ihdcvt(dtype);
	ibuf = (int *) alloc(xnum,sizeof(int));
	dbuf = alloc(xnum,dlen);
	if (gipserrno != 0)
		gipserr();
	putargs();
	if ((fp = ihwrit("-",1)) == NULL)
		gipserr();
	(void)(signal(SIGPIPE,exit));

	for (n = 0, y = ynum; --y >= 0; ) {
		register x	= xnum;
		register int *i = ibuf;

		while (--x >= 0)
			*i++ = n++;

		gconv(dbuf,(char *)ibuf,xnum,outcvt,CVT_I);
		(void)(fwrite(dbuf,dlen,xnum,fp));
	}
	(void)(ihbcl(fp));
}
