#! /bin/sh

: '%Z%$RCSfile: gipsNeWS.sh,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1989/02/07 16:52:28 $

		   General Image Processing program
			   Peter G. Ford
		      Center for Space Research
	Copyright 1988 Massachusetts Institute of Technology

	Module:		$RCSfile: gipsNeWS.sh,v $		Creation Date:	12/20/88
	Version:	$Revision: 2.1 $		Update:		$Date: 1989/02/07 16:52:28 $
	Function:	Display general image via NeWS server
'

zappo= in= cmap=bw display= x=0 y=0

if [ $# -eq 0 ] ; then set - - ; fi

while [ $# -gt 0 -a "$in" = "" ] ; do
	case $1 in
		=)
			echo "usage: gipsNeWS [-a cmap] [-d host] [file]" 1>&2
			exit ;;
		/*.im8)
			in=$1 title=`basename $1` ;;
		*.im8)
			in=`pwd`/$1 title=$1 ;;
		-a)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -a value" 1>&2
				exit 1
			fi
			cmap=$2
			shift ;;
		-a*)
			cmap=`expr substr $1 3 999` ;;
		-d)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -d value" 1>&2
				exit 1
			fi
			NEWSSERVER=`/usr/NeWS/bin/setnewshost $2`
			shift ;;
		-d*)
			display=`expr substr $1 3 999`
			NEWSSERVER=`/usr/NeWS/bin/setnewshost $display` ;;
		-h)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -h value" 1>&2
				exit 1
			fi
			h=$2
			shift ;;
		-h*)
			h=`expr substr $1 3 999` ;;
		-w)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -w value" 1>&2
				exit 1
			fi
			w=$2
			shift ;;
		-w*)
			w=`expr substr $1 3 999` ;;
		-x)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -x value" 1>&2
				exit 1
			fi
			x=$2
			shift ;;
		-x*)
			x=`expr substr $1 3 999` ;;
		-y)
			if [ $# -eq 1 ] ; then
				echo "`basename $0`: no -y value" 1>&2
				exit 1
			fi
			y=$2
			shift ;;
		-y*)
			y=`expr substr $1 3 999` ;;
		-)
			in=/tmp/psh$$
			ihtopix -a $cmap -o $in $1 || exit
			title="Standard input"
			zappo="(rm -f $in) forkunix pause" ;;
		-*)
			echo "`basename $0`: bad arg: $1" 1>&2
			exit 1 ;;
		*)
			in=/tmp/psh$$
			ihtopix -a $cmap -o $in $1 || exit
			title=`git -n $1|sed -n 's/^title = "\(.*\)"/\1/p'` 
			if [ "$w" = "" ] ; then
				w=`git -n $1|sed -n 's/^xnum = \(.*\)/\1/p'` 
			fi
			if [ "$h" = "" ] ; then
				h=`git -n $1|sed -n 's/^ynum = \(.*\)/\1/p'` 
			fi
			zappo="(rm -f $in) forkunix pause" ;;
	esac
	shift
	if [ $# -eq 0 -a "$in" = "" ] ; then set -- - ; fi
done

if [ ! -r "$in" ] ; then echo "$in: file not found" 1>&2 ; exit 1 ; fi

if [ $# -gt 0 ] ; then
	echo "`basename $0`: too many args" 1>&2
	exit 1
fi

if [ "$NEWSSERVER" = "" ] ; then
	echo "`basename $0`: NeWS not running" 1>&2
	exit 1
else
	export NEWSSERVER
fi

if [ "$w" != "" -a "$h" != "" ] ; then
	reshape="$x $y $w $h /reshape"
else
	reshape="/reshapefromuser"
fi

/usr/NeWS/bin/psh <<EOF
/ShowGIPSWindow {
    /win framebuffer /new DefaultWindow send def	% Create a window
    {							% Install my stuff.
	/FrameLabel ($title) def
	/PaintClient {
	    ClientCanvas setcanvas clippath pathbbox scale pop pop
	    ($in) readcanvas pause imagecanvas pause
	} def
	/PaintIcon {
	    IconCanvas setcanvas
	    currentcanvas mapped currentcanvas retained or {
		    clippath pathbbox scale pop pop
		    0 0 moveto ($in) readcanvas pause imagecanvas
		    IconCanvas setcanvas 0 strokecanvas
	    } if
	} def
	/ClientMenu [
	    (Zap)	{ $zappo currentprocess killprocessgroup }
	] /new DefaultMenu send def
    } win send
    $reshape win send					% Shape it.
    /map win send  					% Map the window.
} def
ShowGIPSWindow
EOF
