#ifndef lint
static char *sccsid = "%Z%$RCSfile: gipscont.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1987/03/04 23:16:00 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1987 Massachusetts Institute of Technology
**
**	Module:		gipscont.c	Creation Date:	03/04/87
**	Version:	$Revision: 2.1 $		Update:		$Date: 1987/03/04 23:16:00 $
**	Components:	gipscont()	gipsmongo subroutine
**	Subsystem:	mongo_()	(c) J. Tonry, 1983
**
**	Function:	Draw contour plot from General Image
*/

#include "mongo.h"

#define	xmin	mongopar_.u_cord[0]
#define	xmax	mongopar_.u_cord[1]
#define	ymin	mongopar_.u_cord[2]
#define	ymax	mongopar_.u_cord[3]

gipscont(z, m, n, v, nv)
	register float	*z, *v;
	register m, n, nv;
{
	float	x, y, dx, dy, x0, x1, y0, y1;
	register i, j, k;

	dx = (xmax-xmin)/(m-1);
	dy = (ymax-ymin)/(n-1);

	for (y = ymin, j = 0; j < n-1; j++, y += dy, z++) {
		for (x = xmin, i = 0; i < m-1; i++, x += dx, z++) {
			for (k = 0; k < nv; k++) {
				switch (((v[k] > z[0]) |
					((v[k] > z[1]) << 1) |
					((v[k] > z[m]) << 2)) ^
					((v[k] > z[m+1]) ? 7 : 0)) {
				case 0:
					continue;
				case 1:
					x0 = dx*(v[k]-z[0])/(z[1]-z[0]);
					y0 = 0;
					x1 = 0;
					y1 = dy*(v[k]-z[0])/(z[m]-z[0]);
					break;
				case 2:
					x0 = dx*(v[k]-z[0])/(z[1]-z[0]);
					y0 = 0;
					x1 = dx;
					y1 = dy*(v[k]-z[1])/(z[m+1]-z[1]);
					break;
				case 3:
					x0 = 0;
					y0 = dy*(v[k]-z[0])/(z[m]-z[0]);
					x1 = dx;
					y1 = dy*(v[k]-z[1])/(z[m+1]-z[1]);
					break;
				case 4:
					x0 = 0;
					y0 = dy*(v[k]-z[0])/(z[m]-z[0]);
					x1 = dx*(v[k]-z[m])/(z[m+1]-z[m]);
					y1 = dy;
					break;
				case 5:
					x0 = dx*(v[k]-z[0])/(z[1]-z[0]);
					y0 = 0;
					x1 = dx*(v[k]-z[m])/(z[m+1]-z[m]);
					y1 = dy;
					break;
				case 6:
					x0 = dx*(v[k]-z[0])/(z[1]-z[0]);
					y0 = 0;
					x1 = 0;
					y1 = dy*(v[k]-z[0])/(z[m]-z[0]);
					relocate(x+x0,y+y0);
					draw(x+x1,y+y1);
				case 7:
					x0 = dx*(v[k]-z[m])/(z[m+1]-z[m]);
					y0 = dy;
					x1 = dx;
					y1 = dy*(v[k]-z[1])/(z[m+1]-z[1]);
				}
				relocate(x+x0,y+y0);
				draw(x+x1,y+y1);
			}
		}
	}
}
