#ifndef lint
static char *sccsid = "%Z%$RCSfile: mongodev.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/12/04 17:29:01 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1986 Massachusetts Institute of Technology
**
**	Module:		mongodev.c	Creation Date:	03/19/86
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/12/04 17:29:01 $
**	Function:	Return Mongo device type
**	Components:	get_mongo_device()	GIPS subroutine
*/

#include	<stdio.h>
#include	<ctype.h>
#include	"mongo.h"
	/*
	**	mongo device types
	*/
static	struct	mongo_device	 mongo_devices[] = {
	"r640",		"Retrographics 640",		1,
	"vt125",	"DEC VT125",			2,
	"4014",		"Tektronix 4014",		3,
	"tek",		"Tektronix 4014",		3,
	"g270",		"Grinnell 270",			4,
	"hp2648",	"Hewlett Packard HP2648A",	5,
	"sun",		"SMI Graphic Tool Environment",	6,
	"versv",	"Versatec (vertical)",		-1,
	"vers",		"Versatec (horizontal)",	-2,
	"printv",	"Printronix (vertical)",	-3,
	"print",	"Printronix (horizontal)",	-4,
	"laserv",	"Laser Printer (vertical)",	-5,
	"laser",	"Laser Printer (horizontal)",	-6,
	NULL
};
	/*
	**	Arg: pointer to device name string pointer
	**	Returns: Mongo integer device code
	*/
get_mongo_device(name)
	register char	**name;
{
	struct	mongo_device	*dp;
	char	*getenv();
	register char *c;

	if (! *name)
		*name = getenv("TERM");
	else if (! strcmp(*name, "?"))
		printf("-o\tDescription\n"), *name = NULL;

	for (c = *name; c && *c; c++)
		if (isupper(*c))
			*c = tolower(*c);

	for (dp = mongo_devices; dp->name; dp++)
		if (! *name)
			printf("%s\t%s\n", dp->name, dp->desc);
		else if (! strncmp(dp->name, *name, strlen(dp->name)))
			break;
	if (! *name)
		exit(0);
	return dp->name ? dp->mongo_type : 0;
}
