#ifndef lint
static char *sccsid = "%Z%$RCSfile: sunwin.c,v $	GIPS $Revision: 1.5 $ (MIT/CSR) $Date: 1990/04/30 19:16:55 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1990 Massachusetts Institute of Technology
**
**	Module:		$RCSfile: sunwin.c,v $		Creation Date:	03/07/90
**	Version:	$Revision: 1.5 $		Update:		$Date: 1990/04/30 19:16:55 $
**	Function:	SunView interface for mongo
*/

#include <stdio.h>
#include <signal.h>
#include <suntool/gfx_hs.h>

	/*
	**	Support for colors
	*/
#include "mongo.h"
static	int		colorval;
#define	NCOLORS		32
static	unsigned char	rgb[NCOLORS][3] = {
	{	255,	255,	255	/* 000 white */		},
	{	255,	0,	0	/* 001 red */		},
	{	0,	255,	0	/* 002 green */		},
	{	0,	0,	255	/* 003 blue */		},
	{	255,	255,	0	/* 004 yellow */	},
	{	255,	0,	255	/* 005 magenta */	},
	{	0,	255,	255	/* 006 cyan */		},
	{	192,	192,	192	/* 007 gray */		},
	{	135,	206,	235	/* 008 SkyBlue */	},
	{	112,	128,	144	/* 009 SlateGray */	},
	{	0,	0,	128	/* 010 navy */		},
	{	0,	0,	205	/* 011 MediumBlue */	},
	{	64,	224,	208	/* 012 turquoise */	},
	{	127,	255,	212	/* 013 aquamarine */	},
	{	46,	139,	87	/* 014 SeaGreen */	},
	{	152,	251,	152	/* 015 PaleGreen */	},
	{	127,	255,	0	/* 016 chartreuse */	},
	{	50,	205,	50	/* 017 LimeGreen */	},
	{	240,	230,	140	/* 018 khaki */		},
	{	255,	215,	0	/* 019 gold */		},
	{	160,	82,	45	/* 020 sienna */	},
	{	245,	245,	220	/* 021 beige */		},
	{	165,	42,	42	/* 022 brown */		},
	{	245,	222,	179	/* 023 wheat */		},
	{	250,	128,	114	/* 024 salmon */	},
	{	255,	165,	0	/* 025 orange */	},
	{	255,	192,	203	/* 026 pink */		},
	{	176,	48,	96	/* 027 maroon */	},
	{	160,	32,	240	/* 028 purple */	},
	{	230,	230,	250	/* 029 lavender */	},
	{	106,	90,	205	/* 030 SlateBlue */	},
	{	0,	0,	0	/* 031 black */		}
};
#define	COLOR	((colorval = mongopar_.uservar[9] - COLOR_MAGIC) >= 0 && \
		colorval < NCOLORS && \
		gfx->gfx_pixwin->pw_pixrect->pr_depth > 1 && \
		(colorval + COLOR_MAGIC) == mongopar_.uservar[9])

char buffer[1024];

/* The f77 version of system is frequently broken */
mgosystem_(cmd,cmdlen)
char *cmd;
int cmdlen;
{
  strcpy(buffer,cmd);
  return(system(buffer));
}

struct gfxsubwindow *gfx ;
int sigwinched(), mousex, mousey ;

DEFINE_CURSOR(crosshair, 7, 7, PIX_SRC ^ PIX_DST,
	0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0000, 0xFC7E,
	0x0000, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0100, 0x0000) ;

/* Select output window */
mgosunwinselect_(name,namelen)
int namelen ;
char *name ;
{
	we_setgfxwindow(name) ;
}

/* Open a window and return the size of the window as (x,y) */
mgosunwinopen_(x,y)
int *x, *y ;
{
	int damage ;
	if( gfx == NULL ) {
		if((gfx = gfxsw_init(0,NULL)) == NULL) {
			fprintf(stderr,"Unable to open graphics subwindow\n") ;
			return ;
		}	
		gfxsw_getretained(gfx) ;
		signal(SIGWINCH,sigwinched) ;
		win_setcursor(gfx->gfx_windowfd,&crosshair) ;
		if (gfx->gfx_pixwin->pw_pixrect->pr_depth > 1) {
			char	rgb0[3][NCOLORS];
			int	i, j;
			for (i = 0; i < 3; i++)
				for (j = 0; j < NCOLORS; j++)
					rgb0[i][j] = rgb[j][i];
			pw_setcmsname(gfx->gfx_pixwin, "mongo");
			pw_putcolormap(gfx->gfx_pixwin, 0, NCOLORS,
				rgb0[0], rgb0[1], rgb0[2]);
		}
	}
	checkdamage(gfx,damage) ;
	*x = gfx->gfx_rect.r_width ;
	*y = gfx->gfx_rect.r_height ;
}

/* Draw a vector in the window from (x1,y1) to (x2,y2) */
mgosunwinvec_(x1,y1,x2,y2)
int *x1, *x2, *y1, *y2 ;
{
	int ymax ;
	ymax = gfx->gfx_rect.r_height ;
	pw_vector(gfx->gfx_pixwin,*x1,ymax-*y1,*x2,ymax-*y2,PIX_SRC,
		COLOR ? colorval : NCOLORS-1);
}

/* Write n characters from the string c starting at (x,y) */
mgosunwinchar_(x,y,n,c,clen)
int *x, *y, *n, clen ;
char *c ;
{
	int ymax ;
	c[*n] = '\0' ;
	ymax = gfx->gfx_rect.r_height ;
	if (COLOR)
		pw_ttext(gfx->gfx_pixwin,*x,ymax-*y,
			PIX_SRC | PIX_COLOR(colorval), NULL,c);
	else
		pw_text(gfx->gfx_pixwin,*x,ymax-*y,PIX_SRC|PIX_DST,NULL,c) ;
}

/* If r = 0, put the cursor at x,y; if r=1, wait on mouse and return x,y */
mgosunwincurs_(x,y,r)
int *x, *y, *r ;
{
	Inputmask im ;
	Event ie ;
	int ymax ;
	ymax = gfx->gfx_rect.r_height ;
	if(*r == 0) {
		win_setmouseposition(gfx->gfx_windowfd,*x,ymax-*y) ;
		return ;
	}
	input_imnull(&im) ;
	win_setinputcodebit(&im,MS_LEFT) ;
	win_set_pick_mask(gfx->gfx_windowfd,&im);
	input_readevent(gfx->gfx_windowfd, &ie) ;
	*x = event_x(&ie) ;
	*y = ymax - event_y(&ie) ;
}

/* Erase the graphics window */
mgosunwinerase_()
{
	pw_writebackground(gfx->gfx_pixwin,0,0,gfx->gfx_rect.r_width,
		gfx->gfx_rect.r_height,
			COLOR ? (PIX_SRC | PIX_COLOR(colorval)) : PIX_CLR);
}

/* Close the graphics subwindow */
mgosunwinclose_()
{
	int damage ;
	checkdamage(gfx,damage) ;
}

checkdamage(gfxw,damage)
/* Check the window for damage and fix it if possible */
struct gfxsubwindow *gfxw ;
int damage ;
{
	damage = 0 ;
	if(gfxw->gfx_flags & GFX_DAMAGED) {
		gfxsw_handlesigwinch(gfxw) ;
		damage = GFX_DAMAGED ;
	}
	if(gfxw->gfx_flags & GFX_RESTART) {
		gfxw->gfx_flags &= ~GFX_RESTART ;
		damage = GFX_RESTART ;
	}
}

sigwinched()
{
	gfxsw_interpretesigwinch(gfx) ;
	gfxsw_handlesigwinch(gfx) ;
	if(gfx->gfx_flags & GFX_RESTART) {
		gfx->gfx_flags &= ~GFX_RESTART ;
		mgosunsetup_() ;
	}
}
