#ifndef lint
static char *sccsid = "%Z%$RCSfile: errordiff.c,v $	GIPS $Revision: 3.3 $ (MIT/CSR) $Date: 1990/04/23 18:52:00 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1986,1987 Massachusetts Institute of Technology
**
**	Module:		errordiff.c	Creation Date:	06/18/87
**	Version:	$Revision: 3.3 $		Update:		$Date: 1990/04/23 18:52:00 $
**	Components:	setup_diffuse_error	initialize parameters
**			diffuse_error		plot by diffusion
**
**	Function:	Read and convert the input image
*/
#include	"gipstool.h"
	/*
	**	Initialize error diffusion coefficients
	*/
static	short	zcoeffs[5]	= { 1, 1, 1, 1, 0 };
static	short	zdenom;

setup_diffuse_error()
{
	if (ecoeffs != NULL) (void)sscanf(ecoeffs, "%hd %hd %hd %hd %hd",
	&zcoeffs[0], &zcoeffs[1], &zcoeffs[2], &zcoeffs[3], &zcoeffs[4]);
	zdenom = zcoeffs[0] + zcoeffs[1] + zcoeffs[2] + zcoeffs[3];
	if (zdenom == 0) zdenom = 1;
	zcoeffs[0] = zcoeffs[1] + zcoeffs[2] + zcoeffs[3];
}
	/*
	**	Error diffusion mapping into depth=1 pixrect
	*/
diffuse_error(in, out, nconv, zsave1, zsave2)
register char	*in;
register short	*out, *zsave1, *zsave2;
register int	nconv;
{
	register int	x;
	register short	i, j, m, sw = zcoeffs[4];

	for (m = x = 0; x < nconv; x++, m <<= 1) {
		image_hist[i = *in++ & 0377]++;
		i = *zsave1 + (i << 4);
		if (i >= 128*16)
			i -= 256*16, m |= 1;
		if ((x & 017) == 017)
			*out++ = sw ? ~m : m, m = 0;
		j = i/zdenom;
		*zsave1++ = 0;
		*zsave1 += i-zcoeffs[0]*j;
		*(zsave2-1) += zcoeffs[1]*j;
		*zsave2++ += zcoeffs[2]*j;
		*zsave2 += zcoeffs[3]*j;
	}
	if (x &= 017)
		*out = sw ? ~(m << (017 - x)) : (m << (017 - x));
}	
