/*	%Z%$RCSfile: gipstool.h,v $	GIPS $Revision: 3.8 $ (MIT/CSR) $Date: 1998/05/13 01:13:34 $
**
**		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1986 Massachusetts Institute of Technology
**
**	Module:		gipstool.h	Creation Date:	03/19/86
**	Version:	$Revision: 3.8 $		Update:		$Date: 1998/05/13 01:13:34 $
**	Function:	Define common variables
**	Components:	gipstool.h	C include file
*/
#include 	<string.h>
#include	<stdio.h>
#include	<ctype.h>
#include	"gips.h"
#include	<suntool/sunview.h>
#include	<suntool/canvas.h>
#include	<suntool/panel.h>

#define		TOOL_NAME(v)	"GipsTool v"
#define		GIPSTOOLMENU	"%s/gipstool3.menu", GIPSPROFDIR
#define		GIPSTOOLFONT	"screen.r.14"
#define		GIPSTOOLRC	"%s/.gipstoolrc"
#define		GIPSSOCKET	"/tmp/gips_socket"
#define		NIX		0x7FFFFFFF
#define		RGBSIZE		256
#define		NGRAPHICS	256
#define		TEXTLEN		256
#define		NUMBUF		3
#ifdef CTRL
#undef CTRL
#endif CTRL
#define		CTRL(x)		((x) & 037)

#define	GIPS_ERROR	display_error_message(gipserrs[gipserrno], gipserrs[0])
#define	GIPSWIN(w)	(w)

#ifdef	MAIN
#define	storage
#define	init(x)	= x
#else
#define	storage	extern
#define	init(x)	/* x */
#endif
	/*
	**	fields updated by gipsflags() from callers arguments
	*/
storage	flag	cflag;			/* =1 to update image from disk */
storage	flag	Sflag;			/* generate memory statistics */
storage	char	*colormap;		/* colormap name */
storage	char	*afile;			/* input colormap file name */
storage	char	*ecoeffs;		/* error diffusion coefficients */
storage	int	xzoom	init(1);	/* x-axis pixel replication */
storage	int	yzoom	init(NIX);	/* y-axis pixel replication */
storage	int	colors	init(128);	/* number of colors */
storage	int	cshift	init(1);	/* color value shift */
storage	char	*imfile	init("-");	/* input image file name */
storage	char	*mfile	init("-");	/* input header merge file name */
storage	char	*ifile;			/* command input file */
storage	char	*ofile;			/* command output (log) file */
storage	char	*gipsrc;		/* init file */
	/*
	**	Sunview image canvas structures
	*/
storage	Rect	display_rect;		/* rect of display screen */
storage	Frame	base_frame;		/* describes the tool */
storage	Canvas	image_sw;		/* image subwindow */
storage	Rect	sw_rect;		/* image_sw dimensions */
storage	int	image_fd;		/* image file descriptor */
storage	Pixwin	*image_pw;		/* current image sub-area */
storage	Rect	image_rect;		/* area within image_pw */
storage	Pixrect	*data_pr;		/* byte-pixel image copy */
storage	Pixrect	*saved_pr;		/* image copy */
storage	Pixrect	*paint_pr;		/* image paint overlay */
storage	Rect	saved_rect;		/* dimension of saved_pr */
storage	Pixfont	*default_font;		/* message font */
storage	Cursor	image_cursor;		/* normal cursor */
storage	Cursor	drag_cursor;		/* dragging cursor */
storage	Cursor	hourglass_cursor;	/* hourglass */
storage	Cursor	load_cursor[16];	/* clock faces */
storage	short	graphic_sw[NGRAPHICS];	/* graphic switches */
storage	int	graphic_angle;		/* current text angle */
storage	int	graphic_color;		/* graphic overlay colors */
storage	int	graphic_origin;		/* text display origin */
storage int	graphic_index;		/* current graphic number */
	/*
	**	The following are read from GIPSTOOLMENU
	*/
storage	Menu	menu;			/* main menu */
storage	short	command_index[256];	/* index into commands */
storage	char	**command_prompt;	/* prompts */
storage	char	**command_text;		/* text of menu item */
storage	char	**command_help;		/* help messages */
	/*
	**	Miscellaneous
	*/
storage	struct	pr_pos	last_mark;	/* previous marked cursor */
storage	int	pan_count;		/* accumulated numeric */
storage	int	stretch_percent;	/* colormap stretch factor */
storage	double	stretch_min;		/* minimum linear stretch */
storage	double	stretch_max;		/* maximum linear stretch */
storage long	image_seek;		/* start of image in input file */
storage	int	xnum;			/* input image x-dimension */
storage	int	ynum;			/* input image y-dimension */
storage	int	xorg	init(NIX);	/* input image x-origin */
storage	int	yorg	init(NIX);	/* input image y-origin */
storage	int	xdim	init(NIX);	/* input image x-pixel dimension */
storage	int	ydim	init(NIX);	/* input image y-pixel dimension */
storage	int	xoff;			/* display x-pixel origin */
storage	int	yoff;			/* display y-pixel origin */
storage	FILE	*fp;			/* input GIPS file stream */
storage	FILE	*input_stream;		/* tool command input */
storage	FILE	*output_stream;		/* tool command output */
storage	FILE	*pixel_stream;		/* pixel logging output */
storage	char	*pixel_log_file;	/* pixel log file name */
storage	char	*paint_overlay_file;	/* paint overlay file name */
storage	char	*tag_file;		/* file containing tag info */
storage	gimage	*input_gimage;		/* control block for dtype=G */
storage	char	dtype;			/* GIPS image pixel type */
storage	flag	Zflag;			/* use error diffusion display */
storage	flag	map_sw;			/* true if mapping defined */
storage	int	depth;			/* depth of output image */
storage	int	image_mark[2];		/* marked pixel address */
storage	int	precision init(6);	/* numeric conversion prec */
storage	int	item_size init(31);	/* pixels in zoomed rect */
storage	int	item_zoom init(4);	/* zoom in zoomed rect */
storage	int	item_color init(255);	/* graphic color in zoomed rect */
storage	int	brush_size init(1);	/* graphic paint brush size */
storage	int	must_update;		/* flag to force window writing */
storage	int	no_display;		/* quiet flag during ifile exec */
storage	int	rotated_font;		/* =1 if font is rotated */
storage	char	font[FONTLEN];		/* drawing font name */
storage	unsigned char	rgb[3][256];	/* rgb input colormap */
storage	unsigned char	newrgb[3][256];	/* current colormap */
storage	int	image_hist[256];	/* raw pixel histogram */
storage	char	*left_button_value	/* left mouse command */
		init("");
storage	char	*cursor_format		/* pixel value insert format */
		init("%rd");
storage	char	*logging_format		/* pixel log output format */
		init("%x\t%rx\t%y\t%ry\t%d\t%rd");
	/*
	**	Mapping from image pixel(x or y) to image_pw window
	*/
#define	Y_IMAGE_TO_RECT(y)	(((y)-yoff-yorg)*yzoom+image_rect.r_top)
#define	X_IMAGE_TO_RECT(x)	(((x)-xoff-xorg)*xzoom+image_rect.r_left)
#define	IMAGE_TO_RECT(x,m)	((m)?Y_IMAGE_TO_RECT(x):X_IMAGE_TO_RECT(x))
	/*
	**	Mapping from image_pw window to image pixel(x or y)
	*/
#define	Y_RECT_TO_IMAGE(y)	(((y)-image_rect.r_top)/yzoom+yoff+yorg)
#define	X_RECT_TO_IMAGE(x)	(((x)-image_rect.r_left)/xzoom+xoff+xorg)
#define	RECT_TO_IMAGE(x,m)	((m)?Y_RECT_TO_IMAGE(x):X_RECT_TO_IMAGE(x))
	/*
	**	"mod" image_pw window to origin of zoomed pixel
	*/
#define	__MOD_RECT(z,a,b)	((b==1)?(z):((((z)-a)/b)*b+a))
#define	X_MOD_RECT(x)		__MOD_RECT((x),image_rect.r_left,xzoom)
#define	Y_MOD_RECT(y)		__MOD_RECT((y),image_rect.r_top,yzoom)
	/*
	**	Common library functions and variables
	*/
extern	int	errno;			/* system error number */
/* extern	int	sys_nerr;*/		/* highest index in errlist */
/* extern	char	*sys_errlist[];	*/	/* error strings */

extern		read_image();		/* construct saved_pr */
extern		image_repaint();	/* image SIGWINCH handler */
extern		image_selected();	/* image key/mouse handler */
extern	char	*form_char();		/* format an ascii byte */
extern	char	*get_tag_name();	/* return tag name */
extern	char	*save_string();		/* alloc & save string */
extern	char	*get_coordinates();	/* format coordinate string */
	/*
	**	Special function keys
	*/
#define	KEY_TOP_EDGE	KEY_RIGHT(7)
#define	KEY_BOTTOM_EDGE	KEY_RIGHT(15)
#define	KEY_LEFT_EDGE	KEY_RIGHT(13)
#define	KEY_RIGHT_EDGE	KEY_RIGHT(9)
#define	KEY_REDRAW	KEY_RIGHT(11)

#undef	storage
#undef	MAIN

#ifdef	lint
/*VARARGS*/
Menu	menu_create(s) { return menu_create(s); }
/*VARARGS*/
Window	window_create(w,n,s) Window *w; { return window_create(w,n,s); }
/*VARARGS*/
	window_set(w,s) Window *w; { return window_set(w,s); }
#endif	lint
