%{
#ifndef lint
static char *sccsid = "%Z%$RCSfile: locate.l,v $	GIPS $Revision: 3.4 $ (MIT/CSR) $Date: 1998/05/13 01:12:23 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1986 Massachusetts Institute of Technology
**
**	Module:		locate.l	Creation Date:	03/19/86
**	Version:	$Revision: 3.4 $		Update:		$Date: 1998/05/13 01:12:23 $
**	Function:	Decode pixel location address
**	Components:	locate()	gipstool subroutine
*/

#undef	ECHO
#include	"gipstool.h"
	/*
	**	These defines redirect lex input to *yy_ptr
	*/
#undef	input
#define	input() (*yy_ptr ? *yy_ptr++ : 0)
#undef	output
#define	output(c) /* c */
#undef	unput
#define	unput(c) (yy_ptr > yy_buf ? (*--yy_ptr = c) : c)
#define	yywrap() (1)
	/*
	**	Following variables are referenced by the lex rules
	*/
static	char	*yy_buf;	/* pointer to address buffer */
static	char	*yy_ptr;	/* pointer to address buffer */
static	int	pix[2];		/* image pixel address */
static	char	coord_sw[2];	/* true if coord saved */
static	int	xy;		/* 0,1 for first,second address */
static	double	coord_xy[2];	/* saved realworld values */
extern	double	atof();		/* C library */
	/*
	**	Let yy_lex() parse the addresses into pix[].
	**	Then possibly pan the window to display that pixel
	*/
decode_address(buf, ie)
	char	*buf;			/* address string */
	Event	*ie;			/* event pointer */
{
	double	dd[2];			/* scratch */

	yy_ptr = yy_buf = buf;
	pix[0] = event_x(ie);
	pix[1] = event_y(ie);
	gipserrno = 0;
	coord_sw[0] = coord_sw[1] = 0;
	xy = -1;
	yylex();
	if (map_sw && (coord_sw[0] || coord_sw[1])) {
		if (coord_sw[0] != coord_sw[1])
			display_error_message("Illegal mixed coordinates", "");
		else if (g_map(coord_xy[0], coord_xy[1], dd))
			display_error_message("Coordinate outside image", "");
		else {
			pix[0] = dd[0]+0.5;
			pix[1] = dd[1]+0.5;
		}
	} else {
		if (coord_sw[0])
			(void)gips(&coord_xy[0], &pix[0], 1, GIPS_X_VAL);
		if (coord_sw[1])
			(void)gips(&coord_xy[1], &pix[1], 1, GIPS_Y_VAL);
	}
	if (gipserrno)
		return;
	if (xy != 1)
		display_error_message("Bad address", 0);
	else
		set_image_cursor(pix[0], pix[1], ie);
}
%}

S	[+-]
D	[0-9]
E	[edED]{S}?{D}+
%%
[ \t\n]+	/* ignore whitespace surrounding text*/ ;

{D}+		/* absolute image address */ {
			if (++xy < 2) pix[xy] = atoi(yytext);
		}
{S}{D}+		/* relative image address */ {
			if (++xy < 2) pix[xy] =
				RECT_TO_IMAGE(pix[xy],xy)+atoi(yytext);
		}
":"{D}+		/* absolute window address */ {
			if (++xy < 2) pix[xy] =
				RECT_TO_IMAGE(atoi(yytext+1), xy);
		}
"<"{D}+		/* relative window address */ {
			if (++xy < 2) pix[xy] = RECT_TO_IMAGE(pix[xy] -
				atoi(yytext+1), xy);
		}
">"{D}+		/* relative window address */ {
			if (++xy < 2) pix[xy] = RECT_TO_IMAGE(pix[xy] +
				atoi(yytext+1), xy);
		}
{S}?{D}+{E}	|
{S}?{D}*"."{D}+({E})?	|
{S}?{D}+"."{D}*({E})?	/* RealWorld Address */ {
			if (++xy < 2)
				coord_xy[xy] = atof(yytext), coord_sw[xy]++;
		}
.		/* Bad Value */ xy = 2;
