#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged.c,v $	GIPS $Revision: 2.6 $ (MIT/CSR) $Date: 2004/11/29 18:54:08 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged.c		Creation Date:	12/29/83
**	Version:	$Revision: 2.6 $		Update:		$Date: 2004/11/29 18:54:08 $
**	Components:	main()		UNIX command
**
**	Function:	Edit graphic planes and General Images
*/

#include        <string.h>    /* for strlen */
#include        <stdio.h>     /* for stdout */
#include	<signal.h>
#include	<setjmp.h>
#include	<ctype.h>
#include	"iged.h"
#include	<sys/types.h>
#include	<sys/stat.h>
	/*
	 *	mostly i/o and buffers
	 */
char	*c;			/* input line pointer */
FILE	*fio = "'stdout'";		/* terminal output file */
FILE	*fimage;		/* current input image */
int	fgraphic;		/* current output graphic */
char	fiodflt[] = "'stdout'";	/* pointer to terminal file name */
char	*shell = "/bin/csh";	/* pointer to shell pathname */
char	*fioname = fiodflt;	/* pointer to terminal file name */
char	instr[BUFLEN];		/* string buffer */
char	headfile[FONTLEN];	/* last header read */
char	mergefile[FONTLEN];	/* last header merged */
char	*graphic;		/* current edited graphic */
char	*graphic1;		/* saved graphic */
char	incom		= 0;	/* current command letter */
	/*
	 *	permament disk files
	 */
char	*qfile		= "%sman/iged.1i";
char	*qmacs		= "%slib/man.iged";
char	*qcommand	= "/usr/bin/nroff - | more -f -s";
char	igedrc[]	= ".igedrc";
	/*
	 *	flags and stuff
	 */
int	pixel[2];		/* target location x-y */
int	ngraph		= 1;	/* last accessed graphic plane */
int	nimage		= 1;	/* last accessed image plane */
int	curpnt		= 0;	/* line-drawing point counter */
int	precision	= 6;	/* precision of float output */
int	linetype	= 0377;	/* code for drawing lines */
int	debug		= 0;	/* internal debugging */
int	gflg		= 0;	/* general flags */
	/*
	 *	environment and error handling
	 */
jmp_buf	igenv;			/* for jmpbuf return */
char	**igenvp;		/* entry shell environment */
int	blockmode	= 0;	/* graphic refresh update mode */
int	batch		= 0;	/* =1 if iged invoked with args */
int	prolog		= 0;	/* executing code from prolog file */
int	maclev		= 0;	/* macro execution stack depth */
static	iged_fail();

static	SIGTYPE
onint()
{
	(void)(write(2,"\n",1));
	if (*fioname == '|') {
		(void)(error("\"%s\" halted",fioname+1));
		fio = stdout;
		fioname = fiodflt;
	}
	longjmp(igenv,0);
	return((SIGTYPE)0);
}

static	SIGTYPE
onfpe()
{
	(void)(write(2,"floating-point exception",24));
	return(onint());
}

static	SIGTYPE
onbus()
{
	(void)(write(2,"illegal machine instruction",27));
	return(onint());
}

static	SIGTYPE
onseg()
{
	(void)(write(2,"illegal machine address",23));
	return(onint());
}

main(argc,argv,envp)

	int	argc;
	char	**argv, **envp;
{
	char	buf[BUFLEN];
	char	*getenv(), *tgetstr();
	struct	stat fst;

	if (argc == 2 && argv[1][0] == '=' && argv[1][1] == '\0') {
		(void) fprintf(stderr,"Usage: %s [-subcommands ...]\n",*argv);
		exit(0);
	}
	(void)(fstat(0,&fst));
	batch = (argc > 1 || (fst.st_mode & S_IFREG) != 0);
	igenvp = envp;
	saveargs(argv);
	telltale(0);

	if ((graphic = alloc(1,NGRAPH)) == NULL ||
	    (graphic1 = alloc(1,NGRAPH)) == NULL)
		exit(1);

	(void)(settype(GRAPHIC));
	(void)(setfont("R.6"));
	(void)(setorigin(0));
	(void)(setink(0377));

	if (target_get(1,pixel) && argc == 1)
		(void)(iged_fail());

	if ((fgraphic = graphic_open(ngraph,1)) >= 0)
		(void)(read(fgraphic,graphic,NGRAPH));

	prolog++;
	sprintf(buf,"<< %s/%s",getenv("HOME"),igedrc);
	if (iged_com(buf))
		exit(1);
	prolog--;

	if (--argc) {
		if (ihread("-",GIPSPROFILE) == NULL)
			exit(gipserr() == GOOD ? 0 : 1);
		(void)(strcpy(headfile,"'stdin'"));
		argv++;
		buf[0] = 0;
		while (argc--) {
			(void)(strncat(buf,*argv,BUFLEN-strlen(*argv)-2));
			if (argc == 0 ||
			    (*(*++argv) == '-' && ! isdigit((*argv)[1])))
				if (iged_com(buf) == EVIL)
					exit(1);
				else
					maclev = buf[0] = 0;
			else
				(void)(strcat(buf," "));
		}
	} else	{
		(void)(setjmp(igenv));
		(void)(signal(SIGINT,onint));
		(void)(signal(SIGFPE,onfpe));
		(void)(signal(SIGBUS,onbus));
		(void)(signal(SIGSEGV,onseg));
		fputs("iged v1.0\n : ",stderr);
		gflg = 0;
		while (fgets(buf,BUFLEN,stdin) != NULL) {
			register int rc;
			maclev = buf[strlen(buf)-1] = 0;
			rc = iged_com(buf);
			if (fio != NULL)
				(void)(fflush(fio));
			if (debug & 04)
				telltale(1);
			(void) fprintf(stderr,rc ? " ? " : " : ");
		}
	}

	if (fgraphic >= 0 && (gflg & UP) && (batch || blockmode)) {
		(void)(lseek(fgraphic,(off_t)0,0));
		(void)(write(fgraphic,graphic,NGRAPH));
	}
}

static
iged_fail()
{
#include	<pwd.h>
	register	struct passwd *pwd;
	register	char *s, *t;
	extern	char *index();
	extern	struct passwd *getpwuid();
	extern	uid_t getuid();

	if ((pwd = getpwuid(getuid())) == NULL)
		return(error("Display busy",""));
	if (*pwd->pw_gecos == '&')
		s = pwd->pw_name;
	else
		if ((t = index(s = pwd->pw_gecos,' ')) != NULL)
			*t = '\0';
	(void) fprintf(stderr,"Sorry %s, the display is unavailable.\n",s);
	(void) fprintf(stderr,"Did you forget to lock it?\n");
	return(EVIL);
}
