#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged_com.c,v $	GIPS $Revision: 2.5 $ (MIT/CSR) $Date: 2004/11/29 18:54:08 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged_com.c	Creation Date:	03/16/84
**	Version:	$Revision: 2.5 $		Update:		$Date: 2004/11/29 18:54:08 $
**	Components:	update()	save current graphic
**			iged_eq()	subcommand short help messages
**			iged_edit(p)	change previous command string
**			iged_equ(p)	reissue previous command string
**			iged_qm()	subcommand long help messages
**			iged_com(s)	iged subcommand parser
**
**	Function:	Parse and issue current command
*/

#include        <string.h>    /* for strlen */
#include	<ctype.h>
#include	"iged.h"

extern	struct cntl {
	char	ch;
	int	flg;
	int	(*p1)();
	int	(*p2)();
	int	(*p3)();
	char	*sav;
} comlist[];

static
update()
{
	if (fgraphic < 0) return(GOOD);
	(void)(lseek(fgraphic,(off_t)0,0));
	gflg &= ~UP;
	return((write(fgraphic,graphic,NGRAPH) == NGRAPH) ? GOOD : EVIL);
}

iged_eq()
{
	register struct cntl *p = comlist;

	for (p = comlist; p->ch; p++)
		if (p->sav != NULL && p->ch != '=')
			(void) fprintf(stderr,"%c: %s\n",p->ch,p->sav);
}

static
iged_edit(p)


	register struct cntl *p;
{
	char		buf[1000], *strcpy(), *index();
	register char	*b, *d, *e;
	register	l1, l2, found, glob = 1;

	if ((d = index(++c,'^')) == NULL)
		d = "";
	else
		*d++ = 0;
	if ((e = index(d,'^')) == NULL)
		e = "";
	else {
		for (*e++ = 0; isspace(*e); e++)
			;
		if (*e == 'g') {
			glob = 100;
			while (isspace(*++e))
				;
		}
	}
	if ((l1 = strlen(c)) == 0 || *e)
		return(error ("bad substitution string",""));
	if ((e = p->sav) == NULL)
		return(error ("no saved text",""));

	for (b = buf, l2 = strlen(d), found = 0; b < buf+sizeof(buf)-1; )
		if (glob && *e == *c && ! strncmp(e,c,l1)) {
			b = strcpy(b,d) + l2;
			e += l1;
			found++;
			glob--;
		} else if (! (*b++ = *e++))
			break;
	if (! found)
		return(error ("string '%s' not found",c));
	p->sav = ralloc(p->sav,strlen(buf)+1);
	(void) fprintf(stderr,"%c %s\n",incom,c = strcpy(p->sav,buf));
	return(GOOD);
}

static
iged_equ(p)

	register struct cntl *p;
{
	if (p->sav == NULL)
		return(error ("no saved %.1s command",&p->ch));
	p->sav = ralloc(p->sav,strlen(p->sav)+strlen(c)+1);
	c = strcat(p->sav,c);
	return(! error ("%s",c));
}

iged_qm()
{
	register	FILE	*fq, *fm;
	register	FILE	*fp = NULL;
	register	char	*s;
	extern	FILE	*popen();
	char		buf[BUFLEN];
	static	char	file[256], macs[256];

	if (*c == '*') {
		while (isspace(*++c))
			if (! *c)
				return(error("missing command string",""));
		qcommand = strcpy(alloc(strlen(c)+1,1),c);
		return(GOOD);
	}
	sprintf(file, qfile, gipsdir());
	if ((fq = fopen(qfile = file,"r")) == NULL)
		return(gipserr2(GIPSBADOPEN,qfile));
	s = *c ? c : "*";
	while (fgets(buf,BUFLEN,fq) != NULL)
		if (buf[0] == '.' && buf[1] == '\\' && buf[2] == '"') {
			if (fp != NULL)
				break;
			buf[strlen(buf)-1] = 0;
			if (buf[3] != ' ' || strcmp(buf+4,s) != 0)
				continue;
			if ((fp = popen(qcommand,"w")) == NULL)
				break;
			sprintf(macs, qmacs, gipsdir());
			if ((fm = fopen(qmacs = macs,"r")) != NULL) {
				while (fgets(buf,BUFLEN,fm) != NULL)
					fputs(buf,fp);
				(void)(fclose(fm));
			}
		} else if (fp != NULL)
			fputs(buf,fp);
	(void)(fclose(fq));
	if (fp == NULL) return(error("no help available for: %s",c));
	(void)(pclose(fp));
	return(GOOD);
}

iged_com(s)

	register char *s;
{
	static	struct cntl *lastcomm = NULL;
	register struct cntl *p = comlist;
	register equals = 0;
	extern	quits;

	*instr = 0;
	if (maclev++ > 20)
		return(error ("command stack overflow",""));
	while (isspace(*s) || *s == '-')
		s++;
	if (! *s || *s == '#')
		return(GOOD);
	if ((incom = *(c = s)) != 'q')
		quits = 0;
	if (incom == '^')
		if (lastcomm == NULL)
			return(error("no prior command",""));
		else
			incom = lastcomm->ch;
	else
		while (isspace(*++c))
			;
	if (incom == '=' && *c) {
		if (*c++ == '=')
			if (lastcomm == NULL)
				return(error("no prior command",""));
			else 
				incom = lastcomm->ch;
		else
			for (incom = *--c; isspace(*++c); )
				;
		equals++;
	}
	while (p->ch != incom)
		if (! (p++)->ch)
			return(error ("bad command string: %s",s));
	if (p->flg & UNDEF)
		return(error ("unknown command: %.1s",&incom));
	if (batch && (p->flg & IN))
		return(error ("bad command in pipeline mode: %.1s",&incom));
	if (prolog && (p->flg & NI))
		return(error ("bad command in '~/.igedrc': %.1s",&incom));
	if (p->flg & NR & gflg)
		return(error ("bad repeated command: %.1s",&incom));
	if (*c == '^' && iged_edit(lastcomm = p))
		return(EVIL);
	else if (equals && iged_equ(p))
		return(EVIL);
	else if (maclev <= 1)
		(lastcomm = p)->sav = strcpy(ralloc(p->sav,strlen(c)+1),c);
	if ((p->flg & HD) && ! *headfile)
		return(gipserr1(GIPSNOHEAD));
	if ((*p->p1)() || (*p->p2)() || (*p->p3)())
		return(EVIL);
	if (fgraphic >= 0 && (gflg |= (p->flg & UP)) &&
	    maclev <= 1 && ! batch && ! blockmode)
		return(update());
	return(GOOD);
}
