#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged_csh.c,v $	GIPS $Revision: 2.3 $ (MIT/CSR) $Date: 1998/05/13 01:17:25 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged_csh.c	Creation Date:	03/16/84
**	Version:	$Revision: 2.3 $		Update:		$Date: 1998/05/13 01:17:25 $
**	Components:	iged_csh()	execute shell command
**			iged_exp()	expand filename
**
**	Function:	pass string to C-shell
*/

#include        <string.h>    /* for strlen */
#include	<signal.h>
#include	<sys/wait.h>
#include	"iged.h"

#ifndef	SIGTYPE
#define	SIGTYPE	void
#endif	SIGTYPE

iged_csh()
{
	int	status, pid, w;
	register	FILE * fcom;
	register	SIGTYPE (*istat)(), (*qstat)();

	if (! *c)
		return(error("missing shell command",""));

	if (*c == '*') {
		c++;
		if (iged_str())
			return(EVIL);
		if (instr[0] != '/')
			return(error("bad shell name: ",instr));
		if ((shell = alloc(1,strlen(instr)+1)) == NULL)
			return(gipserr());
		(void)(strcpy(shell,instr));
		return(GOOD);
	}
		
	if (fimage != NULL) {
		(void)(fclose(fimage));
		fimage = NULL;
	}
	if (fgraphic >= 0)
		(void)(close(fgraphic));
	if ((fcom = command_open()) != NULL)
		(void)(fclose(fcom));

	if ((pid = vfork()) == 0) {
		execle(shell, rindex(shell,'/')-1, "-c", c, 0, igenvp);
		_exit(127);
	}
	istat = signal(SIGINT, SIG_IGN);
	qstat = signal(SIGQUIT, SIG_IGN);
	while ((w = wait((WAITYPE)&status)) != pid && w != -1)
		;
	(void)(signal(SIGINT, istat));
	(void)(signal(SIGQUIT, qstat));

	(void)(command_open());
	fgraphic = graphic_open(ngraph,1);
	return((w == -1 || status != 0) ? EVIL : GOOD);
}

char *
iged_exp(gp)

	register char *gp;
{
	char	cbuf[100];
	static	char buf[BUFLEN];
	int	status, pvec[2];
	SIGTYPE	(*stat[3])();
	register r, pid = 0;
	register char *dp = "~{[*?$`'\"\\";

	while (index(gp,*dp++) == NULL) if (! *dp) return(gp);

	if (pipe(pvec) >= 0 && (pid = fork()) == 0) {
		(void)(close(1));
		(void)(dup(pvec[1]));
		(void)(close(pvec[0]));
		(void)(close(2));
		(void)(open("/dev/null",1));
		(void)(close(0));
		(void)(dup(2));
		execle(shell,rindex(shell,'/')-1,"-c",strcat(strcpy(
			alloc(strlen(gp)+9,1),"echo -n "),gp),0,igenvp);
	}
	if (pid <= 0) {
		(void)(error("can't expand: %s",gp));
		return(NULL);
	}
	(void)(close(pvec[1]));
	*buf = 0;
	if (read(pvec[0],buf,sizeof(buf)-1) == sizeof(buf)-1)
		while (read(pvec[0],cbuf,sizeof(cbuf)) > 0) ;
	(void)(close(pvec[0]));
	stat[0] = signal(SIGINT,SIG_IGN);
	stat[1] = signal(SIGQUIT,SIG_IGN);
	stat[2] = signal(SIGHUP,SIG_IGN);
	while((r = wait((WAITYPE)&status)) != pid && r != -1)
		;
	(void)(signal(SIGINT,stat[0]));
	(void)(signal(SIGQUIT,stat[1]));
	(void)(signal(SIGHUP,stat[2]));
	if (r == -1  || status || ! *buf) {
		(void)(error("file not found: %s",gp));
		return(NULL);
	}
	if ((gp = index(buf,' ')) != NULL)
		*gp = 0;
	return(buf);
}
