#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged_help.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 05:45:43 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged.c		Creation Date:	12/29/83
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 05:45:43 $
**	Components:	iged_help()	iged.c subroutine and message file
**
**	Function:	Supply subcommand control and help messages
*/

#include	<ctype.h>
#include	"iged.h"

static
nomore()
{
	while (isspace(*c))
		c++;
	return(*c ? error ("extraneous text: %s",c) : GOOD);
}

static
null()
{
	return(GOOD);
}

static
save()
{
	if (maclev <= 1 && ! batch)
		move(graphic,graphic1,NGRAPH);
	return(GOOD);
}

struct cntl {
	char	ch;		/* subcommand character */
	int	flg;		/* processing flags */
	int	(*p1)();	/* first processing routine */
	int	(*p2)();	/* second processing routine */
	int	(*p3)();	/* third processing routine */
	char	*sav;		/* pointer to last execution */
} comlist[] = {

'?',	NR,		null,		null,		iged_qm,	NULL,
'a',	NR|UP|HD,	save,		iged_a,		iged_a,		NULL,
'b',	NR|IN,		nomore,		save,		iged_b,		NULL,
'c',	NR,		iged_str,	nomore,		iged_c,		NULL,
'd',	UP,		iged_loc,	save,		iged_d,		NULL,
'e',	UP,		iged_loc,	save,		iged_e,		NULL,
'f',	NR,		iged_str,	null,		iged_f,		NULL,
'g',	NR|UP,		iged_str,	nomore,		iged_g,		NULL,
'h',	NR,		iged_str,	nomore,		iged_h,		NULL,
'i',	NR|UP,		iged_str,	nomore,		iged_i,		NULL,
'j',	UP,		iged_loc,	iged_str,	iged_j,		NULL,
'k',	NR,		iged_str,	nomore,		iged_k,		NULL,
'l',	NR,		iged_str,	null,		iged_l,		NULL,
'm',	NR|HD,		iged_str,	nomore,		iged_m,		NULL,
'n',	0,		iged_loc,	nomore,		iged_n,		NULL,
'o',	NR,		iged_str,	nomore,		iged_o,		NULL,
'p',	NR,		iged_str,	nomore,		iged_p,		NULL,
'q',	NR|NI,		nomore,		null,		iged_q,		NULL,
'r',	NR|UP,		iged_str,	save,		iged_r,		NULL,
's',	NR|IN|UP,	nomore,		null,		iged_s,		NULL,
't',	UP,		iged_loc,	null,		iged_t,		NULL,
'u',	IN|UP|NI,	nomore,		null,		iged_u,		NULL,
'v',	NR|HD,		null,		null,		iged_v,		NULL,
'w',	NR,		iged_str,	null,		iged_w,		NULL,
'x',	NR|UP|HD,	null,		save,		iged_a,		NULL,
'y',	NR|UP|HD,	null,		save,		iged_a,		NULL,
'z',	NI,		iged_str,	null,		iged_z,		NULL,
'C',	UP,		nomore,		save,		iged_C,		NULL,
'D',	UP,		iged_loc,	save,		iged_D,		NULL,
'F',	NR,		iged_str,	null,		iged_F,		NULL,
'G',	NR|UP,		null,		save,		iged_G,		NULL,
'H',	NR|NI,		iged_str,	nomore,		iged_H,		NULL,
'L',	UP|NI,		iged_loc,	save,		iged_L,		NULL,
'N',	NI,		iged_loc,	nomore,		iged_N,		NULL,
'O',	UP|NI,		iged_loc,	save,		iged_O,		NULL,
'P',	NI,		iged_loc,	null,		iged_P,		NULL,
'R',	NR|IN|NI,	null,		null,		iged_R,		NULL,
'S',	UP|NI,		null,		save,		iged_S,		NULL,
'T',	UP|HD,		iged_loc,	save,		iged_T,		NULL,
'U',	IN|UP|NI,	nomore,		null,		iged_U,		NULL,
'<',	NR,		null,		null,		iged_in,	NULL,
'>',	NR,		null,		null,		iged_out,	NULL,
'[',	UP,		iged_loc,	save,		iged_bx,	NULL,
']',	UP,		iged_loc,	save,		iged_bf,	NULL,
'!',	IN,		null,		null,		iged_csh,	NULL,
'"',	0,		null,		save,		iged_mac,	NULL,
'.',	NR,		null,		null,		iged_cmd,	NULL,
'=',	NR|NI,		null,		null,		iged_eq,	NULL,
'`',	0,		iged_str,	null,		iged_debug,	NULL,
' ',	NR|NI,		null,		null,		null,		NULL,
'\0'
};
