#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged_mac.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1986/10/01 17:54:52 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged_mac.c	Creation Date:	03/16/84
**	Version:	$Revision: 2.2 $		Update:		$Date: 1986/10/01 17:54:52 $
**	Components:	iged_mac()	store, execute, and report macros
**			iged_R()	repetitively execute a subcommand
**			iged_in()	read commands from external file
**			iged_out()	redirect listing output
**
**	Function:	subcommands relating to macros and terminal i/o
*/

#include        <string.h>   /* for strlen */
#include	<ctype.h>
#include	"iged.h"

iged_mac()
{
	static	char *mactab['z'-'a'+1];
	char	buf[BUFLEN];
	register int i;
	register char *s, *t;

	if (! (incom = *c++)) {
		for (i = 0; i < 'z'-'a'+1; i++)
			if (mactab[i] != NULL)
				(void) fprintf(fio,"\"%c:\t%s\n",'a'+i,mactab[i]);
		return(GOOD);
	}

	if (! isalpha(incom) || ! islower(incom))
		return(error("macro letter '%1s' missing or illegal",&incom));

	while (isspace(*c))
		c++;
	i = incom - 'a';
	if (! *c) {
		if (mactab[i] == NULL)
			return(error("macro -%.1s undefined",&incom));
		for (s = mactab[i]; *s; ) {
			for (t = buf; *t = *s; t++)
				if (isspace(*s++) && *s == '-' &&
				    ! isdigit(s[1]))
					break;
			*t = 0;
			if (iged_com(buf+1))
				return(EVIL);
			else
				maclev--;
		}
		return(GOOD);
	}
	if (*c != '-')
		return(error("illegal macro: %s",c));
	mactab[i] = strcpy(ralloc(mactab[i],strlen(c)+1),c);
	return(GOOD);
}

iged_R()
{
	char	buf[BUFLEN];
	register	i, j;
	register	char *s;

	for (s = c, i = j = 0; isdigit(*s); i = 10*i + *s++ - '0')
		;
	if (i > 100)
		return(error("repeat count too large",""));
	if (i == 0)
		i = j = 100;
	gflg |= NR;
	while ((iged_com(strcpy(c = buf,s)) == 0 || j == 0) && --i > 0)
		--maclev;
	gflg &= ~NR;
	return((i == 0) ? GOOD : EVIL);
}

static	char *
getfile()
{
	if (iged_str()) return(NULL);
	while (isspace(*c)) c++;
	if (! *c) return(iged_exp(instr));
	(void)(error("extraneous text: ",c));
	return(NULL);
}

iged_in()
{
	char	buf[BUFLEN];
	static	char	Mfile[FONTLEN];
	extern	FILE	*popen();

	register FILE	*fp;
	register int	frompipe = 0;
	register int	quiet	= 0;
	register	i	= GOOD;
	register char	*s	= c;

	switch (*c) {
	case '\0':
		return(*Mfile ? ! error("last file/shell executed: %s",Mfile) :
			error("no file/shell executed",""));
	case '|':
		frompipe++;
		fp = popen(s = c+1,"r");
		break;
	case '<':
		quiet++;
		c++;
	default:
		if ((s = getfile()) == NULL) return(EVIL);
		fp = fopen(s,"r");
		break;
	}
	if (fp == NULL)
		return(prolog ? GOOD : gipserr2(GIPSBADOPEN,s));
	if (maclev <= 1)
		(void)(strncpy(Mfile,s,sizeof(Mfile)-1));
	while (fgets(buf,sizeof(buf),fp) != NULL) {
		if (! quiet)
			fputs(buf,fio);
		buf[strlen(buf)-1] = 0;
		if (i = iged_com(buf))
			break;
		else maclev--;
	}
	if (frompipe)
		(void)(pclose(fp));
	else
		(void)(fclose(fp));
	return(i);
}

iged_out()
{
	register	char	*s;
	register	char	*sw	= "w";
	register		topipe	= 0;
	extern	FILE	*popen();

	if (fio != stdout)
		if (*fioname == '|') {
			(void)(pclose(fio));
			(void)(error("\"%s\" completed",fioname+1));
		} else {
			(void)(fclose(fio));
			(void)(error("%s closed",fioname));
		}
	fio = stdout;
	if (fioname != fiodflt) {
		free(fioname);
		fioname = fiodflt;
	}
	switch (*c) {
	case '\0':
		return(GOOD);
	case '|':
		topipe++;
		fio = popen(s = c+1,"w");
		break;
	case '>':
		sw = "a";
		c++;
	default:
		if ((s = getfile()) == NULL) return(EVIL);
		fio = fopen(s,sw);
		break;
	}
	if (fio == NULL) {
		fio = stdout;
		return(gipserr2(GIPSBADOPEN,s));
	}
	fioname = alloc(strlen(s)+1+topipe,1);
	if (topipe) *fioname = '|';
	(void)(strcpy(fioname+topipe,s));
	return(GOOD);
}
