#ifndef lint
static char *sccsid = "%Z%$RCSfile: iged_z.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1998/05/13 01:17:29 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		iged_z.c	Creation Date:	03/16/84
**	Version:	$Revision: 2.2 $		Update:		$Date: 1998/05/13 01:17:29 $
**	Components:	iged_z()	iged subcommand
**
**	Function:	report pixel value in external general image
*/
#include	<signal.h>
#include	<sys/wait.h>
#include	"iged.h"

static	int	egips_mode[3]	= { EGIPS_X_VAL, EGIPS_Y_VAL, EGIPS_D_VAL };

iged_z()
{
	struct	piperec {
		int	var[3];
		double	d[3][2];
	}	p;

	int	dlen, xnum, proc, pvec[2], v[2];
	char	*s, dtype;
	long	offset;
	FILE	*fp;
	char	buf[30];
	register	i, j;

	if (! *instr)
		return(error("missing GIPS filename",""));
	if (iged_loc())
		return(EVIL);
	if ((s = iged_exp(instr)) == NULL)
		return(EVIL);
	if (pipe(pvec) < 0)
		return(error("can't create pipe",""));

	if ((proc = fork()) != 0) {
		(void)(close(pvec[0]));
		do	{
			if ((j = iged_im(pixel)) < 0)
				 j = 0;
			for (i = 0; i < 3; i++) {
				v[0] = p.var[i] = ((i == 2) ? j :
					(pixel[i]-iged_org(i,1)));
				v[1] = 1 + v[0];
				if (egips(v,p.d[i],2,egips_mode[i])) {
					(void)(gipserr());
					break;
				}
			}
			(void)(write(pvec[1],(char *)&p,sizeof(struct piperec)));
		} while (*c && ! iged_loc());
		(void)(close(pvec[1]));

		while (proc != -1 &&
				(i = wait((WAITYPE)0)) != proc && i != 1)
			;
		return((proc != -1) ?
			GOOD : error("unable to execute subtask",""));
	}

	(void)(signal(SIGINT,exit));
	(void)(close(pvec[1]));

	if ((fp = ihread(s,GIPSPROFILE)) == NULL ||
	    ihget("xnum",(char *) &xnum,0) != 0 ||
	    ihget("dtype",(char *) &dtype,1) != 0) {
		if (fp != NULL)
			(void) ihbcl(fp);
		(void)(exit(gipserr() ? 1 : 0));
	}
	if (dtype == 'c' || (dlen = ihdtype(dtype)) == 0)
		(void)(exit(gipserr1(GIPSBADTYPE)));

	offset = ftell(fp);

	while (read(pvec[0],(char *)&p,sizeof(struct piperec)) == 
	    sizeof(struct piperec)) {

		int	v[3][2];

		for (i = 0; i < 3; i++) {
			(void) fprintf(fio,"%c: %d(","xyd"[i],p.var[i]);
			for (j = (p.d[i][0] == p.d[i][1]); j < 2; j++) {
				if (p.d[i][j] == GIPSLOW)
					fputs("MIN",fio);
				else if (p.d[i][j] == GIPSHIGH)
					fputs("MAX",fio);
				else
					fputs(gcvt(p.d[i][j],precision,buf),
						fio);
				if (j == 0)
					(void)(putc(',',fio));
				else if (i < 2)
					fputs(")\t",fio);
				else
					fputs(")\n",fio);
			}
		}

		for (i = 0; i < 2; i++)
			if (gips(&p.d[i][0],&v[i][0],2,
					i ? GIPS_Y_VAL : GIPS_X_VAL))
				(void)(exit(gipserr() ?
					1 : 0));
			else if (v[i][0] > v[i][1]) {
				j = v[i][0];
				v[i][0] = v[i][1];
				v[i][1] = j;
			} 
		for (i = v[1][0]; i <= v[1][1]; i++)
			for (j = v[0][0]; j < v[0][1]; j++) {
				double	dbuf;
				register	char	*s;

				if (fseek(fp,(long)(offset+dlen*(xnum*i+j)),0)
				    == -1 || fread(buf,dlen,1,fp) != 1 ||
				    gips((double *)buf,(int *)&dbuf,
						1,GIPS_R_VAL))
					s = "***";
				else
					s = gcvt(dbuf,precision,buf);
				(void) fprintf(fio,"\tx=%d\ty=%d\t%s\n",j,i,s);
			}
	}
	(void)(ihbcl(fp));
	(void)(close(pvec[0]));
	(void)(exit(0));
	return(EVIL);
}
