#ifndef lint
static char *sccsid = "%Z%$RCSfile: comp_arith.c,v $	GIPS $Revision: 2.6 $ (MIT/CSR) $Date: 2007/11/19 18:39:38 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1985 Massachusetts Institute of Technology
**
**	Module:		comp_arith.c	Creation Date:	04/23/85
**	Version:	$Revision: 2.6 $		Update:		$Date: 2007/11/19 18:39:38 $
**	Components:	comp_arith()	iha subroutine
**
**	Function:	Compile the temporary source file
*/

#include 	<strings.h>
#include 	<string.h>
#include 	<unistd.h>
#include	"iha.h"

#ifdef FLOAT_OPTION
#define	CCSTRG	"%s -O -%s -o %s %s %s %s/lib/libGI.a -lm", FLOAT_OPTION
#else
#define	CCSTRG	"%s -O -o %s %s %s %s/lib/libGI.a -lm"
#endif

comp_arith(envp)
char **envp;
{
	int	pvec[2];	/* pipe descriptors */
	int	pid;		/* child process id */
	char	buf[1000];	/* scratch */
	char	buf2[1000];	/* scratch */
	register char *c;	/* scratch */
	register i;		/* scratch */

	if (pipe(pvec) < 0)
		error("cannot create pipe","");
	if ((pid = fork()) == 0) {
		(void)(close(2));
		(void)(dup(pvec[1]));
		(void)(close(pvec[0]));
		(void)(close(1));
		(void)(open("/dev/null",1));
		(void)(close(0));
		(void)(dup(1));
		c = (*lfile != '\0' && *lfile != '/') ?
			strcat(strcat(getwd(buf2), "/"), lfile) : lfile;
		chdir(ddir);
		(void)sprintf(buf, CCSTRG, CC, tempexec, tempsrc, c, gipsdir());
		execle("/bin/sh","sh","-c", buf, 0, envp);
	}
	if (pid <= 0)
		error("can't compile","");
	(void)(close(pvec[1]));
	/*
	 *	read stderr pipe (should be blank) and format an error message
	 */
	buf[0] = buf[sizeof(buf)-1] = 0;
	if (read(pvec[0],buf,sizeof(buf)-1) > 0)
		while (read(pvec[0],buf2,sizeof(buf2)) > 0)
			;
	(void)(close(pvec[0]));
	while ((i = wait(NULL)) != pid && i != 1)
		;
	if (*buf) {
		if (c = index(buf,'\n')) *c = 0;
		c = (c = index(buf,':')) ? c+2 : buf;
                printf( "iha: before compiler error message \n" );
		error("compiler error: %s",c);
	}
}
