
#ifndef lint
static char *sccsid = "%Z%$RCSfile: get_arith.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1998/05/13 01:19:59 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1985 Massachusetts Institute of Technology
**
**	Module:		get_arith.c	Creation Date:	12/02/86
**	Version:	$Revision: 2.2 $		Update:		$Date: 1998/05/13 01:19:59 $
**	Components:	get_arith()	iha subroutine
**
**	Function:	Scan and save iha function script
*/

#include	"iha.h"

extern	char	*index();
static	scan_arith(), scan_coord();

get_arith()
{
	register char *s;
	register FILE *fp;
	register i;
	/*
	**	If afile is a file name, replace with file contents
	*/
	if (index(afile, '=') == NULL) {
		if ((fp = fopen(afile, "r")) == NULL || fseek(fp, 0L, 2) == -1)
			gipserr2(GIPSBADOPEN, afile);
		s = afile = alloc(1, ftell(fp)+1);
		(void) fseek(fp, 0L, 0);
		while ((i = getc(fp)) != EOF)
			*s++ = i;
		(void) fclose(fp);
	}
	/*
	**	Determine whether script contains assignment
	*/
	if (out->dtype == 'c') {
		scan_arith('r');
		scan_arith('i');
	} else
		scan_arith('p');
	/*
	**	Determine whether script references the coordinate
	*/
	scan_coord('x');
	scan_coord('y');
}
	/*
	**	Scan "afile" for assignment to output pixel
	*/
static
scan_arith(ch)
	register char	ch;
{
	register char	*s;

	for (s = afile; *s; s++) 
		if (*s == ch) {
			if (s != afile && ! index(" \t\n;:,({[}", s[-1]))
				continue;
			while (isspace(*++s)) ;
			if (*s == '=')
				return;
			else if ((*s == '<' || *s == '>') && *s == s[1])
				s++;
			else if (! *s || ! index("+-*/&|%^", *s))
				continue;
			while (isspace(*++s)) ;
			if (*s == '=')
				return;
		}

	error("variable '%c' missing from control script", ch);
}
	/*
	**	Scan "afile" for use of coordinate
	*/
static
scan_coord(ch)
	register char	ch;
{
	register char	*s;

	for (s = afile; *s; s++) 
		if (*s == ch && (s == afile || ! isalnum(s[-1])) &&
			(s[1] == '\0' || ! isalnum(s[1]))) {
				byteflag = 0;
				return;
		}
}
