/*	%Z%$RCSfile: iha.h,v $	GIPS $Revision: 2.3 $ (MIT/CSR) $Date: 1998/05/13 01:20:01 $
**
**		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1985 Massachusetts Institute of Technology
**
**	Module:		iha.h		Creation Date:	04/23/85
**	Version:	$Revision: 2.3 $		Update:		$Date: 1998/05/13 01:20:01 $
**	Components:	none		include file
**
**	Function:	Supply definitions for iha routine
*/

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>
#include	<signal.h>
#include	<sys/wait.h>
#include	"gips.h"

extern	char	*afile;		/* arithmetic file */
extern	char	*lfile;		/* library file list */
extern	char	*mfile;		/* secondary header file */
extern	char	*ofile;		/* output file */
extern	char	*ddir;		/* scratch file directory */
extern	flag	Bflag;		/* don't use lookup table */
extern	flag	Sflag;		/* generate memory stats */
extern	flag	pflag;		/* print expr routine only */
/*
 *	flags for table.flgs field
 */
#define		CONV	01	/* pixel requires float conversion */
#define		NORM	02	/* dscale=n for this file */
#define		POLY	04	/* dscale=p for this file */
/*
 *	image definition table
 */
typedef struct	table {
	struct table  * nexttab;	/* forward allocation pointer */
	FILE	      *	iop;		/* stream i/o pointer */
	char	      *	fname;		/* pointer to name of file */
	char	      * buffer;		/* input buffer */
	float	      * fbuffer;	/* conversion buffer (if reqd) */
	char		dtype;		/* external pixel datatype */
	char		dscale;		/* pixel scale type */
	int		flgs;		/* flag codes */
	int		dlen;		/* external pixel length */
	int		plen;		/* internal pixel length */
	int		npoly;		/* polynomial index if dscale=p */
	double		dfact;		/* dscale=n coefficient */
	double		dzero;		/* dscale=n offset */
	float	      *	dpoly;		/* polynomial coeffs if dscale=p */
	char		vartype[20];	/* C variable type */
} TABLE;
/*
 *	miscellaneous stuff
 */
extern	char	tmpl[];		/* temporary file skeleton */
extern	TABLE	*get_table();	/* fill-in table structure */
extern	void	cleanup();	/* remove temporary files */
extern	char	*tempsrc;	/* temporary source file */
extern	char	*tempexec;	/* temporary executable */
extern	TABLE	*out;		/* output table structure */
extern	int	xnum;		/* number of x pixels */
extern	int	ynum;		/* number of y pixels */
extern	flag	byteflag;	/* true for all-byte pixels */
