#! /bin/sh

: '%Z%$RCSfile: ihbidr.sh,v $	GIPS $Revision: 1.7 $ (MIT/CSR) $Date: 1992/06/19 10:55:29 $

		   General Image Processing program
			   Peter G. Ford
		      Center for Space Research
	Copyright 1990 Massachusetts Institute of Technology

	Module:		ihbidr.sh	Creation Date:	09/07/90
	Version:	$Revision: 1.7 $		Update:		$Date: 1992/06/19 10:55:29 $
	Function:	Create pseudo-header for Magellan BIDR
'

debug=0 debug2=0

while [ $# -gt 0 ] ; do
	case $1 in
	=)
		echo "Usage: ihbidr [-D] [-R] name" 1>&2
		exit 0
		;;
	-D)
		debug=1
		;;
	-R)
		debug2=2
		;;
	-*)
		echo "`basename $0`: unknown option: $1" 1>&2
		exit 1
		;;
	*)
		break
		;;
	esac
	shift
done

case $# in
0)
	echo "`basename $0`: missing file name" 1>&2
	exit 1
	;;
1)
	if [ ! -r $1 ] ; then
		echo "$1: cannot read" 1>&2
		exit 1
	fi
	;;
*)
	echo "`basename $0`: multiple file names: $*" 1>&2
	exit 1
	;;
esac

echo "\
header	= \"Image Header\"
version	= ieee
title	= \"`echo \"Magellan BIDR $1\" | tr / :`\"
origin	= \"$1\"
geometry= \"type=b bidr=$1 debug=`expr $debug + $debug2`\"
dtitle	= \"Sigma-N (dB)\"
dtype	= G
dscale	= n
dmax	= 30
dmin	= -20
dnull	= 0
dzero	= -20.2
dfact	= 0.2
xnum	= 600
xtitle	= Longitude
xscale	= w
ynum	= 870
ytitle	= Latitude
history	= \"`date` ihbidr: $1\"
FINIS="

exit
