#ifndef lint
static char *sccsid = "%Z%$RCSfile: testmap.c,v $	GIPS $Revision: 2.4 $ (MIT/CSR) $Date: 1990/11/26 20:56:07 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984,1987 Massachusetts Institute of Technology
**
**	Module:		testmap.c	Creation Date:	07/02/87
**	Version:	$Revision: 2.4 $		Update:		$Date: 1990/11/26 20:56:07 $
**	Components:	main()		UNIX command
**
**	Function:	Test program for gtrans() subroutines
*/

#define	GRID
#include "gips.h"

static	char	header[] = "\n\
	header	= \"Image Header\"\n\
	version	= sun2\n\
	dtype	= b\n\
	xnum	= 512\n\
	ynum	= 512\n\
	FINIS=\n\
";

main()
{
	char	*g_getname(), *name, buf[BUFLEN];
	double	lonlat[2], xy[2];
	int	nproj;

	if (ihread(header, GIPSPROFILE) == NULL)
		gipserr();

	while (1) {
		printf("Enter projection 1-21: ");
		if (scanf(" %d", &nproj) != 1)
			exit(1);
		if (ihput("mapping", sprintf(buf, GIPS_MAPPING,
                        name = g_getname(nproj), nproj,
			256.0, 256.0, 72.4077, 0.0, 0.0, 0.0, 30.0, 45.0, 0)))
                	gipserr();
		printf("%s\n", buf);
		if (g_setup())
			gipserr();
		while (1) {
			printf("Enter %s lon, lat: ", name);
			if (scanf(" %lf %lf", &lonlat[0], &lonlat[1]) != 2) {
				fgets(buf, BUFLEN-1, stdin);
				break;
			}
			printf("lon=%g lat=%g ", lonlat[0], lonlat[1]);
			if (g_map(lonlat[0], lonlat[1], xy)) {
				printf("g_map error\n");
				continue;
			}
			printf("x=%g y=%g ", xy[0], xy[1]);
			if (g_unmap((int)xy[0], (int)xy[1], lonlat)) {
				printf("g_unmap error\n");
				continue;
			}
			printf("lon=%g lat=%g\n", lonlat[0], lonlat[1]);
		}
	}
}
