#ifndef lint
static char *sccsid = "%Z%$RCSfile: get_logic.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:26:58 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		get_logic.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:26:58 $
**	Components:	get_logic()	ihm subroutine
**
**	Function:	Decodes -l option string
*/

#include	"ihm.h"

#define		LSIZE	(sizeof(unsigned long) << 3)

get_logic(t)

	register TABLE	*t;
{
	static	int	il[5];
	register char	*c;
	register unsigned long l;
	register	i, j;

	if (t->dlen > 4 || t->dtype == 'f')
		error("bad dtype for -l option: %s",t->fname);
	qflag = 1;
	for (c = logic; isspace(*c); c++);
	t->bool[3] = ~0;
	switch (*c++) {
	case '=':	t->bool[3] = i = 0;	break;
	case '|':	i = 0;			break;
	case '&':	i = 1;			break;
	case '^':	i = 2;			break;
	case '\0':	i = il[4];		break;
	default:	error("bad -l value: %s",logic);
	}
	il[4] = t->bool[4] = i;
	if (*c == '~')
		t->bool[1] = ~0, c++;
	for (i = 0; ; i++, c++) {
		while (isspace(*c))
			c++;
		if (isdigit(*c))
			for (il[i] = 0; isdigit(*c); )
				il[i] = 10*il[i] + *c++ - '0';
		if (i == 3 || *c != ',')
			break;
	}
	i = t->dlen << 3;
	j = out->dlen << 3;
	if (il[0] > i || il[2] > j)
		error("bad -l field offset: %s",logic);
	t->bool[2] = il[0]-il[2];
	l = ~0;
	l <<= LSIZE - (il[1] ? il[1] : i);
	t->bool[0] = (l >>= (LSIZE-i+il[0]));
	t->bool[1] &= t->bool[0];
	if (t->bool[3] == 0) {
		l = ~0;
		l <<= LSIZE - (il[3] ? il[3] : j);
		t->bool[3] = ~(l >>= (LSIZE-j+il[2]));
	}
	logic = c;
}
