#ifndef lint
static char *sccsid = "%Z%$RCSfile: get_map.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:00 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		get_map.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:00 $
**	Components:	get_map()	ihm subroutine
**
**	Function:	Allocate and initialize the raster mapping tables
*/

#include	"ihm.h"

get_map(t,xy)

	register TABLE 	* t;	/* input file table */
	int	  	xy;	/* =0,1 for x,y axes */
{
	int	 	npix;	/* number of pixels + 1 */
	register 	i;	/* scratch */
	register double	*dtab;	/* temporary real raster array */
	register MAP	*m;	/* copy of map */

	/*
	 *	allocate and initialize temporary tables
	 */
	npix = t->num[xy]+1;
	dtab = (double *) alloc(npix,sizeof(double));
	/*
	 *	find the corresponding realworld values
	 */
	if (dtab == NULL ||
	    egips((int *)NULL,dtab,npix,xy ? EGIPS_Y_VAL : EGIPS_X_VAL))
		gipserr();
	/*
	 *	copy the arrays into a 'MAP' structure array
	 */
	m = t->map[xy] = (MAP *) alloc(npix,sizeof(struct map));
	for (i = 0; i < npix; i++, m++)
		m->mwt = dtab[m->mptr = i];
	free((char *)dtab);
}
