#ifndef lint
static char *sccsid = "%Z%$RCSfile: get_rasters.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1988/01/14 00:01:01 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		get_rasters.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.2 $		Update:		$Date: 1988/01/14 00:01:01 $
**	Components:	get_rasters()	ihm subroutine
**
**	Function:	Construct x- and y-axis raster tables
*/

#include	"ihm.h"
#include	<sys/types.h>
#include	<sys/stat.h>

get_rasters(t)

	register TABLE *t;	/* input file table */
{
	struct	stat	fst;	/* file status block */
	/*
 	 *	we cannot change 'c' (complex) files to or from another dtype
 	 */
	if (out->dtype != t->dtype && (out->dtype == 'c' || t->dtype == 'c'))
		error("illegal change of dtype: %s",t->fname);
	/*
	 *	determine if really quick merge is possible
	 */
	if (qflag && t->dscale == 'n' && out->dscale == 'n' &&
	    t->dzero == out->dzero && t->dfact == out->dfact)
		;
	else if (! qflag || t->dtype != out->dtype ||
	    t->dscale == 'n' || out->dscale == 'n')
		if (! logic)
			qqflag = 0;
	if (logic)
		get_logic(t);
	/*
 	 *	determine whether we can lseek() the input file
 	 *	we can't if it is a pipe or anything but a 'regular' file
 	 */
	(void)(fstat(fileno(t->iop),&fst));
	t->noseek = (fileno(t->iop) <= 2 || (fst.st_mode & S_IFREG) == 0);
	/*
	 *	now build up the raster pointer and weight tables
	 */
	t->inmap = alloc(t->num[0]+1,sizeof(char));
	get_rast(t,0);
	get_rast(t,1);
	/*
	 *	if we must lseek() the file, spool it to disk
	 *	then remember the offset to the start of the data array
	 */
	if (t->noseek && t->spl[1] == 0)
		get_spool(t);
	t->offset = ftell(t->iop);
	/*
	 *	obtain buffer for weighted input raster
	 */
	t->dwbuffer = qflag ? (DWT *) alloc(t->num[0],t->dlen) :
		(DWT *) alloc(out->num[0],sizeof(struct dwt));
}
