#ifndef lint
static char *sccsid = "%Z%$RCSfile: get_table.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:10 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		get_table.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:10 $
**	Components:	get_table()	ihm subroutine
**
**	Function:	Read the input file headers and fill out a table
*/

#include	"ihm.h"
#include	<signal.h>

TABLE *
get_table(file)

	char	*file;		/* name of input file - "-" for stdin
				   or NULL if this is to be the output file */
{
	register TABLE *t;
	double	 d;
	static	 char cstdin[] = "'stdin'";
	static	 char cstdout[] = "'stdout'";

	t = (TABLE *) alloc(1,sizeof(struct table));
	/*
	 *	read or write the GIPS header, exiting if anything fails
	 */
	if (file == NULL) {
		if ((t->iop = ihwrit(ofile,0)) == stdout) {
			(void)(signal(SIGPIPE,cleanup));
			t->fname = cstdout;
		}
	} else
		if ((t->iop = ihread(t->fname = file,GIPSPROFILE)) == stdin)
			t->fname = cstdin;
	if (t->iop == NULL)
		gipserr();
	/*
	 *	save the important header parameters
	 *	others may be necessary, either for egips() or get_poly()
	 */
	if (ihget("dscale",&t->dscale,1))
		t->dscale = 's';
	if (ihget("xnum",(char *)&t->num[0],0) ||
	    ihget("ynum",(char *)&t->num[1],0) ||
	    ihget("dtype",&t->dtype,1))
		gipserr();
	if (t->dtype == 'c') qflag = 1, qqflag = 0;
	if (ihget("xscale",(char *)&t->xscale,1))
		t->xscale = 's';
	t->xmin = (ihget("xmin",(char *)&d,0)) ? 0 : d;
	t->xmax = (ihget("xmax",(char *)&d,0)) ? t->num[0] : d;
	if (t->dscale == 'p')
		if (file == NULL)
			gipserr1(GIPSUNSCALE);
		else
			get_poly(t);
	else if (t->dscale == 'n') {
		if (ihget("dzero",(char *)&d,0))
			gipserr();
		else
			t->dzero = (float)d;
		if (ihget("dfact",(char *)&d,0))
			gipserr();
		else
			t->dfact = (float)d;
		if (file == NULL)
			if (t->dfact == 0)
				gipserr1(GIPSBADVAL);
			else
				t->dfact2 = 1/t->dfact;
	}
	if ((t->onull = ihget("dnull",(char *)&d,0)) == 0)
		t->dnull = (float) d;
	t->dlen = ihdtype(t->dtype);
	t->raster = t->dlen * t->num[0];
	if (t->num[0] > maxconv)
		maxconv = t->num[0];
	if (t->raster > maxraster)
		maxraster = t->raster;
	/*
	 *	initialize the mapping tables via calls to gips()
	 */
	get_map(t,0);
	get_map(t,1);
	t->iraster = -1;
	return(t);
}
