/*	%Z%$RCSfile: ihm.h,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1998/05/13 01:22:45 $
**
**		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		ihm.c		Creation Date:	01/31/84
**	Version:	$Revision: 2.2 $		Update:		$Date: 1998/05/13 01:22:45 $
**	Components:	ihm.h		C definitions
**
**	Function:	Definition file for ihm()
*/

#include	<stdio.h>
#include	<ctype.h>
#include	"gips.h"

#define		abs(x)		(((x)>0)?(x):(-x))
	/*
 	 *	variables that may be changed by input flags and arguments
 	 */
extern	char	*ddir;		/* spooling directory */
extern	char	*logic;		/* math logic stuff */
extern	char	*ofile;		/* output filename */
extern	flag	qflag;		/* true for "quick" merge */
extern	flag	Dflag;		/* debug flag */
extern	flag	qqflag;		/* true for even quicker merge */

typedef struct	map	{
	int	mptr;		/* raster index */
	float	mwt;		/* weight of this pixel */
} MAP;

typedef struct	raster	{
	MAP	* lowlimit;	/* pointer to first pixel contributing */
	MAP	* highlimit;	/* pointer to last pixel contributing */
	float	lowweight;	/* weight for first pixel */
	float	highweight;	/* weight for last pixel */
} RASTER;

typedef	struct	dwt {
	float	data;			/* output data value */
	float	weight;			/* weight accumulator */
} DWT;

typedef struct	table {
	struct table  * nexttab;	/* forward allocation pointer */
	DWT	      *	dwbuffer;	/* input weighted raster */
	RASTER	      *	rast[2];	/* axis raster definition tables */
	MAP	      *	map[2];		/* axis mapping indices and weights */
	char	      * inmap;		/* input raster pixel byte bap */
	FILE	      *	iop;		/* stream i/o pointer */
	char	      *	fname;		/* pointer to name of file */
	long		offset;		/* lseek offset to first raster */
	char		dtype;		/* pixel datatype */
	char		dscale;		/* pixel scale type */
	char		xscale;		/* x-axis scale type - in case wrap */
	int		dlen;		/* pixel length */
	int		num[2];		/* number of x,y pixels */
	int		ftemp;		/* temporary file */
	int		iraster;	/* last y-raster read */
	int		noseek;		/* pipe or tape - no seeks please */
	int		spl[2];		/* =1,0,-1 if x-axis as/un/descending */
	int		raster;		/* raster length */
	int		onull;		/* dnull flag */
	int		npoly;		/* polynomial index if dscale=p */
	int		bool[5];	/* boolean combo codes */
	float		dnull;		/* float dnull value */
	float		dfact;		/* dscale=n coefficient */
	float		dfact2;		/* inverse dscale=n coefficient */
	float		dzero;		/* dscale=n offset */
	float	      *	dpoly;		/* polynomial coeffs if dscale=p */
	float		xmax;		/* max if xscale=w */
	float		xmin;		/* min if xscale=w */
} TABLE;

extern	DWT	*accbuf;		/* buffer to accumulate output raster */
extern	TABLE	*out;			/* anchor for i/o stream tables */
extern	char	*inbuf;			/* common input buffer */
extern	float	*convbuf;		/* common raster conversion buffer */
extern	char	*outbuf;		/* output binary raster */
extern	int	maxraster;		/* maximum input raster length */
extern	int	maxconv;		/* maximum float raster length */

extern	void	cleanup();		/* recovery routine */
extern	char	*index();		/* C library */
