#ifndef lint
static char *sccsid = "%Z%$RCSfile: put_conv.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:14 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		put_conv.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:14 $
**	Components:	put_conv()	ihm subroutine
**
**	Function:	Convert input raster to realworld values
*/

#include	"ihm.h"

put_conv(t)

	register TABLE *t;	/* pointer to file table */
{
	register	n;	/* offset to first item */
	register float *r;	/* float buffer */
	register char  *sw;	/* pointer to raster pixel byte map */
	float		f;	/* accumulator for dscale=p */

	for (n = 0, r = convbuf, sw = t->inmap; n < t->num[0]; r++, n++)
		if (*sw++) switch (t->dtype) {
		case 'b':	*r = ((unsigned char *) inbuf)[n];	break;
		case 's':	*r = ((char *) inbuf)[n];		break;
		case 'h':	*r = ((short *) inbuf)[n];		break;
		case 'u':	*r = ((unsigned short *) inbuf)[n];	break;
		case 'i':	*r = ((long *) inbuf)[n];		break;
		case 'l':	*r = ((unsigned long *) inbuf)[n];	break;
		case 'f':	*r = ((float *) inbuf)[n];		break;
		case 'd':	*r = ((double *) inbuf)[n];		break;
		}
	/*
	 *	replace the buffer (backwards) by realworld pixels, 
	 *	applying the polynomial or normal transformation
	 */
	if (t->dscale == 'p') {
		for (--r; --n >= 0; *r-- = f)
			if (*--sw && (t->onull || *r != t->dnull)) {
				register float *d = t->dpoly+t->npoly;

				for (f = *d; d > t->dpoly; f = *--d + *r * f)
					;
			}
	} else if (t->dscale == 'n')
		while (--r >= convbuf)
			if (t->onull || *r != t->dnull)
				*r = t->dfact * *r + t->dzero;
}
