#ifndef lint
static char *sccsid = "%Z%$RCSfile: put_logic.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:16 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		put_logic.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:16 $
**	Components:	put_logic()	ihm subroutine
**
**	Function:	Effect boolean pixel operation
*/

#include	"ihm.h"

put_logic(t)

	register TABLE	*t;			/* file table pointer */
{
	register RASTER	*tr	= t->rast[0];	/* raster pointer */
	register	x;			/* output pixel index */
	register	long	i, j;		/* scratch */

	for (x = 0; x < out->num[0]; x++, tr++) {
		if (tr->lowlimit == NULL)
			continue;
		i = tr->lowlimit->mptr;
		switch (t->dlen) {
		case 1:	i = ((unsigned char *)t->dwbuffer)[i];	break;
		case 2:	i = ((unsigned short *)t->dwbuffer)[i];	break;
		case 4:	i = ((unsigned long *)t->dwbuffer)[i];	break;
		}
		i &= t->bool[0];
		i ^= t->bool[1];
		if (t->bool[2] < 0)
			i >>= -t->bool[2];
		else
			i <<= t->bool[2];
		switch (out->dlen) {
		case 1:	j = ((unsigned char *)outbuf)[x];	break;
		case 2:	j = ((unsigned short *)outbuf)[x];	break;
		case 4:	j = ((unsigned long *)outbuf)[x];	break;
		}
		j &= t->bool[3];
		switch (t->bool[4]) {
		case 0:		j |= i;		break;
		case 1:		j &= i;		break;
		case 2:		j ^= i;		break;
		}
		switch (out->dlen) {
		case 1:	((unsigned char *)outbuf)[x] = j;	break;
		case 2:	((unsigned short *)outbuf)[x] = j;	break;
		case 4:	((unsigned long *)outbuf)[x] = j;	break;
		}
	}
}
