#ifndef lint
static char *sccsid = "%Z%$RCSfile: put_pix.c,v $	GIPS $Revision: 2.2 $ (MIT/CSR) $Date: 1986/11/17 14:34:26 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		put_pix.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.2 $		Update:		$Date: 1986/11/17 14:34:26 $
**	Components:	put_pix()	Add the contents of a new input buffer
**					(r) to the accumulator arrays
**					(f) and (w)
**
**	Function:	Decodes -l option string
*/

#include	"ihm.h"

put_pix(t,r,fw)

	TABLE		*t;	/* file table pointer */
	register float	*r;	/* float input buffer */
	register DWT 	*fw;	/* x-weighted raster */
{
	register RASTER	*tr;	/* raster table pointer */
	register MAP	*tm;	/* x-axis lookup pointer */
	register 	x;	/* scratch */
	register float	*pnull;	/* pointer to dnull value */

	pnull = t->onull ? NULL : &t->dnull;

	for (tr = t->rast[0], x = out->num[0]; --x >= 0; tr++, fw++) {
		if ((tm = tr->lowlimit) != NULL &&
				(pnull == NULL || r[tm->mptr] != *pnull)) {
			fw->weight = tr->lowweight;
			fw->data = r[tm->mptr] * fw->weight;
		} else {
			fw->data = fw->weight = 0;
			if (tm == NULL)
				continue;
		}
		while (++tm < tr->highlimit)
			if (pnull == NULL || r[tm->mptr] != *pnull) {
				fw->data += r[tm->mptr] * tm->mwt;
				fw->weight += tm->mwt;
			}
		if (tr->highweight > 0 &&
				(pnull == NULL || r[tm->mptr] != *pnull)) {
			fw->data += r[tm->mptr] * tr->highweight;
			fw->weight += tr->highweight;
		}
	}
}
