#ifndef lint
static char *sccsid = "%Z%$RCSfile: put_qpix.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:20 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		put_qpix.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:20 $
**	Components:	put_qpix()	reformat pixels
**			put_qqpix()	don't reformat pixels
**
**	Function:	Quick-merge processing
*/

#include	"ihm.h"

put_qpix(t)

	register TABLE	*t;	/* file table pointer */
{
	register RASTER	*tr	= t->rast[0];	/* raster pointer */
	register DWT	*fw	= accbuf;	/* output buffer */
	register	x, i;			/* scratch */

	for (x = 0; x < out->num[0]; x++, tr++, fw++) {
		if (tr->lowlimit == NULL)
			continue;
		i = tr->lowlimit->mptr;
		if (t->dtype != 'c')
			if (fw->weight != 0)
				continue;
			else
				fw->weight = 1;
		switch (t->dtype) {
		case 'b':
			fw->data = ((unsigned char *)t->dwbuffer)[i];
			break;
		case 's':
			fw->data = ((char *)t->dwbuffer)[i];
			break;
		case 'h':
			fw->data = ((short *)t->dwbuffer)[i];
			break;
		case 'u':
			fw->data = ((unsigned short *)t->dwbuffer)[i];
			break;
		case 'i':
			fw->data = ((long *)t->dwbuffer)[i];
			break;
		case 'l':
			fw->data = ((unsigned long *)t->dwbuffer)[i];
			break;
		case 'f':
			fw->data = ((float *)t->dwbuffer)[i];
			break;
		case 'c':
			fw->data += t->dwbuffer[i].data;
			fw->weight += t->dwbuffer[i].weight;
			break;
		case 'd':
			fw->data = ((double *)t->dwbuffer)[i];
			break;
		}
		if (t->dscale == 'n')
			fw->data = t->dfact * fw->data + t->dzero;
	}
}

put_qqpix(t)

	register TABLE	*t;	/* file table pointer */
{
	register RASTER	*tr	= t->rast[0];	/* raster pointer */
	register DWT	*fw	= accbuf;	/* output buffer */
	register	x, i;			/* scratch */

	for (x = 0; x < out->num[0]; x++, tr++, fw++) {
		if (tr->lowlimit == NULL)
			continue;
		if (t->dtype != 'c')
			if (fw->weight != 0)
				continue;
			else
				fw->weight = 1;
		i = tr->lowlimit->mptr;
		switch (t->dlen) {
		case 1:
			outbuf[x] = ((char *)t->dwbuffer)[i];
			break;
		case 2:
			((short *)outbuf)[x] = ((short *)t->dwbuffer)[i];
			break;
		case 4:
			((int *)outbuf)[x] = ((int *)t->dwbuffer)[i];
			break;
		case 8:
			((double *)outbuf)[x] = ((double *)t->dwbuffer)[i];
			break;
		}
	}
}
