#ifndef lint
static char *sccsid = "%Z%$RCSfile: put_rast.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 06:27:21 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		put_rast.c	Creation Date:	11/06/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 06:27:21 $
**	Components:	put_rast()	ihm subroutine
**
**	Function:	Multiply the contents of raster 'ptr' of file 't'
**			by 'yweight' and add to the accumulating output
**			raster and weight.
*/

#include	"ihm.h"

put_rast(t,ptr,yweight)

	TABLE	*t;		/* pointer to file table */
	int	ptr;		/* y-value of output raster */
	float	yweight;	/* y-weighting factor */
{
	register DWT	*ydw = accbuf;	/* output raster and weights */
	register DWT	*dw  = t->dwbuffer;	/* raster buffer */
	register int	i;			/* scratch */

	if (yweight == 0.0 || ptr < 0 || ptr >= t->num[1])
		return;
	if (i = ptr - t->iraster) {
		if (i != 1)
			if (i < 0 && t->noseek)
				error("spool sequence error: %s",t->fname);
			else if (! t->noseek) {
				(void)(fseek(t->iop,
					(long)(t->offset + ptr * t->raster),0));
				i = 1;
			}
		while (--i >= 0)
			if (fread(qflag ? (char *)t->dwbuffer : inbuf,
					t->dlen,t->num[0],t->iop) != t->num[0])
				gipserr2(GIPSBADREAD,t->fname);
		t->iraster = ptr;
		if (! qflag) {
			put_conv(t);
			put_pix(t,convbuf,dw);
		}
	}
	if (logic)
		put_logic(t);
	else if (qqflag)
		put_qqpix(t);
	else if (qflag)
		put_qpix(t);
	else
		for (i = out->num[0]; --i >= 0; ydw++, dw++)
			if (dw->weight > 0) {
				ydw->data += dw->data * yweight;
				ydw->weight += dw->weight * yweight;
			}
}
