#ifndef lint
static char *sccsid = "%Z%$RCSfile: ihsum.c,v $	GIPS $Revision: 1.1 $ (MIT/CSR) $Date: 1990/06/07 21:00:20 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1990 Massachusetts Institute of Technology
**
**	Module:		sum.c		Creation Date:	06/04/90
**	Version:	$Revision: 1.1 $		Update:		$Date: 1990/06/07 21:00:20 $
**	Function:	Compute optimal size & stretch of GIPS image
**	Components:	main()		GIPS/UNIX command
*/

#include	"gips.h"
#include	<stdio.h>
#include	<math.h>
	/*
	**	flag fields filled by gipsflags()
	*/
static	char	*ifile	= "-";		/* input mongo command file */
static	char	*ofile	= "-";		/* output device */
static	flag	Sflag;			/* generate statistics */
static	flag	fflag;			/* print ASCII histogram */
	/*
	**	table used by gipsflags()
	*/
static	flagentry	flagtable[]	= {
	"S",	"1",		(flag *) &Sflag,
	"o",	"-> device",	(flag *) &ofile,
	NULL,	"[file ...]",	NULL
};

main(argc, argv)

	int	argc;		/* number of arguments */
	char	**argv;		/* array of argument pointers */
{
	int	xnum, ynum, dlen;
	char	dtype, *inbuf;
	double	dnull, total, totsq;
	FILE	*fp;
	register double *outbuf;
	register x, y, count, inull;
	/*
	**	save and parse callers argument list
	*/
	saveargs(argv);
	argc = gipsflags(argc, argv, flagtable);
	if (Sflag)
		telltale(0);

	if (--argc > 1)
		error("bad arg: %s", argv[2]);
	else if (argc == 1)
		ifile = *++argv;

	fp = ihread(ifile, GIPSPROFILE);

	if (fp == NULL || ihget("xnum", &xnum, 0) ||
		ihget("ynum", &ynum, 0) || ihget("dtype", &dtype, 1))
		gipserr();

	if (fp == stdin)
		ifile = "'stdin'";

	inull = ihget("dnull", &dnull, 0);
	dlen = ihdtype(dtype);
	inbuf = alloc(xnum, dlen);
	outbuf = (double *)alloc(xnum, sizeof(double));
	if (inbuf == NULL || outbuf == NULL)
		gipserr();
	count = total = totsq = 0;

	for (y = 0; y < ynum; y++) {
		if (fread(inbuf, dlen, xnum, fp) != xnum)
			gipserr2(GIPSBADREAD, ifile);
		if (gips(inbuf, outbuf, xnum, GIPS_R_VAL))
			gipserr();
		for (x = 0; x < xnum; x++)
			if (inull || outbuf[x] != dnull) {
				total += outbuf[x];
				totsq += outbuf[x] * outbuf[x];
				count++;
			}
	}
	ihbcl(fp);

	total /= count;
	totsq = totsq/count - total*total;

	printf("x=%d y=%d dmin=%g dmax=%g\n",
		xnum > 800 ? 800 : xnum,
		ynum > 800 ? 800 : ynum,
		total-2*totsq, total+2*totsq);
		
	if (Sflag)
		telltale(1);
	exit(0);
}
