: '%Z%$RCSfile: ihproj.sh,v $	GIPS $Revision: 2.6 $ (MIT/CSR) $Date: 1992/09/12 03:09:18 $

		   General Image Processing program
			   Peter G. Ford
		      Center for Space Research
	Copyright 1984,1987 Massachusetts Institute of Technology

	Module:		ihproj.sh	Creation Date:	12/15/87
	Version:	$Revision: 2.6 $		Update:		$Date: 1992/09/12 03:09:18 $
	Function:	Perform non-local transformation on general image
'

tmp=/tmp/ihp$$
fmt=ihgfmt
grid=ihgrid
geom=ihgeom
trans=

while [ $# -gt 0 ] ; do case $1 in
=)
	echo "Usage: ihproj -'n' [-DSfis] [-R fact] [-XY org] [-d dir] [-mo file]
	[-n order] [-pP lat] [-l lon,lat,rho] [-c lon,lat] [-r radius] [-bxy size] [name]"
	exit 0
	;;
[?])
	exec ihgrid '?'
	;;
-S)
	fmt="$fmt $1"
	grid="$grid $1"
	geom="$geom $1"
	;;
-[Df])
	grid="$grid $1"
	geom="$geom $1"
	;;
-s)
	grid="$grid $1"
	;;
-i)
	geom="$geom -x"
	;;
-[0-9]*)
	trans=$1
	;;
-d)
	if [ $# -eq 1 ] ; then echo "${0}: $1 arg missing" 1>&2 ; exit 1 ; fi
	tmp="$2/ihp$$"
	shift
	;;
-d*)
	tmp="`expr substr $1 3 100`/ihp$$"
	;;
-m)
	if [ $# -eq 1 ] ; then echo "${0}: $1 arg missing" 1>&2 ; exit 1 ; fi
	fmt="$fmt $1 '$2'"
	shift
	;;
-m*)
	fmt="$fmt -m '`expr substr $1 3 1000`'"
	;;
-[RXYbcnpPlrxy])
	if [ $# -eq 1 ] ; then echo "${0}: $1 arg missing" 1>&2 ; exit 1 ; fi
	grid="$grid $1 $2"
	shift
	;;
-[RXYbcnpPlrxy]*)
	grid="$grid $1"
	;;
-o)
	if [ $# -eq 1 ] ; then echo "${0}: $1 arg missing" 1>&2 ; exit 1 ; fi
	geom="$geom $1 $2"
	shift
	;;
-o*)
	geom="$geom $1"
	;;
-?*)
	echo "${0}: unknown flag: $1" 1>&2
	exit 1
	;;
*)
	fmt="$fmt $1"
	;;
esac
shift
done

if [ "$trans" = "" ] ; then
	echo "${0}: no transformation specified" 1>&2
	exit 1
fi
 
trap "/bin/rm -f $tmp" 0 1 2 15
eval $fmt -o $tmp && $grid $trans $tmp | $geom $tmp
