#include <stdio.h>
#include <stdlib.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# ifndef YYLMAX 
# define YYLMAX BUFSIZ
# endif 
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
#define YYISARRAY
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;

/* FILE *yyin = {stdin}, *yyout = {stdout}; */
FILE *yyin, *yyout; 

extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
#ifndef lint
static char *sccsid = "%Z%$RCSfile: locate.c,v $	GIPS $Revision: 1.1 $ (MIT/CSR) $Date: 2004/11/05 21:09:38 $";
#endif

# line 6 "locate.l"
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1986 Massachusetts Institute of Technology
**
**	Module:		locate.l	Creation Date:	03/19/86
**	Version:	$Revision: 1.1 $		Update:		$Date: 2004/11/05 21:09:38 $
**	Function:	Decode pixel location address
**	Components:	locate()	gipstool subroutine
*/

#undef	ECHO
#include	"gipstool.h"
	/*
	**	These defines redirect lex input to *yy_ptr
	*/
#undef	input
#define	input() (*yy_ptr ? *yy_ptr++ : 0)
#undef	output
#define	output(c) /* c */
#undef	unput
#define	unput(c) (yy_ptr > yy_buf ? (*--yy_ptr = c) : c)
#define	yywrap() (1)
	/*
	**	Following variables are referenced by the lex rules
	*/
static	char	*yy_buf;	/* pointer to address buffer */
static	char	*yy_ptr;	/* pointer to address buffer */
static	int	pix[2];		/* image pixel address */
static	char	coord_sw[2];	/* true if coord saved */
static	int	xy;		/* 0,1 for first,second address */
static	double	coord_xy[2];	/* saved realworld values */
extern	double	atof();		/* C library */
	/*
	**	Let yy_lex() parse the addresses into pix[].
	**	Then possibly pan the window to display that pixel
	*/
decode_address(buf, ie)
	char	*buf;			/* address string */
	Event	*ie;			/* event pointer */
{
	double	dd[2];			/* scratch */

	yy_ptr = yy_buf = buf;
	pix[0] = event_x(ie);
	pix[1] = event_y(ie);
	gipserrno = 0;
	coord_sw[0] = coord_sw[1] = 0;
	xy = -1;
	yylex();
	if (map_sw && (coord_sw[0] || coord_sw[1])) {
		if (coord_sw[0] != coord_sw[1])
			display_error_message("Illegal mixed coordinates", "");
		else if (g_map(coord_xy[0], coord_xy[1], dd))
			display_error_message("Coordinate outside image", "");
		else {
			pix[0] = dd[0]+0.5;
			pix[1] = dd[1]+0.5;
		}
	} else {
		if (coord_sw[0])
			(void)gips(&coord_xy[0], &pix[0], 1, GIPS_X_VAL);
		if (coord_sw[1])
			(void)gips(&coord_xy[1], &pix[1], 1, GIPS_Y_VAL);
	}
	if (gipserrno)
		return;
	if (xy != 1)
		display_error_message("Bad address", 0);
	else
		set_image_cursor(pix[0], pix[1], ie);
}
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

# line 83 "locate.l"
/* ignore whitespace surrounding text*/ ;
break;
case 2:

# line 85 "locate.l"
	/* absolute image address */ {
			if (++xy < 2) pix[xy] = atoi(yytext);
		}
break;
case 3:

# line 88 "locate.l"
	/* relative image address */ {
			if (++xy < 2) pix[xy] =
				RECT_TO_IMAGE(pix[xy],xy)+atoi(yytext);
		}
break;
case 4:

# line 92 "locate.l"
	/* absolute window address */ {
			if (++xy < 2) pix[xy] =
				RECT_TO_IMAGE(atoi(yytext+1), xy);
		}
break;
case 5:

# line 96 "locate.l"
	/* relative window address */ {
			if (++xy < 2) pix[xy] = RECT_TO_IMAGE(pix[xy] -
				atoi(yytext+1), xy);
		}
break;
case 6:

# line 100 "locate.l"
	/* relative window address */ {
			if (++xy < 2) pix[xy] = RECT_TO_IMAGE(pix[xy] +
				atoi(yytext+1), xy);
		}
break;
case 7:

# line 104 "locate.l"
case 8:

# line 105 "locate.l"
case 9:

# line 106 "locate.l"
/* RealWorld Address */ {
			if (++xy < 2)
				coord_xy[xy] = atof(yytext), coord_sw[xy]++;
		}
break;
case 10:

# line 110 "locate.l"
	/* Bad Value */ xy = 2;
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

10,
0, 

1,
10,
0, 

1,
0, 

10,
0, 

10,
0, 

2,
10,
0, 

10,
0, 

10,
0, 

10,
0, 

3,
0, 

8,
0, 

9,
0, 

2,
0, 

4,
0, 

5,
0, 

6,
0, 

8,
9,
0, 

7,
0, 

8,
0, 

9,
0, 

8,
9,
0, 
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
4,5,	4,5,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4,5,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
1,6,	0,0,	0,0,	1,7,	
2,7,	1,8,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,9,	
2,9,	1,10,	2,10,	1,11,	
2,11,	0,0,	0,0,	0,0,	
6,12,	1,3,	6,13,	6,13,	
6,13,	6,13,	6,13,	6,13,	
6,13,	6,13,	6,13,	6,13,	
7,14,	7,14,	7,14,	7,14,	
7,14,	7,14,	7,14,	7,14,	
7,14,	7,14,	8,15,	0,0,	
8,16,	8,16,	8,16,	8,16,	
8,16,	8,16,	8,16,	8,16,	
8,16,	8,16,	9,18,	9,18,	
9,18,	9,18,	9,18,	9,18,	
9,18,	9,18,	9,18,	9,18,	
8,17,	8,17,	10,19,	10,19,	
10,19,	10,19,	10,19,	10,19,	
10,19,	10,19,	10,19,	10,19,	
11,20,	11,20,	11,20,	11,20,	
11,20,	11,20,	11,20,	11,20,	
11,20,	11,20,	13,15,	14,21,	
14,21,	0,0,	0,0,	0,0,	
0,0,	17,24,	0,0,	17,24,	
8,17,	8,17,	17,25,	17,25,	
17,25,	17,25,	17,25,	17,25,	
17,25,	17,25,	17,25,	17,25,	
13,17,	13,17,	0,0,	0,0,	
0,0,	0,0,	0,0,	22,28,	
22,28,	0,0,	0,0,	14,21,	
14,21,	0,0,	15,22,	15,22,	
15,22,	15,22,	15,22,	15,22,	
15,22,	15,22,	15,22,	15,22,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
13,17,	13,17,	15,23,	15,23,	
21,26,	0,0,	21,26,	22,28,	
22,28,	21,27,	21,27,	21,27,	
21,27,	21,27,	21,27,	21,27,	
21,27,	21,27,	21,27,	23,29,	
0,0,	23,29,	0,0,	0,0,	
23,30,	23,30,	23,30,	23,30,	
23,30,	23,30,	23,30,	23,30,	
23,30,	23,30,	15,23,	15,23,	
24,25,	24,25,	24,25,	24,25,	
24,25,	24,25,	24,25,	24,25,	
24,25,	24,25,	26,27,	26,27,	
26,27,	26,27,	26,27,	26,27,	
26,27,	26,27,	26,27,	26,27,	
28,31,	0,0,	28,31,	0,0,	
0,0,	28,32,	28,32,	28,32,	
28,32,	28,32,	28,32,	28,32,	
28,32,	28,32,	28,32,	29,30,	
29,30,	29,30,	29,30,	29,30,	
29,30,	29,30,	29,30,	29,30,	
29,30,	31,32,	31,32,	31,32,	
31,32,	31,32,	31,32,	31,32,	
31,32,	31,32,	31,32,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+3,	0,		yyvstop+3,
yycrank+0,	yysvec+4,	yyvstop+6,
yycrank+22,	0,		yyvstop+8,
yycrank+32,	0,		yyvstop+10,
yycrank+44,	0,		yyvstop+12,
yycrank+54,	0,		yyvstop+15,
yycrank+66,	0,		yyvstop+17,
yycrank+76,	0,		yyvstop+19,
yycrank+0,	yysvec+7,	0,	
yycrank+88,	yysvec+6,	yyvstop+21,
yycrank+67,	yysvec+7,	yyvstop+23,
yycrank+122,	0,		yyvstop+25,
yycrank+0,	yysvec+8,	yyvstop+27,
yycrank+98,	0,		0,	
yycrank+0,	yysvec+9,	yyvstop+29,
yycrank+0,	yysvec+10,	yyvstop+31,
yycrank+0,	yysvec+11,	yyvstop+33,
yycrank+149,	0,		0,	
yycrank+95,	yysvec+15,	yyvstop+35,
yycrank+164,	0,		0,	
yycrank+176,	0,		0,	
yycrank+0,	yysvec+24,	yyvstop+38,
yycrank+186,	0,		0,	
yycrank+0,	yysvec+26,	yyvstop+40,
yycrank+201,	0,		0,	
yycrank+211,	0,		0,	
yycrank+0,	yysvec+29,	yyvstop+42,
yycrank+221,	0,		0,	
yycrank+0,	yysvec+31,	yyvstop+44,
0,	0,	0};
struct yywork *yytop = yycrank+278;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,  43,   1,  43,   1,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,  68,  68,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,  68,  68,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.11	97/01/06 SMI"

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
#ifdef YYISARRAY
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
#else
			if (yylastch >= &yytext[ yytextsz ]) {
				int	x = yylastch - yytext;

				yytextsz += YYTEXTSZINC;
				if (yytext == yy_tbuf) {
				    yytext = (char *) malloc(yytextsz);
				    memcpy(yytext, yy_tbuf, sizeof (yy_tbuf));
				}
				else
				    yytext = (char *) realloc(yytext, yytextsz);
				if (!yytext) {
				    fprintf(yyout,
					"Cannot realloc yytext\n");
				    exit(1);
				}
				yylastch = yytext + x;
			}
#endif
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
