#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)carith.c	4.2 (MIT/CSR) 01/22/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		carith.c	Creation Date:	12/29/83
 *	Version:	1.0		Update:		01/22/84
 *	Function:	Perform Comtal image frame arithmetic operations	
 *	Components:	main()		UNIX command
 */
#include	<stdio.h>
#include	"gips.h"
#include	<ctype.h>
#include	"doflags.h"

#define		BUFFER		4096

statop	char	*ddir initially "/tmp";	/* default scratch directory */
statop	flag	mflag;		/* report expanded arithmetic operation */
statop	flag	pflag;		/* write program to sysout - don't compile */
	/*
	 *	table used by doflags()
	 */
statop	flagentry	flagtable[] initially {
	"d",	"-> dir",	(flag *) &ddir,
	"m",	"1",			&mflag,
	"p",	"1",			&pflag,
	NULL,	"[C-language command(s)]",	NULL
};

statop	char	tmpl[]  initially "%s/caXXXXXX";	/* temporary files */
statop	char	tempo[100];			/* temporary filename */
statop	char	temp[102];			/* tempo with ".c" */

statop	char	buf[BUFFER];	/* reformatted arithmetic operation */
statop	char	iin[129];	/* input image switches - i(n) format */
statop	char	pin[129];	/* input image switches - p(n) format */
statop	char	iout[129];	/* output image switches = i(n) format */
statop	char	pout[129];	/* output image switches = p(n) format */
statop	FILE	*fcom;		/* comtal keyboard file */

extern	char	*index(), *sprintf(), *strcat(), *mktemp(), *strcpy();
/*
 *	interrupt handler - remove the scratch files and quit
 */
statop
onint()
{
	use(unlink(temp));
	use(unlink(tempo));
	return(0);
}

main(argc,argv,envp)

	int	argc;			/* number of arguments */
	char	**argv;			/* argument pointer array */
	char	**envp;			/* environment pointer array */
{
	int	xy	initially 0;	/* [x]/[y] notation is used */
	int	byte	initially 1;	/* byte=0,1 if inline im-,possible */
	int	paren	initially 0;	/* parenthesis level */
	int	equ	initially 0;	/* '=' was found */
	int	in;			/* input image number */
	int	out	initially 0;	/* output image number */
	int	pvec[2];		/* pipe for compiler stdout */
	int	pid initially 0;	/* compiler process number */
	register i;			/* scratch */

	regextra FILE *fp;		/* compiler input */
	register char *c;		/* input arithmetic argument pointer */
	register char *b initially buf;	/* output arithmetic string pointer */
	/*
	 *	parse the argument list
	 */
	saveargs(argv);
	argc = doflags(argc,argv,flagtable);
	if (argc <= 1)
		error("missing command(s)","");
	/*
	 *	parse the arithmetic string copying the result to b-> buf
	 */
	while (--argc)
		for (*b++ = ' ', c = *++argv; *c; *b++ = *c++)
			switch(*c) {
			case '[':
			case '(':	/* increase parenthesis level */
			case '{':
				++paren;
				break;
			case ']':
			case ')':
			case '}':
				paren--;
				break;
			case ';':	/* multiple statements */
				if (paren == 0)
					equ = 0;
				break;
			case '=':	 /* if compound operation,
					    cannot be inline code */
				if (index("%&*+-~|<>/",b[-1]) != NULL)
					byte = 0;
				if (paren == 0)
					equ++;
				break;
			case 'p':
				byte = 0;
			case 'i':	/* 'i' or 'p' variable */
				if (isalpha(c[-1]))
					break;
				if (isdigit(c[-1]))
					break;
				if (! isdigit(c[1]))
					break;
				if (sscanf(c+1,"%d",&in) != 1)
					break;
				if (in < 1 || in > 128)
					break;
				pin[in]++;
				if (*c == 'i')
					iin[in]++;
				if (equ == 0 && paren == 0) {
					pout[out=in]++;
					if (*c == 'i')
						iout[out]++;
					break;
				} else if (pout[in])
					byte = 0;
				break;
			case 'x':
			case 'y':
				xy = 1;
				break;
			default:
				break;
			}
	if (out == 0)
		error("no output plane specified","");
	/*
	 *	if arithmetic is to be executed immediately, check out the
	 *	Comtal device and the specific image planes requested.
	 *	Then reset interrupts to unlink the scratch files.
	 */
	if (! pflag) {
		if ((fcom = command_open()) == NULL)
			gipserr();
		for (i = 1; i < 129; i++) {
			regextra int fildes;
			if (pin[i])
				if ((fildes = image_open(i,0)) < 0)
					gipserr();
				else
					use(close(fildes));
		}
		use(strcpy(temp,mktemp(sprintf(tempo,tmpl,ddir))));
		use(strcat(temp,".c"));
		/*
	 	*	trap all interrupts
	 	*/
		gipsint(onint);
		if (freopen(temp,"w",stdout) == NULL)
			gipserr2(GIPSBADOPEN,temp);
		use(chmod(temp,0600));
	}
	/*
	 *	generate the C-program source.
	 *	for '-p' option, it goes to stdout, otherwise to temp
	 */
	if (byte) printf("#include\t<stdio.h>\n");
	printf("main()\n");
	printf("{\n");
	/*
	 *	for in-line operation, comard() returns FILE pointer to image
	 *	otherwise, it returns pointer to COLS x ROWS image array
	 */
	printf("\tchar\t*comard();\n");
	for (i = 1; i < 129; i++) if (pin[i]) 
		if (byte) printf(
			"\tregister FILE *f%d = (FILE *)comard(%d,%d);\n",
				i,i,iout[i] ? 1 : 0);
		else printf(
"\tregister unsigned char (*p%d)[%d] = (unsigned char(*)[%d])comard(%d,2);\n",
			i,COLS,COLS,i);
	if (xy || ! byte)	{
		printf("\tregister int x, y;\n");
		printf("\tfor (y=0; y<%d; y++) for (x=0; x<%d; x++) {\n",
			ROWS,COLS);
	} else {
		printf("\tregister int x = %d;\n",NIMAGE);
		printf("\twhile (--x >= 0) {\n");
	}
	for (i = 1; i < 129; i++) if (pin[i])
		if (! byte)
			printf("\t\tregister int i%d = p%d[y][x];\n",i,i);
		else if(iout[i])
			printf("\t\tregister int i%d = 0;\n",i);
		else
			printf("\t\tregister int i%d = getc(f%d);\n",i,i);
	printf("\t\t%s;\n",buf+1);
	if (out)
		for (i = 1; i < 129; i++) if (iout[i])
			if (byte)
				printf("\t\tputc(i%d,f%d);\n",i,i);
			else
				printf("\t\tp%d[y][x]=i%d;\n",i,i);
	printf("\t}\n");
	/*
	 *	comawr() writes COLS x ROWS image array to Comtal image plane
	 */
	for (i = 1; i < 129; i++)
		if (byte && pin[i])
			printf("\tfclose(f%d);\n",i,i);
		else if ((! byte) && pout[i])
			printf("\tcomawr(p%d,%d);\n",i,i);
	/*
	 *	comapr() writes completion message to user
	 */
	if (mflag)
		printf("\tcomapr(\"%s\");\n",buf+1);
	printf("}\n");

	if (pflag)
		exit(TAMEEXITVAL);
	use(fclose(stdout));
	use(fclose(fcom));
	/*
	 *	execute C-compiler to create temporary module 'tempo'
	 *	piping back 'stderr'
	 */
	if (pipe(pvec) >= 0 && (pid = fork()) == 0) {
		use(close(2));
		use(dup(pvec[1]));
		use(close(pvec[0]));
		use(close(1));
		use(open("/dev/null",1));
		use(close(0));
		use(dup(1));
		execle("/bin/csh","csh","-c",
			sprintf(buf,"cc -O -o %s %s -lC -lGI -lm",tempo,temp),
			0,envp);
	}
	if (pid <= 0)
		error("can't compile","");
	use(close(pvec[1]));
	/*
	 *	read stderr pipe (should be blank) and format an error message
	 */
	if ((fp = fdopen(pvec[0],"r")) == NULL)
		error("open error on pipe","");
	for (c = buf; fgets(c,sizeof(buf),fp) != NULL; )
		if (c == buf)
			c EQ_PLUS strlen(c)+1;
	use(fclose(fp));
	if (c != buf)
		error("compiler error: %s",
			((c = index(buf,':')) == NULL) ? buf : c+2);
	/*
	 *	execute the compiled source
	 */
	use(system(tempo));
	use(onint());
	use(exit(TAMEEXITVAL));
}
