#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)cfont.c	4.2 (MIT/CSR) 01/24/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		cfont.c		Creation Date:	12/29/83
 *	Version:	1.0		Update:		01/24/84
 *	Function:	Display Berkeley font on graphic plane
 *	Components:	main()		UNIX command
 */
#include	<stdio.h>
#include	"gips.h"
#include	"doflags.h"

statop	char	*font	initially "R.8";	/* name of font */
statop	int	color	initially 15;		/* color of displayed graphic */
statop	int	plane	initially 1;		/* graphic plane number */
	/*
	 *	table used by doflags()
	 */
statop	flagentry	flagtable[] initially {
	"f",	"-> font",	(flag *) &font,
	"c",	"%d color",	(flag *) &color,
	"g",	"%d #plane",	(flag *) &plane,
	NULL,	NULL,		NULL
};

extern	char	*sprintf();

main(argc,argv)

	int	argc;			/* argument count */
	char	**argv;			/* array of argument pointers */
{
	char	*graphic;		/* incore graphic plane */
	char	buf[45];		/* graphic plane feature name */
	int	dline	initially 0;	/* line increment */
	int	dcol	initially 0;	/* column increment */
	int	fildes;			/* scratch */
	int	nbytes;			/* scratch */
	regextra line	initially 255;	/* starting line number */
	register col	initially 255;	/* starting column number */
	register ch	initially 0;	/* font character */
	register char *c;		/* pointer to graphic plane */
	/*
	 *	save and verify callers arguments
	 */
	saveargs(argv);
	argc = doflags(argc,argv,flagtable);
	if (argc > 1)
		error("illegal argument: %s",*++argv);
	/*
	 *	read font definition file
	 */
	if (! setfont(font))
		error("bad font: %s",font);
	/*
	 *	verify that the graphic plane is addressable
	 */
	if (color_put(plane,color))
		gipserr();
	/*
	 *	allocate graphic plane, and indicate byte-swap required
	 */
	graphic = alloc(NGRAPH,sizeof(char));
	use(settype(GRAPHIC));
	use(setink(0377));
	/*
	 *	if font is rotated, fix up column and row indices
	 */
	if (font[strlen(font)-1] == 'r')
		{ col = COLS+25; dcol = -50; }
	else	{ line = -25; dline = 50; }
	/*
	 *	write 128 characters into the graphic plane
	 */
	for (c = font, ch = 0; ch <= 0200; *c = '\0', c = buf)
		if (memmarker(graphic,ROWS,COLS,
				line EQ_PLUS dline,col EQ_PLUS dcol,c)) 
			for (c = buf; c < buf+16; ch++) 
				*c++ = (ch == 0 || ch == 0177) ? ' ' : ch; 
		else	error("bad font: %s",font);
	/*
	 *	write the graphic to the graphic plane with byte-swap
	 */
	if ((fildes = graphic_open(plane,1)) < 0)
		gipserr();
	nbytes = write(fildes,graphic,NGRAPH);
	use(close(fildes));
	if (nbytes != NGRAPH)
		gipserr1(GIPSBADWRITE);
}
