#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)comcat.c	4.2 (MIT/CSR) 11/21/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		comcat.c	Creation Date:	12/29/83
 *	Version:	1.0		Update:		11/21/84
 *	Function:	Filter troff output to graphic plane
 *	Components:	main()		UNIX command
 */
#include	<stdio.h>
#include	"gips.h"
#include	<vfont.h>
#include	"doflags.h"
	/*
	 * Cat Simulator for Comtal
	 */ 
#define		DISPATCHSIZE	256	/* must be a power of two */
#define 	NFONTS		25
#define		SPECIALFONT	3
#define		DSIZ		((sizeof *dispatch)*DISPATCHSIZE)
#define		MAXF		4
#define		CONVERT(n)	(n*(200./432.))
#define		RECONVERT(n)	(n*(432./200.))
#define		BYTES_PER_LINE	(COLS/8)

statop	char	*fontname[MAXF] initially {
	"R",	"I",	"B",	"S"
};

statop	flagentry	flagtable[] initially {
	"1",	"-> font",	(flag *) &fontname[0],
	"2",	"-> font",	(flag *) &fontname[1],
	"3",	"-> font",	(flag *) &fontname[2],
	"4",	"-> font",	(flag *) &fontname[4],
	NULL,	NULL,		NULL
};

statop	char	buffer[NGRAPH];	/* Big line buffers  */
statop	char	*buf0p initially &buffer[0];	/* origin in circular buffer  */

statop	char	*calloc();
statop	char	*allpanic();

statop	struct	header	header;
statop	struct	dispatch *dispatch;

statop	struct	fontdes {
	int	fnum;
	int	psize;
	struct	dispatch *disp;
	char	*bits;
} fontdes[NFONTS] initially {
	-1,
	-1
};

statop	struct point_sizes {
	int	stupid_code;
	int	real_code;
} point_sizes[] initially {
	010,	6,	0,	7,	01,	8,	07,	9,
	02,	10,	03,	11,	04,	12,	05,	14,
	0211,	16,	06,	18,	0212,	20,	0213,	22,
	0214,	24,	0215,	28,	0216,	36,	0,	0
};

statop	int	lines;
statop	int	fildes		initially 1;
statop	int	cfnum		initially -1;
statop	int	cpsize		initially 10;
statop	int	cfont		initially 1;
statop	int	nfontnum	initially -1;
statop	int	fontwanted	initially 1;
statop	int	npsize		initially 10;
statop	int	last_ssize	initially 02;
statop	int	xpos, ypos;
statop	int	esc, lead, back, verd, mcase, railmag;
statop	double	row, col;
statop	char	*bits;
statop	char	fontdir[] initially GIPSFONTDIR;
statop	int	initialized;

statop	char	asctab[128] initially {
	'\0',	/*blank*/
	'h',	/*h*/
	't',	/*t*/
	'n',	/*n*/
	'm',	/*m*/
	'l',	/*l*/
	'i',	/*i*/
	'z',	/*z*/
	's',	/*s*/
	'd',	/*d*/
	'b',	/*b*/
	'x',	/*x*/
	'f',	/*f*/
	'j',	/*j*/
	'u',	/*u*/
	'k',	/*k*/
	'\0',	/*blank*/
	'p',	/*p*/
	'\06',	/*_ 3/4 em dash*/
	';',	/*;*/
	'\0',	/*blank*/
	'a',	/*a*/
	'\05',	/*rule*/
	'c',	/*c*/
	'`',	/*` open*/
	'e',	/*e*/
	'\'',	/*' close*/
	'o',	/*o*/
	'\021',	/*1/4*/
	'r',	/*r*/
	'\022',	/*1/2*/
	'v',	/*v*/
	'-',	/*- hyphen*/
	'w',	/*w*/
	'q',	/*q*/
	'/',	/*/*/
	'.',	/*.*/
	'g',	/*g*/
	'\023',	/*3/4*/
	',',	/*,*/
	'&',	/*&*/
	'y',	/*y*/
	'\0',	/*blank*/
	'%',	/*%*/
	'\0',	/*blank*/
	'Q',	/*Q*/
	'T',	/*T*/
	'O',	/*O*/
	'H',	/*H*/
	'N',	/*N*/
	'M',	/*M*/
	'L',	/*L*/
	'R',	/*R*/
	'G',	/*G*/
	'I',	/*I*/
	'P',	/*P*/
	'C',	/*C*/
	'V',	/*V*/
	'E',	/*E*/
	'Z',	/*Z*/
	'D',	/*D*/
	'B',	/*B*/
	'S',	/*S*/
	'Y',	/*Y*/
	'\0',	/*blank*/
	'F',	/*F*/
	'X',	/*X*/
	'A',	/*A*/
	'W',	/*W*/
	'J',	/*J*/
	'U',	/*U*/
	'K',	/*K*/
	'0',	/*0*/
	'1',	/*1*/
	'2',	/*2*/
	'3',	/*3*/
	'4',	/*4*/
	'5',	/*5*/
	'6',	/*6*/
	'7',	/*7*/
	'8',	/*8*/
	'9',	/*9*/
	'*',	/***/
	'\04',	/*minus*/
	'\01',	/*fi*/
	'\02',	/*fl*/
	'\03',	/*ff*/
	'\020',	/* cent sign */
	'\012',	/*ffl*/
	'\011',	/*ffi*/
	'(',	/*(*/
	')',	/*)*/
	'[',	/*[*/
	']',	/*]*/
	'\013',	/* degree */
	'\014',	/* dagger */
	'=',	/*=*/
	'\017',	/* registered */
	':',	/*:*/
	'+',	/*+*/
	'\0',	/*blank*/
	'!',	/*!*/
	'\07',	/* bullet */
	'?',	/*?*/
	'\015',	/*foot mark*/
	'|',	/*|*/
	'\0',	/*blank*/
	'\016',	/* copyright */
	'\010',	/* square */
	'$',	/*$*/
	'\0',
	'\0',
	'"',	/*"*/
	'#',	/*#*/
	'<',	/*<*/
	'>',	/*>*/
	'@',	/*@*/
	'\\',	/*\\*/
	'^',	/*^*/
	'{',	/*{*/
	'}',	/*}*/
	'~'	/*~*/
};

statop	char spectab[128] initially {
	'\0',	/*blank*/
	'w',	/*psi*/
	'h',	/*theta*/
	'm',	/*nu*/
	'l',	/*mu*/
	'k',	/*lambda*/
	'i',	/*iota*/
	'f',	/*zeta*/
	'r',	/*sigma*/
	'd',	/*delta*/
	'b',	/*beta*/
	'n',	/*xi*/
	'g',	/*eta*/
	'u',	/*phi*/
	't',	/*upsilon*/
	'j',	/*kappa*/
	'\0',	/*blank*/
	'p',	/*pi*/
	'@',	/*at-sign*/
	'7',	/*down arrow*/
	'\0',	/*blank*/
	'a',	/*alpha*/
	'|',	/*or*/
	'v',	/*chi*/
	'"',	/*"*/
	'e',	/*epsilon*/
	'=',	/*=*/
	'o',	/*omicron*/
	'4',	/*left arrow*/
	'q',	/*rho*/
	'6',	/*up arrow*/
	's',	/*tau*/
	'_',	/*underrule*/
	'\\',	/*\*/
	'W',	/*Psi*/
	'\07',	/*bell system sign*/
	'\001',	/*infinity*/
	'c',	/*gamma*/
	'\002',	/*improper superset*/
	'\003',	/*proportional to*/
	'\004',	/*right hand*/
	'x',	/*omega*/
	'\0',	/*blank*/
	'(',	/*gradient*/
	'\0',	/*blank*/
	'U',	/*Phi*/
	'H',	/*Theta*/
	'X',	/*Omega*/
	'\005',	/*cup (union)*/
	'\006',	/*root en*/
	'\014',	/*terminal sigma*/
	'K',	/*Lambda*/
	'-',	/*minus*/
	'C',	/*Gamma*/
	'\015',	/*integral sign*/
	'P',	/*Pi*/
	'\032',	/*subset of*/
	'\033',	/*superset of*/
	'2',	/*approximates*/
	'y',	/*partial derivative*/
	'D',	/*Delta*/
	'\013',	/*square root*/
	'R',	/*Sigma*/
	'1',	/*approx =*/
	'\0',	/*blank*/
	'>',	/*>*/
	'N',	/*Xi*/
	'<',	/*<*/
	'\016',	/*slash (longer)*/
	'\034',	/*cap (intersection)*/
	'T',	/*Upsilon*/
	'\035',	/*not*/
	'\023',	/*right ceiling (rt of ")*/
	'\024',	/*left top (of big curly)*/
	'\017',	/*bold vertical*/
	'\030',	/*left center of big curly bracket*/
	'\025',	/*left bottom*/
	'\026',	/*right top*/
	'\031',	/*right center of big curly bracket*/
	'\027',	/*right bot*/
	'\021',	/*right floor (rb of ")*/
	'\020',	/*left floor (left bot of big sq bract)*/
	'\022',	/*left ceiling (lt of ")*/
	'*',	/*multiply*/
	'/',	/*divide*/
	'\010',	/*plus-minus*/
	'\011',	/*<=*/
	'\012',	/*>=*/
	'0',	/*identically equal*/
	'3',	/*not equal*/
	'{',	/*{*/
	'}',	/*}*/
	'\'',	/*' acute accent*/
	'\`',	/*` grave accent*/
	'^',	/*^*/
	'#',	/*sharp*/
	'\036',	/*left hand*/
	'\037',	/*member of*/
	'~',	/*~*/
	'z',	/*empty set*/
	'\0',	/*blank*/
	'Y',	/*dbl dagger*/
	'Z',	/*box rule*/
	'9',	/*asterisk*/
	'[',	/*improper subset*/
	']',	/*circle*/
	'\0',	/*blank*/
	'+',	/*eqn plus*/
	'5',	/*right arrow*/
	'8'	/*section mark*/
};

main(argc, argv) 

	int	argc;
	char	**argv;
{
	register int c;

	saveargs(argv);
	argc = doflags(argc,argv,flagtable);
	if (argc > 1) error("bad arg: %s",*++argv);
	while ((c = getchar()) != EOF) {
		if (!c) continue;
		if (c & 0200) { esc EQ_PLUS (~c) & 0177; continue; }
		if (esc) {
			if (back) esc = -esc;
			col EQ_PLUS esc;
			ypos = CONVERT(col);
			esc = 0;
		}
		if ((c & 0377) < 0100)
			use(outc((c & 077) | mcase));
		else if (c == 0100) {
			if (initialized) { slop_lines(ROWS); exit(TAMEEXITVAL); }
			initialized = 1;
			row = 25;
			xpos = CONVERT(row);
			for (c = 0; c < NGRAPH; c++) buffer[c] = 0;
			ypos= col= esc= lead= verd= back= mcase= railmag= 0;
			loadfont(railmag, cpsize);
		} else if (c < 0100 || c > 0117) {
			if ((c & 0340) == 0140)	/* leading */ {
				lead = (~c) & 037;
				if (verd) lead = -lead;
				row EQ_PLUS lead*3;	/*  Lead is 3 units  */
				c = CONVERT(row);
				while (c >= ROWS) {
					slop_lines(15);
					c = CONVERT(row);
				}
				xpos = c;
			} else	if ((c & 0360) == 0120)	/* size change */
				loadfont(railmag, findsize(c & 017));
			else	if (!(c & 0300))
				use(outc((c & 077) | mcase));
		} else	switch (c) {
		case 0101:	/* lower rail */
			crail(railmag EQ_AND ~01);
			break;
		case 0102:	/* upper rail */
			crail(railmag EQ_OR 01);
			break;
		case 0103:	/* upper mag */
			crail(railmag EQ_OR 02);
			break;
		case 0104:	/* lower mag */
			crail(railmag EQ_AND ~02);
			break;
		case 0105:	/* lower case */
			mcase = 0;
			break;
		case 0106:	/* upper case */
			mcase = 0100;
			break;
		case 0107:	/* escape forward */
			back = 0;
			break;
		case 0110:	/* escape back */
			back = 1;
			break;
		case 0111:	/* stop */
			break;
		case 0112:	/* lead forward */
			verd = 0;
			break;
		case 0113:	/* undefined */
			break;
		case 0114:	/* lead backward */
			verd = 1;
			break;
		case 0115:	/* undefined */
		case 0116:	/* undefined */
		case 0117:	/* undefined */
			break;
		}
	}
	slop_lines(ROWS);
	exit(TAMEEXITVAL);
}

statop	int findsize(code)
register int code;
{
	register struct point_sizes *psp;

	for (psp = point_sizes; psp->real_code != 0; psp++)
		if ((psp->stupid_code & 017) == code) break;
	if (!(last_ssize & 0200) && (psp->stupid_code & 0200)) code = -55;
	else if ((last_ssize & 0200) && !(psp->stupid_code & 0200)) code = 55;
	else code = 0;
	esc EQ_PLUS back ? -code : code;
	last_ssize = psp->stupid_code;
	return(psp->real_code);
}

statop	crail(nrail)
register int nrail;
{
	loadfont(nrail,(fontwanted && cpsize != npsize) ? npsize : cpsize);
}


statop	loadfont(fnum, size)
register int fnum, size;
{
	register int i;

	fontwanted = 0;
	if (fnum == cfnum && size == cpsize) return;
	for (i = 0; i < NFONTS; i++)
		if (fontdes[i].fnum == fnum && fontdes[i].psize == size) {
			cfnum = fontdes[i].fnum;
			cpsize = fontdes[i].psize;
			dispatch = &fontdes[i].disp[0];
			bits = fontdes[i].bits;
			cfont = i;
			return;
		}
	if (fnum < 0 || fnum >= MAXF)
		error("Internal error: illegal font","");
	nfontnum = fnum;
	npsize = size;
	fontwanted++;
}


statop	getfont()
{
	register int font, d;
	register char *fbuf;
	char	cbuf[BUFSIZ], *falloc(), *sprintf();

	if (!fontwanted) return;
	use(sprintf(cbuf, "%s%s.%d", fontdir, fontname[nfontnum], npsize));
	if (((font = open(fbuf=cbuf+sizeof(fontdir)-1, 0)) == -1 &&
			(font = open(fbuf=cbuf, 0)) == -1) ||
			read(font, (char *) &header, sizeof header) !=
			    sizeof header || header.magic != 0436)
		error("Bad font file: %s", fbuf);
	cfont = relfont();
	if ((bits = falloc((int)(header.size+DSIZ+1))) == NULL)
		error("ran out of memory: %s", fbuf);
	d = (int) bits+header.size;
	d EQ_PLUS 1;
	d EQ_AND ~1;
	if (read(font, (char *) d, DSIZ) != DSIZ ||
		read(font, bits, (int) header.size) != header.size)
		error("bad font header: %s",fbuf);
	use(close(font));
	cfnum = fontdes[cfont].fnum = nfontnum;
	cpsize = fontdes[cfont].psize = npsize;
	fontdes[cfont].bits = bits;
	fontdes[cfont].disp = (struct dispatch *) d;
	dispatch = &fontdes[cfont].disp[0];
	fontwanted = 0;
}

int lastloaded	= -1;

statop	int relfont()
{
	register int newfont;

	newfont = lastloaded;
	if (fontdes[cfont].fnum != SPECIALFONT || fontdes[cfont].bits == 0)
		if (++newfont>=NFONTS) newfont = 0;
	lastloaded = newfont;
	if ((int) fontdes[newfont].bits != -1 && fontdes[newfont].bits != 0)
		Free(fontdes[newfont].bits);
	fontdes[newfont].bits = 0;
	return(newfont);
}

statop	char *falloc(nbytes)
register int nbytes;
{
	register int i;
	register char *buf;

	if ((buf = calloc((arg4alloc)nbytes,1)) != NULL) return(buf);
	lastloaded = cfont;
	for (i = 0; i <= NFONTS; i++) {
		if (fontdes[i].bits != (char *) -1 &&
				fontdes[i].bits != (char *) 0)
			Free(fontdes[i].bits);
		fontdes[i].fnum = fontdes[i].psize = -1;
		fontdes[i].bits = 0;
		cfnum = cpsize = -1;
	}
	return(calloc((arg4alloc)nbytes,1));
}

statop	int	M[] initially { 0xffffffff, 0xfefefefe, 0xfcfcfcfc, 0xf8f8f8f8,
			0xf0f0f0f0, 0xe0e0e0e0, 0xc0c0c0c0, 0x80808080, 0x0 };
statop	int	N[] initially { 0x00000000, 0x01010101, 0x03030303, 0x07070707,
			0x0f0f0f0f, 0x1f1f1f1f, 0x3f3f3f3f, 0x7f7f7f7f, 0xffffffff };
statop	int	strim[] initially {
			0xffffffff, 0xffffff00, 0xffff0000, 0xff000000, 0 };

statop
outc(code)

	int	code;
{
	char	c;			/* character to print */
	int	llen;			/* length of each font line */
	int	nlines;			/* number of font lines */
	int	scanp_inc;		/* increment to start of next buffer */
	int	offset;			/* bit offset to start of font data */
	regextra char	*scanp;		/* ptr to output buffer */
	regextra struct	dispatch *d;	/* ptr to character font record */
	regextra char	*addr;		/* addr of font data */
	register int	count;		/* font data ptr */
	register unsigned fontdata;	/* font data temporary */
	register int	off8;		/* offset + 8 */

	if (fontwanted) getfont();
	if (railmag == SPECIALFONT) {
		if ((c = spectab[code]) < 0) return(0);
	} else if ((c = asctab[code]) < 0) return(0);

	if ((d = dispatch+c)->nbytes == 0) return(0);
	addr = bits+d->addr;
	llen = (d->left+d->right+7)/8;
	nlines = d->up+d->down;
	if (xpos+d->down >= ROWS) slop_lines(xpos+d->down-ROWS+1);
	scanp = ((xpos-d->up-1)*BYTES_PER_LINE+(ypos-d->left)/8)+buf0p;
	if (scanp < &buffer[0]) scanp EQ_PLUS NGRAPH;
	scanp_inc = BYTES_PER_LINE-llen;
	offset = -((ypos-d->left)&07);
	off8 = offset+8;
	while (nlines--) {
		if (scanp >= &buffer[NGRAPH]) scanp EQ_MINUS NGRAPH;
		count = llen;
		if (scanp + count <= &buffer[NGRAPH])
			do {
				fontdata = *(unsigned *)addr;
				addr EQ_PLUS 4;
				if (count < 4) fontdata EQ_AND ~strim[count];
				*(unsigned *)scanp EQ_OR
					(fontdata << offset) &~ M[off8];
				scanp++;
				*(unsigned *)scanp EQ_OR
					(fontdata << off8) &~ N[off8];
				scanp EQ_PLUS 3;
				count EQ_MINUS 4;
			} while (count > 0);
		scanp EQ_PLUS scanp_inc+count;
		addr EQ_PLUS count;
	}		
	return(1);
}

statop	int slop_lines(nlines)
int	nlines;
{
	register int rlines;

	lines EQ_PLUS nlines;
	rlines = (&buffer[NGRAPH] - buf0p) / BYTES_PER_LINE;
	if (rlines < nlines) {
		if (write(fildes, buf0p, BYTES_PER_LINE * rlines) < 0)
			error("write error","");
		clear(buf0p, rlines * BYTES_PER_LINE);
		buf0p = buffer;
		nlines EQ_MINUS rlines;
		xpos EQ_MINUS rlines;
		row EQ_MINUS RECONVERT(rlines);
	}
	if (write(fildes, buf0p, BYTES_PER_LINE * nlines) < 0)
		error("write error","");
	clear(buf0p, BYTES_PER_LINE * nlines);
	buf0p EQ_PLUS BYTES_PER_LINE * nlines;
	if (buf0p >= &buffer[NGRAPH]) buf0p EQ_MINUS NGRAPH;
	xpos EQ_MINUS nlines;
	row EQ_MINUS RECONVERT(nlines);
}
