#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)comstat.c	4.2 (MIT/CSR) 01/21/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		comstat.c	Creation Date:	12/29/83
 *	Version:	1.0		Update:		01/21/84
 *	Function:	Return status of Comtal and its image and graphic
 *			planes.
 *	Components:	main()		UNIX command
 */
#include	"stdio.h"
#include	"comsubs.h"
#include	"comtal.h"
#include	"gips.h"
#include	"doflags.h"

#define		NIMAGES		8	/* highest defined image plane */
#define		NGRAPHICS	8	/* highest defined graphic plane */
#define		MAXIM		8	/* highest contiguous image plane */
#define		MAXGR		8	/* highest contiguous graphic plane */

statop	flag	aflag;		/* -a  -- display everything */
statop	flag	fflag;		/* -f  -- display real filenames only */
statop	flag	tflag;		/* -t  -- display totals only */
statop	flag	iflag;		/* -i  -- display image stats */
statop	flag	gflag;		/* -g  -- display graphic stats */
statop	flag	qflag;		/* -q  -- just return with exit code */
statop	int	nunit;		/*  -_  -- select a plane */
statop	char	*station initially "";	/* -s  -- set station code a,b,c etc */
	/*
	 *	table used by doflags()
	 */
statop	flagentry flagtable[] initially {
	"s",	"-> station",	(flag *) &station,
	"a",	"1",		&aflag,
	"f",	"1",		&fflag,
	"t",	"1",		&tflag,
	"i",	"1",		&iflag,
	"g",	"1",		&gflag,
	"q",	"1",		&qflag,
	"",	"%d plane",	(flag *) &nunit,
	NULL
};

statop	char *colors[] initially {
	"black",	"red",		"dark green",	"orange",
	"forest gr.",	"lt. orange",	"green",	"yellow",
	"blue",		"magenta",	"dk. turq.",	"pink",
	"turquoise",	"light pink",	"cyan",		"white"
};

statop	char *zooms[] initially { "x1", "??", "x4", "x2" };
statop	char *yn[] initially { "\tno", "\tyes" };
statop	char *tab3 initially "\t\t\t  ";
	/*
	 *	argument list used by error() in libIH.a
	 */
extern	char	*sprintf();

statop	char *tit[] initially {
	"IMAGE\tDEFN\tSET\tCOL\tGRAPH\tVIRT\tCOLOR\tQUAD\tWINDOW\n",
	"IMAGE TOT   DIR   SIZE   COMPONENTS    DISPLAY ZM   X-MAX-Y   WINDOW\n",
	"GRAPH TOT   DIR   SIZE      COLOR      DISPLAY ZM   X-MAX-Y   WINDOW\n"
};

main(argc,argv)

	int	argc;		/* number of arguments */
	char	**argv;		/* argument pointer array */
{
	istat	is;		/* image status block */
	gstat	gs;		/* graphic status block */
	register i;		/* scratch */
	register fid;		/* fileno of Comtal feature */
	char	name[15];	/* name of Comtal feature */
	/*
	 *	scan argument list
	 */
	saveargs(argv);
	argc = doflags(argc,argv,flagtable);
	if (nunit < 0 || nunit > NIMAGES)
		error("bad unit: %d",(char *)nunit);
	if (fflag)
		if (aflag || tflag || iflag || gflag || qflag)
			error("-f conflict","");
		else
			;
	else if (aflag)
		tflag = iflag = gflag = 1;
	else if (! fflag && ! gflag && ! iflag)
		tflag = 1;
	/*
	 *	try opening the Comtal keyboard buffer
	 *	if it fails, report it
	 *	for '-q', that's all there is
	 */
	if ((fid = open(sprintf(name,"/dev/command%.1s",station),1)) < 0)
		if (qflag)
			exit(WILDEXITVAL);
		else if (*station)
			error("Comtal station '%s' busy or not assigned to you",
				station);
		else
			error("Comtal busy or not assigned to you","");
	else
		if (qflag)
			exit(TAMEEXITVAL);
	/*
	 *	'-f' option: report available planes
	 */	
	if (fflag) {
		for (i = 1; i <= NIMAGES; ++i)
			if (nunit > 0 && i != nunit)
				;
			else if (cstat("image",i,(char*)&is) == COMTAME &&
					! is.is_status.assignedto)
				printf(" i.%d f.%d",i,i);
			else if (i > MAXIM)
				break;
		for (i = 1; i <= NGRAPHICS; ++i)
			if (nunit > 0 && i != nunit)
				;
			else if (cstat("graphic",i,(char*)&gs) == COMTAME &&
					gs.gs_status.defined)
				printf(" g.%d",i);
			else if (i > MAXGR)
				break;
		printf("\n");
		exit(TAMEEXITVAL);
	}
	/*
	 *	report general info about image planes
	 */
	if (tflag)
		for (i = 1, printf(tit[0]); i <= NIMAGES; ++i)
			if (nunit > 0 && i != nunit)
				;
			else if (cstat("image",i,(char *)&is) == COMTAME
					&& is.is_status.defined)
				printf("%-3d%s%s%s%s%s%s%s%s\n",i,
				yn[is.is_status.defined],
				yn[is.is_status.set],
				yn[is.is_status.iscolor],
				yn[is.is_status.isagraphic],
				yn[is.is_status.assignedto],
				yn[is.is_status.inacolor],
				yn[is.is_status.inaquad],
				yn[is.is_status.windowed]);
			else if (! aflag && i > MAXIM)
				break;
	/*
	 *	report details of image planes
	 */
	if (iflag) for (i = 1, printf(tit[1]); i <= NIMAGES; ++i)
		if (nunit > 0 && i != nunit)
			;
		else if (cstat("image",i,(char *)&is) == COMTAME) {
			printf("%3d %5d %5d %4dx%-4d ",i,
				is.is_mems, is.is_xmems,
				is.is_size.xy_x, is.is_size.xy_y);

			if (is.is_status.iscolor)
				printf("red:%-6d ",is.is_redimage);
			else	
				printf(is.is_status.assignedto ?
					"upleft:%-3d " : "none       ",
					is.is_ulimage);

			printf("%4d %4d %2s %4d %4d",is.is_shownx,
				is.is_showny, zooms[is.is_zoom],
				is.is_maximum.xy_x, is.is_maximum.xy_y);

			printf(is.is_status.windowed ?
				" %4d %4d %4d %4d\n" : "\n",
				is.is_ulwindow.xy_x,is.is_ulwindow.xy_y,
				is.is_lrwindow.xy_x,is.is_lrwindow.xy_y);

			if (is.is_status.iscolor)
				printf("%sgreen:%d\n%sblue:%d\n",
					tab3,is.is_greenimage,
					tab3,is.is_blueimage);
			else if (is.is_status.assignedto)
				printf(
				"%supright:%d\n%sloleft:%d\n%sloright:%d\n",
				tab3,is.is_urimage,
				tab3,is.is_llimage,
				tab3,is.is_lrimage);
		} else if (! aflag && i > MAXIM)
			break;
	/*
	 *	report details of graphics planes
	 */
	if(gflag) for (i = 1, printf(tit[2]); i <= NGRAPHICS; ++i)
		if (nunit > 0 && i != nunit)
			;
		else if (cstat("graphic",i,(char *)&gs) == COMTAME
				&& gs.gs_status.defined) {

			printf("%3d %5d %5d %4dx%-4d %-10.10s ",
				i, gs.gs_mems, gs.gs_xmems,
				gs.gs_size.xy_x, gs.gs_size.xy_y,
				colors[(gs.gs_color >> 3) & 017]);

			printf("%4d %4d %2s %4d %4d",
				gs.gs_shownx, gs.gs_showny,
			 	zooms[gs.gs_zoom], gs.gs_maximum.xy_x,
				gs.gs_maximum.xy_y);

			printf(gs.gs_status.windowed ?
				" %4d %4d %4d %4d\n" : "\n",
				gs.gs_ulwindow.xy_x, gs.gs_ulwindow.xy_y,
				gs.gs_lrwindow.xy_x, gs.gs_lrwindow.xy_y);
		} else if (! aflag && i > MAXGR)
			break;
	use(close(fid));
	exit(TAMEEXITVAL);
}
/*
 *	return Comtal status block 'tab' for feature 'dev' number 'i'
 */
statop
cstat(dev,i,tab)

	register char *dev;
	register char *tab;
	register i;
{
	char	name[50];

	use(sprintf(name,"/dev/%s%s.%d",dev,station,i));
	return(comstat(name,(istat *)tab));
}
