#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)cpallet.c	4.2 (MIT/CSR) 01/22/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		cpallet.c	Creation Date:	12/29/83
 *	Version:	1.0		Update:		01/22/84
 *	Function:	Display Comtal color pallet and edit the
 *			pseudocolor tables
 *	Components:	main()		UNIX command
 */
#include	<stdio.h>
#include	"gips.h"
#include	<sgtty.h>
#include	<ctype.h>
#include	"doflags.h"

statop	flag	debug;
statop	int	plane	initially 1;
statop	char	*font	initially "R.8";
statop	char	*smfont	initially "7seg.2";

statop	flagentry	flagtable[] initially {
	"d",	"1",		(flag *) &debug,
	"o",	"%d #plane",	(flag *) &plane,
	NULL,	NULL,		NULL
};

#define	PSIZE	(256*sizeof(PSEUDO))

statop	int	curpix	initially 0;	/* displayed pixel number */
statop	int	ch	initially 0;	/* current input byte */
statop	int	sgn	initially 0;	/* sign of current numeric */
statop	int	cnt	initially -1;	/* current numeric */
statop	int	incr	initially 10;	/* current increment */
statop	int	eof	initially EOF;	/* current endfile value */

statop	PSEUDO	psm[3][256];	/* pseudocolor tables */
statop	char	(*im)[512];	/* pointer to image buffer */
statop	struct	sgttyb	tty;	/* stdin terminal device table */

extern	char	*sprintf();
extern	long	lseek();

statop	char	*color[] initially { "red", "green", "blue" };

statop
cleanup()
{
	if (eof == 4) {
		tty.sg_flags EQ_AND ~CBREAK;
		use(ioctl(0,(int)TIOCSETN,(char *)&tty));
	}
	exit(TAMEEXITVAL);
	return(0);
}

main(argc,argv)

	int	argc;
	char	**argv;
{
	register 	i, j, k;

	saveargs(argv);
	argc = doflags(argc,argv,flagtable);
	if (argc > 1)
		error("bad arg: %s",*++argv);

	setup(argv);

	while ((ch = getchar()) != eof)
		switch(ch) {
		case '+':
			sgn = 1;
			break;
		case '-':
			sgn = -1;
			break;
		case 'd':
			i = (cnt == -1) ? plane : cnt;
			if ((j = image_open(i,1)) < 0)
				gipserr();
			else
				use(close(j));
			if (i == plane)
				goto clear;
			if (target_dump(0))
				gipserr();
			cnt = -1;
			sgn = 0;
			continue;
		case 'i':
			if (cnt <= 0 || cnt > 255)
				printf("\nbad increment\n");
			else
				incr = cnt * sgn;
			goto clear;
		case 'r':
			putps(0);
			goto clear;
		case 'g':
			putps(1);
			goto clear;
		case 'b':
			putps(2);
			goto clear;
		case 'c':
		case 'm':
		case 's':
			if (sgn == 0)
				i = (cnt < 0) ? targ() : cnt;
			else
				i = curpix + ((cnt < 0) ? sgn : sgn*cnt);
			if (i < 0 || i > 255)
				printf("\nillegal pixel designation\n");
			else if (ch != 'c')
				for (j = 0; j < 3; j++) {
					if (ch == 's')
						k = psm[j][i];
					psm[j][i] = psm[j][curpix];
					if (ch == 's')
						psm[j][curpix] = k;
					outps(j);
				}
			if (ch != 'm')
				putim(curpix = i,40);
			goto clear;
		case 'q':
			use(command_open());
			error("done","");
		default:
			if (isdigit(ch)) {
				cnt = (cnt < 0) ? ch - '0' : 10*cnt + ch - '0';
				break;
			}
			printf("?\n",ch);
		case '\n':
		clear:
			if (target_roam(0))
				gipserr();
			cnt = -1;
			sgn = 0;
			break;
		}

	use(command_open());
	use(cleanup());
	exit(TAMEEXITVAL);
}

statop
setup(args)

	char	**args;
{
	int	dx, dy; 
	register	i, x, y;
	regextra	char *c, *d;
	char	buf[30];

	use(command_open());

	for (i = 0; i < 3; i++)
		if ((x = pseudo_open(i,0)) < 0)
			gipserr();
		else if (read(x,(char *)(psm[i]),PSIZE) != PSIZE)
			gipserr1(GIPSBADREAD);
		else
			use(close(x));

	im = (char(*)[512]) alloc(NIMAGE,sizeof(char));
	if (setfont(smfont) == NULL)
		error("bad font: %s",smfont);
	use(settype(IMAGE));
	use(setorigin(0));
	use(setink('\377'));

	for (c = im[464], *c = 255, x = 1, y = 13; --y >= 0; x EQ_LEFT 1)
		move(c,c+x,x);
	move(d = c,c+x+x,x);

	for (i = 0, dy = 3; dy < 464; dy EQ_PLUS 29)
		for (dx = 3; dx < COLS; dx EQ_PLUS 32) {
			move(d,c = im[dy]+dx,26);
			for (d = c+COLS, d[0]=d[25]=255, x = 25; --x; d[x] = i);
			for (x = 12; --x >= 0; move(c+COLS,d EQ_PLUS COLS,26));
			move(c,d,26);
			use(memmarker((char *)im,ROWS,COLS,dy+20,dx+12,
				sprintf(buf,"%d",i++)));
		}

	if (setfont(font) == NULL)
		error("bad font: %s",font);

	use(setink('\0'));

	putim(0,ROWS);

	if (target_roam(0))
		gipserr();

	if (! debug) {
		use(ioctl(0,(int)TIOCGETP,(char *)&tty));
		tty.sg_flags EQ_OR CBREAK;
		use(ioctl(0,(int)TIOCSETN,(char *)&tty));
		setbuf(stdin,(char *)NULL);
		eof = 4;
		gipsint(cleanup);
		*args = "\ncpallet";
		saveargs(args);
	}
}

statop
putim(n,i)

	int	n, i;
{
	register	x, y;
	register char	*c;
	regextra char	*d;
	char	buf[50];

	for (c = im[472], d=c+8, *d = n, x = 1, y = 7; --y >= 0; x EQ_LEFT 1)
		move(d,d+x,x);
	for (x = COLS, y = 5; --y >= 0; x EQ_LEFT 1)
		move(c,c+x,x);
	use(memmarker((char *)im,ROWS,COLS,488,324,
		sprintf(buf,"P%d R%d G%d B%d",n,psm[0][n],psm[1][n],psm[2][n])));

	x = ROWS-i;
	if ((n = image_open(plane,1)) < 0)
		gipserr();
	use(lseek(n, (long) (COLS*x), 0));
	if (write(n,(char *)(im+x),COLS*i) != COLS*i)
		gipserr1(GIPSBADWRITE);
	use(close(n));
}

statop
targ()
{
	int	tg[2];

	if (target_get(plane,tg))
		gipserr();
	return((tg[1] / 29) << 4) + (tg[0] >> 5); 
}

statop
putps(fi)

	register	fi;
{
	register	i;

	if (sgn == 0)
		i = (cnt < 0) ? psm[fi][targ()] : cnt;
	else
		i = psm[fi][curpix] + ((cnt < 0) ? sgn*incr : sgn*cnt);
	if (i < 0 || i > 255)
		error ("bad %s pixel value",color[fi]);
	psm[fi][curpix] = i;
	outps(fi);
	putim(curpix,40);
}

statop
outps(i)

	register	i;
{
	register	fi, n;

	if ((fi = pseudo_open(i,1)) < 0)
		gipserr();
	n = write(fi,(char *)(psm[i]),PSIZE);
	use(close(fi));
	if (n != PSIZE)
		gipserr1(GIPSBADWRITE);
}
