#include	"tailor.h"
#ifndef lint
statop char *comid initially "@(#)cplot.c	4.2 (MIT/CSR) 11/21/84";
#endif
/*		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		cplot.c		Creation Date:	12/29/83
 *	Version:	1.0		Update:		11/21/84
 *	Function:	Reads standard graphics input.
 *			Writes a 512 x 512 x 1 bit (32768 byte)
 *			Comtal Graphic on Standard Output
 *	Components:	main()		UNIX command
 */
#include	<stdio.h>
#include	"gips.h"
#include	<math.h>
#include	<signal.h>
 
#define	mapx(x)		(del*((x)-botx)+centx)
#define	mapy(y)		(del*(topy-(y))+centy)
#define SOLID		-1
#define DOTTED		014
#define SHORTDASHED	034
#define DOTDASHED	054
#define LONGDASHED	074
#define	y0		Y0
#define	y1		Y1

statop	int	linmod	initially SOLID;
statop	int	done1	initially 0;
extern	char	chrtab[][16];
statop	char	*map	initially NULL;
statop	int	lastx	initially 0;
statop	int	lasty	initially 0;
statop	double	topx	initially COLS;
statop	double	topy	initially ROWS;
statop	double	botx	initially 0;
statop	double	boty	initially 0;
statop	int	centx	initially 0;
statop	int	centy	initially 0;
statop	double	del	initially 1;
statop	int	xerr	initially 0;
statop	int	yerr	initially 0;

main(argc,argv)
int	argc;
char	**argv;
{
	char	*alloc();
	int	onintr();
	int	fd;
	double	delx, dely, th, r, x0, y0, x2, y2;
	register char *c;
	register int x1 initially -1, y1;

	saveargs(argv);
	use(signal(SIGTERM, onintr));
	if (signal(SIGINT, SIG_IGN) != SIG_IGN)
		use(signal(SIGINT, onintr));

	map = alloc(NGRAPH,1);

	if (argc > 2)
		error("bad argument(s): %s ...",argv[2]);
	else if (argc == 2)
		if (*(*++argv) == '=' && ! (*argv)[1]) {
			fprintf(stderr,"Usage: cplot [file]\n");
			exit(WILDEXITVAL);
		} else if ((fd = open(*argv,0)) < 0 )
			error("cannot open %s",*argv);
		else if (read(fd,map,(int) NGRAPH) != NGRAPH)
			error("read error: %s",*argv);
		else {	use(close(fd)); x1 = NGRAPH; }
	else 
		x1 = 'e';

	for (;; x1 = getc(stdin))

	switch (x1) {
	case 's':
		botx = getW(stdin);
		boty = getW(stdin);
		topx = getW(stdin);
		topy = getW(stdin);
		delx = topx-botx;
		dely = topy-boty;
		if (delx == 0 || dely == 0) {
			fprintf (stderr,"plot: bad range\n");
			quit(WILDEXITVAL);
		}
		del = (delx > dely) ? COLS./delx : ROWS./dely;
		centx = (COLS - del*delx)/2;
		centy = (ROWS - del*dely)/2;

	case NGRAPH:
		continue;

	case 'l':
		done1++;
		x1 = mapx(getW(stdin));
		y1 = mapy(getW(stdin));
		lastx = mapx(getW(stdin));
		lasty = mapy(getW(stdin));
		line(x1, y1, lastx, lasty);
		continue;

	case 'm':
		lastx = mapx(getW(stdin));
		lasty = mapy(getW(stdin));
		continue;

	case 't':
		done1++;
		while ((x1 = getc(stdin)) != '\n')
			plotch(x1);
		continue;

	case 'e':
		if (done1)
			use(write (1,map,(int) NGRAPH));
		for (c = map; c < map+NGRAPH; *c++ = '\0') ;
		continue;

	case 'p':
		done1++;
		lastx = mapx(getW(stdin));
		lasty = mapy(getW(stdin));
		point(lastx, lasty);
		point(lastx+1, lasty);
		point(lastx, lasty+1);
		point(lastx+1, lasty+1);
		continue;

	case 'n':
		done1++;
		x1 = mapx(getW(stdin));
		y1 = mapy(getW(stdin));
		line(lastx, lasty, x1, y1);
		lastx = x1;
		lasty = y1;
		continue;

	case 'f':
		use(getW(stdin));
		linmod = getc(stdin);
		switch(getc(stdin)) {
		case 't':
			linmod = DOTTED;
			break;
		default:
		case 'i':
			linmod = SOLID;
			break;
		case 'g':
			linmod = LONGDASHED;
			break;
		case 'r':
			linmod = SHORTDASHED;
			break;
		case 'd':
			linmod = DOTDASHED;
			break;
		}
		while( (x1 = getc(stdin)) != '\n')
			if(x1 == -1) quit(TAMEEXITVAL);
		continue;

	case 'd':
		use(getW(stdin));
		use(getW(stdin));
		use(getW(stdin));
		x1 = getW(stdin);
		while (--x1 >= 0)
			use(getW(stdin));
		continue;

	case 'c':
		done1++;
		x1 = mapx(getW(stdin));
		y1 = mapy(getW(stdin));
		r  = mapx(getW(stdin));
		if (r != 0)
			for (th = 0; th < 6.14; th EQ_PLUS 1.0/r)
				point((int)(x1+r*sin(th)), (int)(y1+r*cos(th)));
		continue;

	case 'a':
		done1++;
		x1 = mapx(getW(stdin));
		y1 = mapy(getW(stdin));
		x0 = mapx(getW(stdin));
		y0 = mapy(getW(stdin));
		x2 = mapx(getW(stdin));
		y2 = mapy(getW(stdin));
		if ((r = hypot(x0-x1,y0-y1)) == 0.0)
			continue;
		y2 = 1.0/r;
		if ((th = atan2(y0-y1,x0-x1)) > (x2 = atan2(y2-y1,x2-x1)))
			{ x0 = th; th = x2; x2 = x0; y2 = -y2; }
		for (; th < x2; th EQ_PLUS y2)
			point((int)(x1+r*sin(th)), (int)(y1+r*cos(th)));
		continue;

	case -1:
		quit(TAMEEXITVAL);

	default:
		fprintf(stderr, "plot: bad control char: %c\n", x1);
		quit(WILDEXITVAL);
	}
}

statop	plotch(c)
register c;
{
	register j;
	register char *cp;
	int	i, k, l;

	if (c < ' ' || c > 0177)
		return;

	cp = chrtab[c - ' '];
	lastx EQ_PLUS 16;

	for (i = -16; i<16; i EQ_PLUS 2)
		for (c = *cp++, k = lasty+i, l = lastx-10, j = 7; j >= 0; --j)
			if ((c >> j) & 1 ) {
				point(l-j-j, k);
				point(l+1-j-j, k);
				point(l-j-j, k+1);
				point(l+1-j-j, k+1);
			}
}

statop	line(x0, y0, x1, y1)
register x0, y0;
{
	int	dx, dy, slope;
	int	xinc initially 1;
	int	yinc initially 1;
	int	res2 initially 0;
	register res1 initially 0;

	if ((dx = x1-x0) < 0) {
		xinc = -1;
		dx = -dx;
	}
	if ((dy = y1-y0) < 0) {
		yinc = -1;
		dy = -dy;
	}
	slope = xinc*yinc;
 
	if (dx >= dy) while (x0 != x1) {
		if((x0+slope*y0) & linmod)
			point(x0, y0);
		if (res1 > res2) {
			res2 EQ_PLUS dx - res1;
			res1 = 0;
			y0 EQ_PLUS yinc;
		}
		res1 EQ_PLUS dy;
		x0 EQ_PLUS xinc;
	} else while (y0 != y1) {
		if((x0+slope*y0) & linmod)
			point(x0, y0);
		if (res1 > res2) {
			res2 EQ_PLUS dy - res1;
			res1 = 0;
			x0 EQ_PLUS xinc;
		}
		res1 EQ_PLUS dx;
		y0 EQ_PLUS yinc;
	}
	if((x1+slope*y1) & linmod)
		point(x1, y1);
}

statop	point(x,y)
register int x,y;
{
	if (! ISCOL(x))
		xerr++;
	else if (! ISROW(y))
		yerr++;
	else
		SETGRAPH(map,x,y);
}

statop	getW(f)
register FILE	*f;
{
	register short a, b;

	if ((b = getc(f)) == EOF || (a = getc(f)) == EOF)
		quit(WILDEXITVAL);
	return((a << 8) | b);
}

statop	quit(i)
int i;
{
	if (done1)
		use(write (1,map,(int) NGRAPH));
	if (xerr+yerr) 
		fprintf (stderr,"cplot: bounds x=%d y=%d\n",xerr,yerr,i = 1);
	exit(i);
}

statop	onintr()
{
	exit(WILDEXITVAL);
}
