/* @(#)comsubs.h	4.2 (MIT/CSR) 07/03/84
 *
 *		   Comtal Image Processor Utility
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 *	Module:		comsubs.c	Creation Date:	07/03/84
 *	Version:	1.0		Update:		07/03/84
 *	Function:	Define Comtal status register fields
 */
#define	COMTAME	0
#define	COMWILD	(-1)

typedef struct {
	unsigned short	xy_x;
	unsigned short	xy_y;
}	xypair;

typedef struct status {	/* Structure of istat and gstat status bytes */
	unsigned char windowed		:1;
	unsigned char inaquad		:1;
	unsigned char inacolor		:1;
	unsigned char assignedto	:1;
	unsigned char isagraphic	:1;
	unsigned char iscolor		:1;
	unsigned char set		:1;
	unsigned char defined		:1;
} status;

typedef struct istat	{	/* image status block */
	char				:8;
	status		is_status;
	unsigned char	is_mems;
	unsigned char	is_xmems;
	xypair		is_size;
	unsigned char	is_ulimage;
	unsigned char	is_urimage;
	unsigned char	is_llimage;
	unsigned char	is_lrimage;
	unsigned char	is_redimage;
	unsigned char	is_greenimage;
	unsigned char	is_blueimage;
	char				:8;
	xypair		is_ulwindow;
	xypair		is_lrwindow;
	unsigned short	is_shownx;
	unsigned	is_showny	:12;
	unsigned	is_zoom		:2;
	unsigned			:2;
	xypair		is_maximum;
} istat;

typedef struct gstat	{	/* graphic status block */
	char				:8;
	status		gs_status;
	char		gs_mems;
	char		gs_xmems;
	xypair		gs_size;
	int				:32;
	unsigned char	gs_color;
	int				:24;
	xypair		gs_ulwindow;
	xypair		gs_lrwindow;
	unsigned short	gs_shownx;
	unsigned	gs_showny	:12;
	unsigned	gs_zoom		:2;
	unsigned			:2;
	xypair		gs_maximum;
} gstat;

#define NIMAGES		128
#define	NGRAPHICS	128
