#ifndef lint
static char *sccsid = "%Z%$RCSfile: comard.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 04:56:45 $";
#endif
/*		   Comtal Image Processor Utility
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		comard.c	Creation Date:	12/30/83
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 04:56:45 $
**	Components:	comard()	either open image plane or read an
**					image into malloc() storage.
**			comawr()	write complete image to image plane
**			comapr()	format carith(1) message to stdout
**
**	Function:	Read and write image planes
*/

#include	<stdio.h>
#include	"gips.h"

extern	char	*argsav[];

char *
comard(i, mode)

	register i;		/* image plane number */
	register mode;		/* mode=0,1,2 to open for read,write or
				   to read entire plane (mode=2) */
{
	register char *c;
	/*
	**	fix up command name for error()
	*/
	if (argsav[0] == NULL)
		argsav[0] = "carith";
	/*
	**	mode=0,1: open the image plane file and return the file pointer
	**	mode=2: allocate an image plane buffer and read the image
	**	into it return the address of the buffer
	*/
	if (mode < 2) {
		if ((i = image_open(i, mode ? 1 : 0)) < 0 ||
		    (c = (char *) fdopen(i, mode ? "w" : "r")) == NULL)
			gipserr1(GIPSBADOPEN);
	} else {
		if ((c = alloc(NIMAGE, sizeof(char))) == NULL ||
		    (i = image_open(i, 0)) < 0)
			gipserr();
		if (read(i, c, (int)NIMAGE) != NIMAGE)
			gipserr1(GIPSBADREAD);
		(void)close(i);
	}
	return(c);
}
	/*
	**	write image in buffer 'p' to image plane 'i'
	*/
void
comawr(p, i)
	
	register char *p;
	register i;
{
	/*
	**	fix up command name for error()
	*/
	if (argsav[0] == NULL)
		argsav[0] = "carith";
	/*
	**	write the image
	*/
	if ((i = image_open(i, 1)) < 0)
		gipserr();
	if (write(i, p, (int)NIMAGE) != NIMAGE)
		gipserr1(GIPSBADWRITE);
	(void)close(i);
}
	/*
	**	write the string 's' to stdout in standard GIPS format
	*/
void
comapr(s)

	register char *s;
{
	fprintf(stdout, "carith: %s; done\n", s);
}
