/*	%Z%$RCSfile: mongo.h,v $	GIPS $Revision: 2.6 $ (MIT/CSR) $Date: 1987/07/03 12:57:30 $
**
**		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1985,1987 Massachusetts Institute of Technology
**
**	Module:		mongo.h		Creation Date:	11/26/85
**	Version:	$Revision: 2.6 $		Update:		$Date: 1987/07/03 12:57:30 $
**
**	Function:	Define mongo routines for C callers
*/

#define _ac(a,b,c,d) _af(a,0),_af(b,1),_af(c,2),_af(d,3)
#define	_af(x,n) (_MongoFloat[n]=x,&_MongoFloat[n])
#define	_ai(x,n) (_MongoInteg[n]=x,&_MongoInteg[n])

#define	axis(p,q,s,b,x,y,z,i,m) mgoaxis_(_ac((p),(q),(s),(b)),\
	_af((x),4),_af((y),5),_af((z),6),_ai((i),0),_ai((m),1))
#define	box(i,j) mgobox_(_ai((i),0),_ai((j),1))
#define	connect(x,y,m) mgoconnect_((x),(y),_ai((m),0))
#define	contour(x,m,n,r,l) mgocontour_((x),_ai((m),0),_ai((n),1),(r),_ai((l),2))
#define	device(n) mgodevice_(_ai((n),0))
#define	draw(x,y) mgodraw_(_af((x),0),_af((y),1))
#define	erase mgoerase_
#define	errorbar(k,x,y,e,n) mgoerrorbar_(_ai((k),0),(x),(y),(e),_ai((n),1))
#define	fileinit mgoprntinit_
#define	fileplot() mgoprntplot_(_ai(0,0))
#define	gdraw(x,y) mgogdraw_(_af((x),0),_af((y),1))
#define	grelocate(x,y) mgogrelocate_(_af((x),0),_af((y),1))
#define	grid(n) mgogrid_(_ai((n),0))
#define	gstring(s) mgogstring_(_ai(strlen(s),0),(s),strlen(s))
#define	gstrlen(s,x,y) mgogstrlen_(_ai(strlen(s),0),(s),(x),(y),strlen(s))
#define	halftone(z,m,n,x,y,c) mgohalftone_((z),_ai((m),0),_ai((n),1),\
	_af((x),0),_af((y),1),_af((c),2))
#define	hatch(x,y,m,n) mgohatch_((x),(y),_ai((m),0),_ai((n),1))
#define	histogram(x,y,m) mgohistogram_((x),(y),_ai((m),0))
#define	init mgoinit_
#define	label(s) mgolabel_(_ai(strlen(s),0),(s),strlen(s))
#define	line(a,b,c,d) mgoline_(_ac((a),(b),(c),(d)))
#define	mongo(n,c,l,m,f,i) mongo_(_ai((n),0),(c),_ai((l),1),_ai((m),2),(f),(i))
#define	page(n) mgopage_(_ai((n),0))
#define	plotid(f1,f2) mgoplotid_((f1),(f2),strlen(f1),strlen(f2))
#define	plt3d(z,m,n,w,c,a,f,o) mgoplt3d_((z),_ai((m),0),_ai((n),1),(w),\
	_ac((c),(a),(f),(o)))
#define	point(n,i) mgopoint_(_ai((n),0),_ai((i),1))
#define	points(s,n,x,y,m) mgopoints_((s),_ai((n),0),(x),(y),_ai((m),1))
#define	prntinit mgoprntinit_
#define	prntplot(n) mgoprntplot_(_ai((n),0))
#define	psetup mgopsetup_
#define	putlabel(s,l) mgoputlabel_(_ai(strlen(s),0),(s),_ai((l),1),strlen(s))
#define	relocate(x,y) mgorelocate_(_af((x),0),_af((y),1))
#define	setangle(a) mgosetangle_(_af((a),0))
#define	setexpand(e) mgosetexpand_(_af((e),0))
#define	setlim(a,b,c,d) mgosetlim_(_ac((a),(b),(c),(d)))
#define	setloc(a,b,c,d) mgosetloc_(_ac((a),(b),(c),(d)))
#define	setltype(n) mgosetltype_(_ai((n),0))
#define	setlweight(n) mgosetlweight_(_ai((n),0))
#define	setphysical(a,b,c,d) mgosetphysical_(_ac((a),(b),(c),(d)))
#define	setslope(a,b,c,d) mgosetslope_(_ac((a),(b),(c),(d)))
#define	setup(n) mgosetup_(_ai((n),0))
#define	tclose mgotclose_
#define	tcursor(x,y,n) mgocursor_((x),(y),_ai((n),0))
#define	ticksize(a,b,c,d) mgoticksize_(_ac((a),(b),(c),(d)))
#define	tidle mgotidle_
#define	tsetup mgotsetup_
#define	ttflush_ mgotidle_
#define	vfield(x,y,r,p,n) mgovfield_((x),(y),(r),(p),_ai((n),0))
#define	vtsetup mgopsetup_
#define	vtswapxy mgoprntinit_
#define	window(i,j,k) mgowindow_(_ai((i),0),_ai((j),1),_ai((k),2))
#define	xlabel(s) mgoxlabel_(_ai(strlen(s),0),(s),strlen(s))
#define	ylabel(s) mgoylabel_(_ai(strlen(s),0),(s),strlen(s))
	/*
	 *	Mongo parameter area
	 */
extern	struct	{
	float	u_cord[4];	/* User coordinates of plot region */
	float	g_cord[4];	/* Physical coordinates of user plot region */
	int	l_cord[4];	/* Limits of physical device coordinates */
	float	p_cord[2];	/* Present physical plot position */
	float	c_cord[2];	/* User coordinates of cursor */
	float	expand;		/* Expansion factor of characters*/
	float	angle;		/* Character rotation angle (counterclkwise) */
	int	ltype;		/* Line type, 0=solid, 1=dot, 2=dash, etc */
	int	lweight;	/* Line weight, 0,1=single, 2=double */
	float	c_dim[7];	/* Character and point scale factors */
	int	termout;	/* Terminal/Hardcopy switch */
	int	xy_swapped;	/* Inversion switch */
	int	numdev;		/* Output device number code */
	float	pi;		/* 3.14.. */
	float	uservar[10];	/* User-defined variables */
	int	autodot;	/* true for output device capable of dots */
} mongopar_;
	/*
	**	Dummies for Mongo routine arguments
	*/
static	float	_MongoFloat[7];
static	int	_MongoInteg[3];
	/*
	**	Mongo device type table entry
	*/
static	struct	mongo_device	{
	char	*name;		/* -o device name */
	char	*desc;		/* device description */
	int	mongo_type;	/* mongo device code */
};
