#ifndef lint
static char *sccsid = "%Z%$RCSfile: clear.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 02:46:45 $";
#endif
/*
**		   General Image Processing System
**
**			   Peter G. Ford
**		Massachusetts Institute of Technology
**	Department of Earth, Atmospheric, and Planetary Sciences
**
**	Module:		clear.c		Creation Date:	12/30/83
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 02:46:45 $
**
**	Function:	Data manipulation subroutines
**
**	Components:	clear()		Set a string to zeroes
**			move()		Copy a string:
**			poly()		Expand a polynomial
*/

void
clear(lp, nbytes)

#ifdef vax
	char	*lp;			/* pointer to area to be cleared */
	int	nbytes;			/* number of bytes to clear */
{
	if (lp != 0 && nbytes > 0)
		asm("movc5 $0,(sp),$0,8(ap),*4(ap)");
#else
	register char *lp;
	register nbytes;
{
	while (--nbytes >= 0)
		*lp++ = '\0';
#endif
}

void
move(from, to, count)
	
#ifdef vax
	char	*from;			/* source pointer */
	char	*to;			/* target pointer */
	int	count;			/* number of bytes to move */
{
	if (from != to && count > 0)
		asm("movc3 12(ap),*4(ap),*8(ap)");
#else
	register char *from, *to;
	register count;
{
	while (--count >= 0)
		if (from > to)
			*to++ = *from++;
		else
			to[count] = from[count];
#endif
}

void
/*ARGSUSED*/
poly(in, out, n, parm, m)

	register double *in;		/* input array */
	register double *out;		/* output array */
	register double *parm;		/* polynomial coefficient table */
	register n;			/* number of array elements */
#ifdef vax
	register m;			/* order of polynomial (dim+1) */
{
	if (m >= 0)
		while (--n >= 0) {
			asm("polyd (r11)+,r7,(r8)");
			asm("movd r0,(r10)+");
#else
{
	if (m >= 0)
		for ( ;--n >= 0; in++, out++, parm -= m) {
			register i;
			for (*out = *parm, i = m; --i >= 0; )
				*out = *++parm + *out * *in;
#endif
		}
}
