#ifndef lint
static char *sccsid = "%Z%$RCSfile: error.c,v $	GIPS $Revision: 2.3 $ (MIT/CSR) $Date: 1998/05/13 00:51:42 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		error.c		Creation Date:	12/30/83
**	Version:	$Revision: 2.3 $		Update:		$Date: 1998/05/13 00:51:42 $
**	Components:	gipserror()	Handle errors
**			gipsint()	Set or cancel cleanup routine
**
**	Function:	Format error message to stderr and exit(1)
**/

#include	"gips.h"
#include	<signal.h>

char		*argsav[3];		/* routine name and calling args */
static	SIGTYPE	(*gipsintp)() = NULL;	/* interrput handler */

static	SIGTYPE
cleanup()
{
	if (gipsintp != NULL)
		(void)((*gipsintp)());
	exit(1);
}

void
gipsint(p)

	register SIGTYPE (*p)();	/* new interrupt handler */
{
	static	SIGTYPE	(*sig[17])();	/* saved signal handlers */
	register	i = 0;		/* scratch */

	while (++i < 16)
		if (p == NULL)
			(void)(signal(i,sig[i]));
		else
			sig[i] = signal(i,cleanup);
	gipsintp = p;
}

gipserror(s,t)

	register char *s;		/* error message */
	register char *t;		/* message insert */
{
	if (argsav[0] != NULL)
		(void) fprintf(stderr,"%s: ",argsav[0]);
	(void) fprintf(stderr,(s == NULL) ? "error" : s,t);
	(void)(fputc('\n',stderr));
	(void)(cleanup());		/* execute any outstanding cleanup */
	exit(1);			/* kill process */
	return(0);			/* make lint happy */
}
