#ifndef lint
static char *sccsid = "%Z%$RCSfile: fopens.c,v $	GIPS $Revision: 2.4 $ (MIT/CSR) $Date: 1998/05/13 00:52:42 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		fopens.c	Creation Date:	03/07/85
**	Version:	$Revision: 2.4 $		Update:		$Date: 1998/05/13 00:52:42 $
**	Components:	fopens()	C subroutine
**
**	Function:	Open a string for 'stream' input
*/

#include        <stdlib.h>  /* for malloc */
#include	"gips.h"
#include	<strings.h>

#ifndef _IOSTRG
char	*ihdstr;			/* stream table */
int	ihdlstr;			/* length of stream table */
#endif

FILE *
fopens(s)
	register char *s;
{
	register FILE	*ff;		/* incore stream descriptor */

#ifdef _IOSTRG
	if (s == NULL) return NULL;
	ff = (FILE *) alloc(sizeof(FILE),1);
	ff->_flag = _IOREAD + _IOSTRG;
#ifdef sun
	ff->_base = (unsigned char *)s;
#else
	ff->_base = s;
#endif
	ff->_cnt = strlen(ff->_ptr = ff->_base);
#else
	register char	*temp;		/* scratch file name */
	register int	nfile;
/*	extern	char	*malloc(); */

	if (s == NULL) return NULL;
	temp = tmpnam(NULL);
	ff = fopen(temp, "w");
	if (ff == NULL) return NULL;
	(void)fputs(s, ff);
	(void)fclose(ff);
	ff = fopen(temp, "r");
	(void)unlink(temp);
	if (ff) {
		nfile = fileno(ff)+1;
		if (nfile > ihdlstr) {
			temp = malloc(nfile);
			bzero(temp, nfile);
			if (ihdstr) {
				bcopy(ihdstr, temp, ihdlstr);
				free(ihdstr);
			}
			ihdstr = temp;
			ihdlstr = nfile;
		}
		ihdstr[nfile-1] = 1;
	}
#endif
	return(ff);
}
