#ifndef lint
static char *sccsid = "%Z%$RCSfile: gconv.c,v $	GIPS $Revision: 2.4 $ (MIT/CSR) $Date: 1998/05/13 00:51:44 $";
#endif

/*
 *		   General Image Processing System
 *			   Peter G. Ford
 *		      Center for Space Research
 *	Copyright 1984 Massachusetts Institute of Technology
 *
 #	Module:		gconv.c		Creation Date:	04/28/84
 #	Version:	$Revision: 2.4 $		Update:		$Date: 1998/05/13 00:51:44 $
 *	Function:	VAX array conversion routines
 *	Syntax:		gconv(&to, &from, item_count, to_type, from_type)
 *	Return value:	none
 */

#include	"gips.h"
#include	<limits.h>
#include	<strings.h>

#define	PA(p1, p2, p3, p4, p5, p6, p7, p8, p9, c, d, l, m) \
	static p1(i, o, n) PB(m, c, char, d, SCHAR_MIN, SCHAR_MAX) \
	static p2(i, o, n) PB(m, c, unsigned char, d, 0, UCHAR_MAX) \
	static p3(i, o, n) PB(m, c, short, d, SHRT_MIN, SHRT_MAX) \
	static p4(i, o, n) PB(m, c, unsigned short, d, 0, USHRT_MAX) \
	static p5(i, o, n) PB(m, c, long, d, LONG_MIN, LONG_MAX) \
	static p6(i, o, n) PB(m, c, unsigned long, d, 0, LONG_MAX) \
	static p7(i, o, n) PC(m, c, float) \
	static p8(i, o, n) PC(m, c, double) \
	static p9(i, o, n) PC(*i++; *o++ = l, c, float)

#define	PB(r, x, y, z, min, max) \
	register x *i; \
	register y *o; \
	register n; \
{ \
	register z low = min; \
	register z high = max; \
	while (--n >= 0) { \
		register z val = r; \
		*o++ = (val <= low) ? low : ((val >= high) ? high : val); \
	} \
}

#define PC(r, x, y) \
	register x *i; register y *o; register n; \
{ \
	while (--n >= 0) { \
		*o++ = r; \
	} \
}

extern	double	hypot();

PA(cvtss, cvtsb, cvtsh, cvtsu, cvtsi, cvtsl, cvtsf, cvtsd, cvtsc, char, long, 0, *i++)

PA(cvtbs, cvtbb, cvtbh, cvtbu, cvtbi, cvtbl, cvtbf, cvtbd, cvtbc, unsigned char, long, 0, *i++)

PA(cvths, cvthb, cvthh, cvthu, cvthi, cvthl, cvthf, cvthd, cvthc, short, long, 0, *i++)

PA(cvtus, cvtub, cvtuh, cvtuu, cvtui, cvtul, cvtuf, cvtud, cvtuc, unsigned short, long, 0, *i++)

PA(cvtis, cvtib, cvtih, cvtiu, cvtii, cvtil, cvtif, cvtid, cvtic, long, long, 0, *i++)

PA(cvtls, cvtlb, cvtlh, cvtlu, cvtli, cvtll, cvtlf, cvtld, cvtlc, unsigned long, long, 0, *i++)

PA(cvtfs, cvtfb, cvtfh, cvtfu, cvtfi, cvtfl, cvtff, cvtfd, cvtfc, float, float, 0, *i++)

PA(cvtds, cvtdb, cvtdh, cvtdu, cvtdi, cvtdl, cvtdf, cvtdd, cvtdc, double, double, 0, *i++)

PA(cvtcs, cvtcb, cvtch, cvtcu, cvtci, cvtcl, cvtcf, cvtcd, cvtcc, float, float, *i++, (*(int *)(i+1) ? hypot((double)i[0],i[1]) : (*(int *)i ? i[0] : 0)); i++; i++)

static	int (*proc[9][9])() = {
	cvtss, cvtsb, cvtsh, cvtsu, cvtsi, cvtsl, cvtsf, cvtsd, cvtsc,
	cvtbs, cvtbb, cvtbh, cvtbu, cvtbi, cvtbl, cvtbf, cvtbd, cvtbc, 
	cvths, cvthb, cvthh, cvthu, cvthi, cvthl, cvthf, cvthd, cvthc,
	cvtus, cvtub, cvtuh, cvtuu, cvtui, cvtul, cvtuf, cvtud, cvtuc,
	cvtis, cvtib, cvtih, cvtiu, cvtii, cvtil, cvtif, cvtid, cvtic,
	cvtls, cvtlb, cvtlh, cvtlu, cvtli, cvtll, cvtlf, cvtld, cvtlc,
	cvtfs, cvtfb, cvtfh, cvtfu, cvtfi, cvtfl, cvtff, cvtfd, cvtfc,
	cvtds, cvtdb, cvtdh, cvtdu, cvtdi, cvtdl, cvtdf, cvtdd, cvtdc,
	cvtcs, cvtcb, cvtch, cvtcu, cvtci, cvtcl, cvtcf, cvtcd, cvtcc
};

void
gconv(o, i, n, t, f)
	char *i, *o;
{
	if (t == f)
		bcopy(i, o, n * ihdlen(t));
	else
		(*proc[f][t])(i, o, n);
}
