#ifndef lint
static char *sccsid = "%Z%$RCSfile: gipsflags.c,v $	GIPS $Revision: 2.7 $ (MIT/CSR) $Date: 1998/05/13 00:51:48 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**
**	Module:		gipsflags.c	Creation Date:	12/30/83
**	Version:	$Revision: 2.7 $		Update:		$Date: 1998/05/13 00:51:48 $
**	Components:	gipsflags()	parse caller's arguments
**			Usage()		print legal argument syntax
**			logic()		write error message
**
**	Function:	Parse gips command argument list
*/

#include "gips.h"

static	char	**arg0;
static	flagentry *fq;
static	logic();

gipsflags(argc, argv, fp)
	register int argc;
	register char **argv;
	register flagentry *fp;
{
	register char **arg = argv;
	register char *a, *b, ch;

	arg0 = argv;
	fq = fp;
	if (! argv || ! *argv)
		logic(0);
	if (argv[1] && ! argv[2] && argv[1][0] == '=' && ! argv[1][1])
		Usage();

	while (*++argv) {
		if (**argv != '-' || ! (*argv)[1]) {
			*++arg = *argv;
			continue;
		}
		for (a = *argv; *++a; ) {
			for (fp = fq; ; fp++)
				if (! fp->flag_name)
					Usage();
				else if (! (ch = fp->flag_name[0]) &&
						*a >= '0' && *a <= '9')
					break;
				else if (ch && fp->flag_name[1])
					logic(fp);
				else if (*a == ch)
					break;
			if (! (b = fp->flag_oper) || ! fp->flag_ptr)
				logic(fp);
			if (! b[1])
				switch(b[0]) {
					case '1':
						*fp->flag_ptr = 1;
						continue;
					case '0':
						*fp->flag_ptr = 0;
						continue;
					default:
						Usage();
				}
			if (! b[2] && b[0] == b[1])
				switch(b[0]) {
					case '+':
						++(*fp->flag_ptr);
						continue;
					case '-':
						--(*fp->flag_ptr);
						continue;
					default:
						Usage();
				}
			if (a[-1] != '-' || (ch && ! *++a && ! (a = *++argv)))
				Usage();
			if (b[0] == '-' && b[1] == '>') {
				*(char **)(fp->flag_ptr) = a;
				break;
			}
			while ((ch = *b) && ch != ' ')
				b++;
//			*b = 0;
			if (sscanf(a, fp->flag_oper, fp->flag_ptr) != 1)
				Usage();
//			*b = ch;
			break;
		}
	}

	*++arg = 0;
	return arg - arg0;
}

Usage()
{
	register char *b;
	register flagentry *fp;

	fprintf(stderr, "Usage: %s", *arg0);

	for (fp = fq; fp->flag_name; fp++) {
		if (! fp->flag_oper || ! fp->flag_ptr)
			logic(fp);
		for (b = fp->flag_oper; *b && *b != ' '; b++)
			;
		if (*fp->flag_name)
			fprintf(stderr, " [-%c%s]", *fp->flag_name, b);
		else
			fprintf(stderr, " [-'%s']", b+1);
	}

	fprintf(stderr, fp->flag_oper ? " %s\n" : "\n", fp->flag_oper);
	exit(1);
}

static
logic(fp)
	register flagentry *fp;
{
	if (! fp)
		fprintf(stderr, "flags: NULL argv or argv[0]\n");
	else if (! fp->flag_oper)
		fprintf(stderr, "flags: NULL -%c flag_oper\n", fp->flag_name);
	else if (! fp->flag_ptr)
		fprintf(stderr, "flags: NULL -%c flag_ptr\n", fp->flag_name);
	else
		fprintf(stderr, "flags: bad flag_name: -%s\n", fp->flag_name);
	exit(1);
}
