#ifndef lint
static char *sccsid = "%Z%$RCSfile: ihbin.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 02:47:09 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		ihbin.c		Creation Date:	12/30/83
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 02:47:09 $
**	Components:	ihbin_()	Read a raster (F77 call)
**			ihbin()		Read a raster (C call)
**			ihbout_()	Write a raster (F77 call)
**			ihbout()	Write a raster (C call)
**
**	Function:	Read, write, and close general image rasters
*/

#include	<stdio.h>
#include	"gips.h"

extern	int	arginit;	/* =0 if header has been updated */
static	int	xnum;		/* saved header variable */
static	char	dtype;		/* saved header variable */

ihbin_(buf, fp, lbuf)

	FILE	**fp;		/* pointer to open GIPS file */
	char	*buf;		/* raster buffer address */
	int	*lbuf;		/* maximum length of buffer in bytes */
{
	return ihbin(buf, *fp, *lbuf);
}

ihbin(buf, fp, lbuf)

	register FILE	*fp;	/* pointer to open GIPS file */
	register char	*buf;	/* raster buffer address */
	register	lbuf;	/* maximum length of buffer in bytes */
{
	register i;		/* scratch */
	register len;		/* raster length in bytes */

	if (! arginit)
		if ((i = ihget("xnum", (char *)&xnum, 0)) ||
			(i = ihget("dtype", (char *)&dtype, 1)))
			return -i;
		else
			xnum *= ihdtype(dtype);

	if (fp == NULL || buf == NULL || lbuf <= 0 || (len = xnum) == 0)
		return -1;

	i = fread(buf, 1, (lbuf < len) ? lbuf : len, fp);

	if (lbuf < len && i == lbuf)
		while (len-- > i)
			(void)(getc(fp));

	if (i < lbuf)
		clear(buf+i, lbuf-i);
	return i;
}

ihbout_(buf, fp, lbuf)

	FILE	**fp;		/* pointer to GIPS output file */
	char	*buf;		/* raster buffer */
	int	*lbuf;		/* maximum length of buffer in bytes */
{
	return ihbout(buf, *fp, *lbuf);
}

ihbout(buf, fp, lbuf)

	register FILE	*fp;	/* pointer to GIPS output file */
	register char	*buf;	/* raster buffer */
	register	lbuf;	/* maximum length of buffer in bytes */
{
	register	i;	/* scratch */
	register	len;	/* actual raster length in bytes */

	if (! arginit)
		if ((i = ihget("xnum", (char *)&xnum, 0)) ||
		    (i = ihget("dtype", (char *)&dtype, 1)))
			return -i;
		else
			xnum *= ihdtype(dtype);

	if (fp == NULL || buf == NULL || lbuf <= 0 || (len = xnum) == 0)
		return -1;

	i = fwrite(buf, 1, (lbuf < len) ? lbuf : len, fp);

	if (lbuf < len && i == lbuf)
		while (len-- < i)
			(void)(putc('\0', fp));
	return i;
}
