#ifndef lint
static char *sccsid = "%Z%$RCSfile: telltale.c,v $	GIPS $Revision: 2.1 $ (MIT/CSR) $Date: 1986/07/27 02:47:21 $";
#endif
/*		   General Image Processing System
**			   Peter G. Ford
**		      Center for Space Research
**	Copyright 1984 Massachusetts Institute of Technology
**
**	Module:		telltale.c	Creation Date:	06/13/84
**	Version:	$Revision: 2.1 $		Update:		$Date: 1986/07/27 02:47:21 $
**	Components:	telltale()	Format message to stderr
**
**	Function:	Format resource usage message to stderr
*/


#include        <string.h>   /* for strlen */
#include	<stdio.h>
#include	"gips.h"
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/resource.h>

char		*argsav[3];		/* routine name and calling args */

telltale(sw)

	register	sw;
{
	static struct timeval t0;
	struct timeval	t1;
	struct rusage	r1, r2;
	char		buf[200];
	register time_t	t, l, ms;
	register	i;

	if (! sw) {
		(void)(gettimeofday(&t0, (struct timezone *)0));
		return;
	}
	(void)(getrusage(RUSAGE_SELF, &r1));
	(void)(getrusage(RUSAGE_CHILDREN, &r2));

	if (r1.ru_maxrss > r2.ru_maxrss)
		r1.ru_maxrss = r2.ru_maxrss;

	(void)(gettimeofday(&t1, (struct timezone *)0));

	r1.ru_utime.tv_sec += r2.ru_utime.tv_sec;
	r1.ru_utime.tv_usec += r2.ru_utime.tv_usec;
	r1.ru_stime.tv_sec += r2.ru_stime.tv_sec;
	r1.ru_stime.tv_usec += r2.ru_stime.tv_usec;

	t = (r1.ru_utime.tv_sec + r1.ru_stime.tv_sec)*100+
	    (r1.ru_utime.tv_usec + r1.ru_stime.tv_usec)/10000;

	ms = (t1.tv_sec-t0.tv_sec)*100 + (t1.tv_usec-t0.tv_usec)/10000;

	if (r1.ru_utime.tv_sec > 1000000)
		r1.ru_utime.tv_sec++, r1.ru_utime.tv_usec -= 1000000;

	if (r1.ru_stime.tv_sec > 1000000)
		r1.ru_stime.tv_sec++, r1.ru_stime.tv_usec -= 1000000;

	(void)(sprintf(buf, "%s:\t%d.%01du %d.%01ds ", argsav[0],
		r1.ru_utime.tv_sec, r1.ru_utime.tv_usec/100000,
		r1.ru_stime.tv_sec, r1.ru_stime.tv_usec/100000));

	if (i = (l = ms/100)/3600 && ms > 0) {
		(void)(sprintf(&buf[strlen(buf)], "%d:%02d",
			ms/360000, ((i = l % 3600)/60) % 100));
	} else
		(void)(sprintf(&buf[strlen(buf)], "%d", (i = l)/60));

	(void)(sprintf(&buf[strlen(buf)],
		":%02d %d%% %d+%dk %d+%dio %dpf+%dw %dss+%dm+%dr\n",
		(i % 60) % 100,
		(int) (t*100 / ((ms ? ms : 1))),
		t==0 ? 0 : (r1.ru_ixrss+r2.ru_ixrss)/t,
		t==0 ? 0 : (r1.ru_idrss+r1.ru_isrss+r2.ru_idrss+r2.ru_isrss)/t,
		r1.ru_inblock+r2.ru_inblock,
		r1.ru_oublock+r2.ru_oublock,
		r1.ru_majflt+r2.ru_majflt,
		r1.ru_nswap + r2.ru_nswap,
		t==0 ? 0 : (r1.ru_ixrss+r1.ru_isrss+r1.ru_idrss+
			r2.ru_ixrss+r2.ru_idrss+r2.ru_isrss)/t,
		r1.ru_maxrss/2,
		r1.ru_minflt+r2.ru_minflt));
#ifdef	MSTATS
	(void) fprintf(stderr, "%s\n%s:\t", buf, argsav[0]);
	mstats();
#else
	(void) write(2, buf, strlen(buf));
#endif
}
